/*
OuDiaSecond Copyright (C) 2017-2020 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDlgOperationProp.cpp : Cve[V t@C
//

#include "stdafx.h"

#include "str\CStrCharSizeMb.h"
#include "str\strLf.h"
#include "LogMsg\LogMsg.h"

#include "..\DiagramEdit.h"
#include "CDlgOperationProp.h"
#include "str\tstring.h"
#include "Str\strtoint.h"
#include "str\stringSplit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewJikokuhyou{

using namespace std ;


// ================================================================
//	CDlgOperationProp::CPropEditUiInternal
// ================================================================

tstring CDlgOperationProp::CPropEditUiInternal::CreateOperationString(
	Operation aOperation, 
	bool bIsAfterOperation)
{
	CDlgOperationProp* pOuter = (CDlgOperationProp*)((BYTE*)this - offsetof(CDlgOperationProp, m_PropEditUiInternal));

	/** _CAO{bNXւ̎̏ێ܂B */
	const CdDedJikoku::CConv	g_CdDedJikokuConv(
		false,		//	Colon 
		CdDedJikoku::CConv::EHour_ZeroToNone,		//	HourZeroToNone 
		CdDedJikoku::CConv::ESecond_Output);	//	Output

	tstring strRev = _T("");
	strRev += to_tstring(aOperation.iLevel[0]);
	for (int idxl = 1; idxl < (int)aOperation.iLevel.size(); idxl++)
	{
		strRev += _T(".");
		strRev += to_tstring(aOperation.iLevel[idxl]);
	}
	if (aOperation.iOperation == 0)//
	{
		strRev += _T("  ");
		const CentDedEki* pEki = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->
			getCentDedEkiCont()->getMuPtr()->get(pOuter->m_iEkiIndex);
		strRev += pEki->getEkiTrack2Cont()->get(aOperation.iComboData1).getTrackName().c_str();
		if (bIsAfterOperation)
		{
			strRev += _T(" ");
		}
		else
		{
			strRev += _T(" ");
		}
		CdDedJikoku aJikoku;
		int iRev = aJikoku.decode(aOperation.strEditData1);
		if (iRev >= 0)
		{
			if (aJikoku.isNull())
			{
				strRev += _T("--:--");
			}
			else
			{
				strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
			}
			strRev += _T("  ");
		}
		iRev = aJikoku.decode(aOperation.strEditData2);
		if (iRev >= 0)
		{
			if (aJikoku.isNull())
			{
				strRev += _T("--:--");
			}
			else
			{
				strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
			}
			strRev += _T("  ");
		}
	}
	else if (aOperation.iOperation == 1)//
	{
		strRev += _T("  ");
		CdDedJikoku aJikoku;
		int iRev = aJikoku.decode(aOperation.strEditData1);
		if (iRev >= 0)
		{
			if (aJikoku.isNull())
			{
				strRev += _T("--:--");
			}
			else
			{
				strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
			}
		}
		if (aOperation.iComboData1 == 0)
		{
			strRev += _T(" Ґɑ");
		}
		else
		{
			strRev += _T(" ҐOɑ");
		}

	}
	else if (aOperation.iOperation == 2)//
	{
		strRev += _T("  ");
		CdDedJikoku aJikoku;
		int iRev = aJikoku.decode(aOperation.strEditData2);
		if (iRev >= 0)
		{
			if (aJikoku.isNull())
			{
				strRev += _T("--:--");
			}
			else
			{
				strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
			}
		}
		if (aOperation.iComboData1 == 0)
		{
			strRev += _T("  ");
			strRev += aOperation.strEditData1.c_str();
			strRev += _T(" Ґ");
		}
		else if (aOperation.iComboData1 == 1)
		{
			strRev += _T(" O ");
			strRev += aOperation.strEditData1.c_str();
			strRev += _T(" Ґ");
		}
		else
		{
			strRev += _T(" O ");
			strRev += aOperation.strEditData1.c_str();
			strRev += _T(" ҐȊO");
		}
	}
	else if (aOperation.iOperation == 3)
	{
		if (bIsAfterOperation)//
		{
			strRev += _T("  ");
			CdDedJikoku aJikoku;
			int iRev = aJikoku.decode(aOperation.strEditData1);
			if (iRev >= 0)
			{
				if (aJikoku.isNull())
				{
					strRev += _T("--:--");
				}
				else
				{
					strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
				}
			}
		}
		else//o
		{
			strRev += _T(" o ");
			CdDedJikoku aJikoku;
			int iRev = aJikoku.decode(aOperation.strEditData1);
			if (iRev >= 0)
			{
				if (aJikoku.isNull())
				{
					strRev += _T("--:--");
				}
				else
				{
					strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
				}
			}
			strRev += _T(" ");
			if (aOperation.strOperationNumber.size() > 0)
			{
				strRev += joinc(';', aOperation.strOperationNumber);
			}
		}
	}
	else if (aOperation.iOperation == 4)
	{
		if (bIsAfterOperation)//HOI
		{
			strRev += _T(" HOI ");
			CdDedJikoku aJikoku;
			int iRev = aJikoku.decode(aOperation.strEditData1);
			if (iRev >= 0)
			{
				strRev += _T("w ");
				if (aJikoku.isNull())
				{
					strRev += _T("--:--");
				}
				else
				{
					strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
				}
				strRev += _T("  ");
			}
			iRev = aJikoku.decode(aOperation.strEditData2);
			if (iRev >= 0)
			{
				const CentDedEki* pEki = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->
					getCentDedEkiCont()->getMuPtr()->get(pOuter->m_iEkiIndex);
				strRev += pEki->getOuterTerminalEkimei(aOperation.iComboData1);
				strRev += _T("w ");
				if (aJikoku.isNull())
				{
					strRev += _T("--:--");
				}
				else
				{
					strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
				}
				strRev += _T(" ");
			}
		}
		else//HOn
		{
			strRev += _T(" HOn ");
			CdDedJikoku aJikoku;
			int iRev = aJikoku.decode(aOperation.strEditData1);
			if (iRev >= 0)
			{
				const CentDedEki* pEki = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->
					getCentDedEkiCont()->getMuPtr()->get(pOuter->m_iEkiIndex);
				strRev += pEki->getOuterTerminalEkimei(aOperation.iComboData1);
				strRev += _T("w ");
				if (aJikoku.isNull())
				{
					strRev += _T("--:--");
				}
				else
				{
					strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
				}
				strRev += _T("  ");
			}
			iRev = aJikoku.decode(aOperation.strEditData2);
			if (iRev >= 0)
			{
				strRev += _T("w ");
				if (aJikoku.isNull())
				{
					strRev += _T("--:--");
				}
				else
				{
					strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
				}
				strRev += _T(" ");
			}

			strRev += _T(" ");
			if (aOperation.strOperationNumber.size() > 0)
			{
				strRev += joinc(';', aOperation.strOperationNumber);
			}
		}
	}
	else if (aOperation.iOperation == 5)
	{
		if (bIsAfterOperation)//Ԑڑ
		{
			strRev += _T(" Ԑڑ ");
			CdDedJikoku aJikoku;
			int iRev = aJikoku.decode(aOperation.strEditData1);
			if (iRev >= 0)
			{
				if (aJikoku.isNull())
				{
					strRev += _T("--:--");
				}
				else
				{
					strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
				}
			}
		}
		else//OԐڑ
		{
			strRev += _T(" OԐڑ ");
			CdDedJikoku aJikoku;
			int iRev = aJikoku.decode(aOperation.strEditData1);
			if (iRev >= 0)
			{
				if (aJikoku.isNull())
				{
					strRev += _T("--:--");
				}
				else
				{
					strRev += g_CdDedJikokuConv.encode(aJikoku).c_str();
				}
			}
			strRev += _T(" ");
			if (aOperation.strOperationNumber.size() > 0)
			{
				strRev += joinc(';', aOperation.strOperationNumber);
			}
		}
	}
	else if (aOperation.iOperation == 6)
	{
		strRev += _T(" ^pԍύX ");
		if (aOperation.strOperationNumber.size() > 0)
		{
			strRev += joinc(';', aOperation.strOperationNumber);
		}
	}
	else if (aOperation.iOperation == 7)
	{
		strRev = _T("(Ƃǉ)");
	}
	return strRev;
}

void CDlgOperationProp::CPropEditUiInternal::UiDataToUi( const UIDATA* pUiData )
{
	CDlgOperationProp* pOuter = (CDlgOperationProp*)( (BYTE*)this - offsetof( CDlgOperationProp , m_PropEditUiInternal ) ) ;

	if (pUiData->iListSelected >= 0)
	{
		/**
			Ǝރ{^̗L
			(Ȏdl)nwOƂ̈ԏƁAIwƂ̈ԉA
				yё̑OƂ̈ԏƉƂ̈ԉ́AoEHOE(OԐڑ)̂ꂩ̂
				ȊO̍Ƃ́AEÊꂩɌ
			(ȈՂȎ)IĂƂoEHOÊꂩȂA̎OLA𖳌ɁA
				EÊꂩȂA̎OLA𖳌ɂB
		*/
		bool bIsAfterOperation = pUiData->bSelectedAfter;
		const Operation* pOprationSel;
		if (pUiData->bSelectedAfter)
		{
			pOprationSel = &pUiData->sOperationA[pUiData->iListSelected];

			if (pOprationSel->iLevel.size() > 1)
			{
				/**
					iLevel2vfȏ゠ꍇ́AqƂȂ̂ŁAOƂƂׂKv܂
				*/
				vector<int> iLevelSearch = pOprationSel->iLevel;
				iLevelSearch.pop_back();
				for (int idxp = 0; idxp < (int)pUiData->sOperationA.size(); idxp++)
				{
					if (pUiData->sOperationA[idxp].iLevel == iLevelSearch)
					{
						if (idxp > pUiData->iListSelected)
						{
							//idxp()ɂ遨O
							bIsAfterOperation = false;
						}
						break;
					}
				}
			}
		}
		else
		{
			pOprationSel = &pUiData->sOperationB[pUiData->iListSelected];

			if (pOprationSel->iLevel.size() > 1)
			{
				/**
					iLevel2vfȏ゠ꍇ́AqƂȂ̂ŁAOƂƂׂKv܂
				*/
				vector<int> iLevelSearch = pOprationSel->iLevel;
				iLevelSearch.pop_back();
				for (int idxp = 0; idxp < (int)pUiData->sOperationB.size(); idxp++)
				{
					if (pUiData->sOperationB[idxp].iLevel == iLevelSearch)
					{
						if (idxp < pUiData->iListSelected)
						{
							//idxp()Oɂ遨
							bIsAfterOperation = true;
						}
						break;
					}
				}
			}
		}

		CButton* pButton1 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType);
		CButton* pButton2 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType2);
		CButton* pButton3 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType3);
		CButton* pButton4 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType4);
		CButton* pButton5 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType5);
		CButton* pButton6 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType6);
		CButton* pButton7 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType7);
		if (bIsAfterOperation)
		{
			pButton4->SetWindowText(_T("(&K)"));
			pButton5->SetWindowText(_T("HOI(&O)"));
			pButton6->SetWindowText(_T("Ԑڑ(&E)"));
		}
		else
		{
			pButton4->SetWindowText(_T("o(&K)"));
			pButton5->SetWindowText(_T("HOn(&O)"));
			pButton6->SetWindowText(_T("OԐڑ(&E)"));
		}
		if (pOprationSel->iOperation <= 2 ||
			pOprationSel->iOperation == 6)//EEE^pԍύX
		{
			pButton1->EnableWindow(true);
			pButton2->EnableWindow(true);
			pButton3->EnableWindow(true);
			pButton4->EnableWindow(false);
			pButton5->EnableWindow(false);
			pButton6->EnableWindow(false);
			pButton7->EnableWindow(true);
		}
		else if (pOprationSel->iOperation >= 3 && pOprationSel->iOperation <= 5)
		{
			pButton1->EnableWindow(false);
			pButton2->EnableWindow(false);
			pButton3->EnableWindow(false);
			pButton4->EnableWindow(true);
			pButton5->EnableWindow(pOuter->m_bOuterHatsuChakuIsEnable);
			pButton6->EnableWindow(true);
			pButton7->EnableWindow(false);
		}
		else
		{
			pButton1->EnableWindow(false);
			pButton2->EnableWindow(false);
			pButton3->EnableWindow(false);
			pButton4->EnableWindow(false);
			pButton5->EnableWindow(false);
			pButton6->EnableWindow(false);
			pButton7->EnableWindow(false);
		}

		/**
			Ƃ̒ǉE폜{^̗Lݒ
			Iꏊ̍ƁAʒuɂāALȃ{^ς܂
			Eɒǉ
				Ƃ̓EHOIEԐڑł͖
			E}
				OƂ̏oEHOnEOԐڑł͖
			Eqƒǉ
				yщł̂ݗL
			E폜
				oEHOnIEԑOԐڑł͖
			E
				oEHOnIEԑOԐڑł͖
				̍ƂAoEHOnIEԑOԐڑȂ疳
				ł̍Ƃ̏ꍇB
			E
				oEHOnIEԑOԐڑł͖
				̍ƂAoEHOnIEԑOԐڑȂ疳
				ł̍Ƃ̏ꍇB
		*/
		CButton* pButtonAdd = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_OperationAdd);
		CButton* pButtonIns = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_OperationInsert);
		CButton* pButtonCAdd = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_ChildOperationAdd);
		CButton* pButtonCLR = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_OperationClear);
		CButton* pButtonUp = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_OperationUp);
		CButton* pButtonDown = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_OperationDown);
		if (pOprationSel->iOperation == 1 ||
			pOprationSel->iOperation == 2) 
		{
			pButtonAdd->EnableWindow(true);
			pButtonIns->EnableWindow(true);
			pButtonCAdd->EnableWindow(true);
			pButtonCLR->EnableWindow(true);
			if (pOprationSel->iOperation == 1)
			{
				pButtonCAdd->SetWindowTextW(_T("Ґ̍Ƃ}(&3)"));
			}
			else if (pOprationSel->iOperation == 2)
			{
				pButtonCAdd->SetWindowTextW(_T("Ґ̍Ƃǉ(&3)"));
			}
		}
		else if(pOprationSel->iOperation == 0 ||
			pOprationSel->iOperation == 6)
		{
			pButtonAdd->EnableWindow(true);
			pButtonIns->EnableWindow(true);
			pButtonCAdd->EnableWindow(false);
			pButtonCLR->EnableWindow(true);
		}
		else if (pOprationSel->iOperation == 7)
		{
			pButtonAdd->EnableWindow(true);
			pButtonIns->EnableWindow(false);
			pButtonCAdd->EnableWindow(false);
			pButtonCLR->EnableWindow(false);
		}
		else
		{
			if (bIsAfterOperation)
			{
				pButtonAdd->EnableWindow(false);
				pButtonIns->EnableWindow(true);
				pButtonCAdd->EnableWindow(false);
				pButtonCLR->EnableWindow(false);
			}
			else
			{
				pButtonAdd->EnableWindow(true);
				pButtonIns->EnableWindow(false);
				pButtonCAdd->EnableWindow(false);
				pButtonCLR->EnableWindow(false);
			}

		}
		if (pOprationSel->iOperation == 0 ||
			pOprationSel->iOperation == 1 ||
			pOprationSel->iOperation == 2 ||
			pOprationSel->iOperation == 6)
		{
			vector<Operation> contOperation;
			if (pUiData->bSelectedAfter)
			{
				contOperation = pUiData->sOperationA;
			}
			else
			{
				contOperation = pUiData->sOperationB;
			}
			vector<int> iLevelUpper = pOprationSel->iLevel;
			vector<int> iLevelLower = pOprationSel->iLevel;
			if (iLevelUpper.back() == 0)
			{
				pButtonUp->EnableWindow(false);
			}
			else
			{
				iLevelUpper.back()--;
				bool bFound = false;
				for (int idx = 0; idx < pUiData->iListSelected && !bFound; idx++)
				{
					if (contOperation[idx].iLevel == iLevelUpper &&
						(contOperation[idx].iOperation == 0 ||
						contOperation[idx].iOperation == 1 || 
						contOperation[idx].iOperation == 2 ||
						contOperation[idx].iOperation == 6))
					{
						bFound = true;
					}
				}
				if (bFound)
				{
					pButtonUp->EnableWindow(true);
				}
				else
				{
					pButtonUp->EnableWindow(false);
				}
			}
			iLevelLower.back()++;
			bool bFound = false;
			for (int idx = pUiData->iListSelected+1; idx < (int)contOperation.size() && !bFound; idx++)
			{
				if (contOperation[idx].iLevel == iLevelLower &&
					(contOperation[idx].iOperation == 0 ||
						contOperation[idx].iOperation == 1 ||
						contOperation[idx].iOperation == 2 ||
						contOperation[idx].iOperation == 6))
				{
					bFound = true;
				}
			}
			if (bFound)
			{
				pButtonDown->EnableWindow(true);
			}
			else
			{
				pButtonDown->EnableWindow(false);
			}
		}
		else
		{
			pButtonUp->EnableWindow(false);
			pButtonDown->EnableWindow(false);
		}

		/**
			ύX{^̗Lݒ
			Edit1:AAoAHOAOԐڑɗLAAnySec1̂ݗL
			Edit2:AAHOɗL
		*/
		CButton* pButton1_0 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_DecEdit1_1Min);
		CButton* pButton1_1 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_IncEdit1_1Min);
		CButton* pButton1_2 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_DecEdit1_5Min);
		CButton* pButton1_3 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_IncEdit1_5Min);
		CButton* pButton1_4 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_DecEdit1AnySec1);
		CButton* pButton1_5 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_IncEdit1AnySec1);
		CButton* pButton1_6 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_DecEdit1AnySec2);
		CButton* pButton1_7 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_IncEdit1AnySec2);
		CButton* pButton2_0 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_DecEdit2_1Min);
		CButton* pButton2_1 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_IncEdit2_1Min);
		CButton* pButton2_2 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_DecEdit2_5Min);
		CButton* pButton2_3 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_IncEdit2_5Min);
		CButton* pButton2_4 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_DecEdit2AnySec1);
		CButton* pButton2_5 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_IncEdit2AnySec1);
		CButton* pButton2_6 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_DecEdit2AnySec2);
		CButton* pButton2_7 = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_IncEdit2AnySec2);

		if (pOprationSel->iOperation == 0 ||
			pOprationSel->iOperation == 4)
		{
			pButton1_0->EnableWindow(true);
			pButton1_1->EnableWindow(true);
			pButton1_2->EnableWindow(true);
			pButton1_3->EnableWindow(true);
			pButton1_4->EnableWindow(true);
			pButton1_5->EnableWindow(true);
			pButton1_6->EnableWindow(true);
			pButton1_7->EnableWindow(true);
			pButton2_0->EnableWindow(true);
			pButton2_1->EnableWindow(true);
			pButton2_2->EnableWindow(true);
			pButton2_3->EnableWindow(true);
			pButton2_4->EnableWindow(true);
			pButton2_5->EnableWindow(true);
			pButton2_6->EnableWindow(true);
			pButton2_7->EnableWindow(true);
		}
		else if (pOprationSel->iOperation == 1 ||
			pOprationSel->iOperation == 3 ||
			pOprationSel->iOperation == 5)
		{
			pButton1_0->EnableWindow(true);
			pButton1_1->EnableWindow(true);
			pButton1_2->EnableWindow(true);
			pButton1_3->EnableWindow(true);
			pButton1_4->EnableWindow(true);
			pButton1_5->EnableWindow(true);
			pButton1_6->EnableWindow(true);
			pButton1_7->EnableWindow(true);
			pButton2_0->EnableWindow(false);
			pButton2_1->EnableWindow(false);
			pButton2_2->EnableWindow(false);
			pButton2_3->EnableWindow(false);
			pButton2_4->EnableWindow(false);
			pButton2_5->EnableWindow(false);
			pButton2_6->EnableWindow(false);
			pButton2_7->EnableWindow(false);
		}
		else if (pOprationSel->iOperation == 2)
		{
			pButton1_0->EnableWindow(false);
			pButton1_1->EnableWindow(false);
			pButton1_2->EnableWindow(false);
			pButton1_3->EnableWindow(false);
			pButton1_4->EnableWindow(true);
			pButton1_5->EnableWindow(true);
			pButton1_6->EnableWindow(false);
			pButton1_7->EnableWindow(false);
			pButton2_0->EnableWindow(true);
			pButton2_1->EnableWindow(true);
			pButton2_2->EnableWindow(true);
			pButton2_3->EnableWindow(true);
			pButton2_4->EnableWindow(true);
			pButton2_5->EnableWindow(true);
			pButton2_6->EnableWindow(true);
			pButton2_7->EnableWindow(true);
		}
		else
		{
			pButton1_0->EnableWindow(false);
			pButton1_1->EnableWindow(false);
			pButton1_2->EnableWindow(false);
			pButton1_3->EnableWindow(false);
			pButton1_4->EnableWindow(false);
			pButton1_5->EnableWindow(false);
			pButton1_6->EnableWindow(false);
			pButton1_7->EnableWindow(false);
			pButton2_0->EnableWindow(false);
			pButton2_1->EnableWindow(false);
			pButton2_2->EnableWindow(false);
			pButton2_3->EnableWindow(false);
			pButton2_4->EnableWindow(false);
			pButton2_5->EnableWindow(false);
			pButton2_6->EnableWindow(false);
			pButton2_7->EnableWindow(false);
		}
		// --------------------------------
		//	DDXpAUiControlւ̐ݒ
		// --------------------------------
		{
			//IDC_RADIO_Operation
			{
				pOuter->m_iRADIO_OperationType = pOprationSel->iOperation;
			}

			// --------------------------------
			pOuter->UpdateData(FALSE);
		}
		// --------------------------------
		//	DDXpȂAUiControlւ̐ݒ
		//	́ADDXɂlݒ̌
		//	sȂĂ͂Ȃ܂B
		// --------------------------------
		//IDC_COMBO_Data1
		{
			CComboBox* pComboBox0 = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_0);
			CComboBox* pComboBox1 = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_1);
			CComboBox* pComboBox2 = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_2);
			CComboBox* pComboBox4 = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_4);
			CStatic* pStatic = (CStatic*)pOuter->GetDlgItem(IDC_STATIC_Combo1);
			if (pOprationSel->iOperation == 0 )
			{
				pComboBox0->EnableWindow(true);
				pComboBox0->ShowWindow(SW_SHOW);
				pComboBox0->SetCurSel(pOprationSel->iComboData1);
				pStatic->SetWindowText(_T("Ԑ(&U):"));

				pComboBox1->EnableWindow(false);
				pComboBox1->ShowWindow(SW_HIDE);
				pComboBox2->EnableWindow(false);
				pComboBox2->ShowWindow(SW_HIDE);
				pComboBox4->EnableWindow(false);
				pComboBox4->ShowWindow(SW_HIDE);
			}
			else if (pOprationSel->iOperation == 1)
			{
				pComboBox1->EnableWindow(true);
				pComboBox1->ShowWindow(SW_SHOW);
				pComboBox1->SetCurSel(pOprationSel->iComboData1);
				pStatic->SetWindowText(_T("ʒu(&U):"));

				pComboBox0->EnableWindow(false);
				pComboBox0->ShowWindow(SW_HIDE);
				pComboBox2->EnableWindow(false);
				pComboBox2->ShowWindow(SW_HIDE);
				pComboBox4->EnableWindow(false);
				pComboBox4->ShowWindow(SW_HIDE);
			}
			else if (pOprationSel->iOperation == 2)
			{
				pComboBox2->EnableWindow(true);
				pComboBox2->ShowWindow(SW_SHOW);
				pComboBox2->SetCurSel(pOprationSel->iComboData1);
				pStatic->SetWindowText(_T("ʒu(&U):"));

				pComboBox0->EnableWindow(false);
				pComboBox0->ShowWindow(SW_HIDE);
				pComboBox1->EnableWindow(false);
				pComboBox1->ShowWindow(SW_HIDE);
				pComboBox4->EnableWindow(false);
				pComboBox4->ShowWindow(SW_HIDE);
			}
			else if (pOprationSel->iOperation == 4)
			{
				pComboBox4->EnableWindow(true);
				pComboBox4->ShowWindow(SW_SHOW);
				pComboBox4->SetCurSel(pOprationSel->iComboData1);

				if (bIsAfterOperation)
				{
					pStatic->SetWindowText(_T("HOIw(&U):"));
				}
				else
				{
					pStatic->SetWindowText(_T("HOnw(&U):"));
				}

				pComboBox0->EnableWindow(false);
				pComboBox0->ShowWindow(SW_HIDE);
				pComboBox1->EnableWindow(false);
				pComboBox1->ShowWindow(SW_HIDE);
				pComboBox2->EnableWindow(false);
				pComboBox2->ShowWindow(SW_HIDE);
			}
			else
			{
				pComboBox0->EnableWindow(false);
				pComboBox1->EnableWindow(false);
				pComboBox2->EnableWindow(false);
				pComboBox4->EnableWindow(false);
			}
		}
		//IDC_EDIT_Data1
		{
			CEdit* pControl = (CEdit*)(pOuter->GetDlgItem(IDC_EDIT_Data1));
			CStatic* pStatic = (CStatic*)pOuter->GetDlgItem(IDC_STATIC_Edit1);


			if (pOprationSel->iOperation == 0)
			{
				pControl->EnableWindow(true);
				pControl->SetWindowText(pOprationSel->strEditData1.c_str());
				pControl->SetSel(0, -1);
				pStatic->SetWindowText(_T("(&J):"));
			}
			else if (pOprationSel->iOperation == 1)
			{
				pControl->EnableWindow(true);
				pControl->SetWindowText(pOprationSel->strEditData1.c_str());
				pControl->SetSel(0, -1);
				pStatic->SetWindowText(_T("(&J):"));
			}
			else if (pOprationSel->iOperation == 2)
			{
				pControl->EnableWindow(true);
				pControl->SetWindowText(pOprationSel->strEditData1.c_str());
				pControl->SetSel(0, -1);
				pStatic->SetWindowText(_T("Ґ(&J):"));
			}
			else if (pOprationSel->iOperation == 3)
			{
				pControl->EnableWindow(true);
				pControl->SetWindowText(pOprationSel->strEditData1.c_str());
				pControl->SetSel(0, -1);
				if (bIsAfterOperation)
				{
					pStatic->SetWindowText(_T("掞(&J):"));
				}
				else
				{
					pStatic->SetWindowText(_T("o掞(&J):"));
				}
			}
			else if (pOprationSel->iOperation == 4)
			{
				pControl->EnableWindow(true);
				pControl->SetWindowText(pOprationSel->strEditData1.c_str());
				pControl->SetSel(0, -1);
				if (bIsAfterOperation)
				{
					pStatic->SetWindowText(_T("w(&J):"));
				}
				else
				{
					pStatic->SetWindowText(_T("nw(&J):"));
				}
			}
			else if (pOprationSel->iOperation == 5)
			{
				pControl->EnableWindow(true);
				pControl->SetWindowText(pOprationSel->strEditData1.c_str());
				pControl->SetSel(0, -1);
				if (bIsAfterOperation)
				{
					pStatic->SetWindowText(_T("I_(&J):"));
				}
				else
				{
					pStatic->SetWindowText(_T("N_(&J):"));
				}
			}
			else
			{
				pControl->EnableWindow(false);
				pControl->SetWindowText(CString());
				//pControl->SetSel(0, -1);
			}
		}
		//IDC_EDIT_Data2
		{
			CEdit* pControl = (CEdit*)(pOuter->GetDlgItem(IDC_EDIT_Data2));
			CStatic* pStatic = (CStatic*)pOuter->GetDlgItem(IDC_STATIC_Edit2);
			if (pOprationSel->iOperation == 0 )
			{
				pControl->EnableWindow(true);
				pControl->SetWindowText(pOprationSel->strEditData2.c_str());
				pControl->SetSel(0, -1);
				pStatic->SetWindowText(_T("(&I):"));
			}
			else if (pOprationSel->iOperation == 2 )
			{
				pControl->EnableWindow(true);
				pControl->SetWindowText(pOprationSel->strEditData2.c_str());
				pControl->SetSel(0, -1);
				pStatic->SetWindowText(_T("(&I):"));
			}
			else if (pOprationSel->iOperation == 4)
			{
				pControl->EnableWindow(true);
				pControl->SetWindowText(pOprationSel->strEditData2.c_str());
				pControl->SetSel(0, -1);
				if (bIsAfterOperation)
				{
					pStatic->SetWindowText(_T("Iw(&J):"));
				}
				else
				{
					pStatic->SetWindowText(_T("w(&J):"));
				}
			}
			else
			{
				pControl->EnableWindow(false);
				pControl->SetWindowText(CString());
			}
		}

		//IDC_EDIT_OperationNumbers
		{
			CEdit* pControl = (CEdit*)(pOuter->GetDlgItem(IDC_EDIT_OperationNumbers));
			CStatic* pStatic = (CStatic*)pOuter->GetDlgItem(IDC_STATIC_OperationNumber);
			if (((pOprationSel->iOperation == 3 || pOprationSel->iOperation == 4 ||
				pOprationSel->iOperation == 5) &&
				!bIsAfterOperation) ||
				pOprationSel->iOperation == 6)
			{
				tstring strTemp = _T("");
				strTemp = joinc(';', pOprationSel->strOperationNumber);
				pControl->EnableWindow(true);
				pControl->SetWindowText(strTemp.c_str());
				pControl->SetSel(0, -1);

				if (pOprationSel->iOperation == 5)
				{
					pStatic->SetWindowText(_T("^pԍ(&N):"));
				}
				else
				{
					pStatic->SetWindowText(_T("^pԍ(&N):"));
				}

			}
			else
			{
				pControl->EnableWindow(false);
				pControl->SetWindowText(CString());
			}
		}
		//IDC_CHECK_JikokuDisplay(\ȗݒǉ)
		{
			CButton* pControl = (CButton*)(pOuter->GetDlgItem(IDC_CHECK_JikokuDisplay));
			if (pOprationSel->iOperation == 0 && pOprationSel->iLevel.size() == 1)
			{
				pControl->EnableWindow(true);
				pControl->SetCheck(pOprationSel->bCheckData1 ? BST_CHECKED : BST_UNCHECKED);
				if (bIsAfterOperation)
				{
					pControl->SetWindowText(_T("𓖉wɂ(&M)"));
				}
				else
				{
					pControl->SetWindowText(_T("𓖉wɂ(&M)"));
				}
			}
			else if (pOprationSel->iOperation == 5)
			{
				pControl->EnableWindow(true);
				pControl->SetCheck(pOprationSel->bCheckData1 ? BST_CHECKED : BST_UNCHECKED);
				if (bIsAfterOperation)
				{
					pControl->SetWindowText(_T("ԂɂȂ(&M)"));
				}
				else
				{
					pControl->SetWindowText(_T("ԂɂȂ(&M)"));
				}
			}
			else
			{
				pControl->EnableWindow(false);
			}
		}
		////IDC_CHECK_SyubetsuChange
		//{
		//	CButton* pControl = (CButton*)(pOuter->GetDlgItem(IDC_CHECK_SyubetsuChange));
		//	if (pOprationSel->iOperation == 5 && pUiData->bSelectedAfter &&
		//		pOprationSel->iLevel.size() == 1)
		//	{
		//		pControl->EnableWindow(true);
		//		pControl->SetCheck(pOprationSel-> ? BST_CHECKED : BST_UNCHECKED);
		//	}
		//	else
		//	{
		//		pControl->EnableWindow(false);
		//	}
		//}
	}
	else
	{
		CButton* pButton1 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType);
		CButton* pButton2 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType2);
		CButton* pButton3 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType3);
		CButton* pButton4 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType4);
		CButton* pButton5 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType5);
		CButton* pButton6 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType6);
		CButton* pButton7 = (CButton*)pOuter->GetDlgItem(IDC_RADIO_OperationType7);
		pButton1->EnableWindow(false);
		pButton2->EnableWindow(false);
		pButton3->EnableWindow(false);
		pButton4->EnableWindow(false);
		pButton5->EnableWindow(false);
		pButton6->EnableWindow(false);
		pButton7->EnableWindow(false);

		CComboBox* pComboBox0 = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_0);
		CComboBox* pComboBox1 = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_1);
		CComboBox* pComboBox2 = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_2);
		CComboBox* pComboBox4 = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_4);
		pComboBox0->EnableWindow(false);
		pComboBox1->EnableWindow(false);
		pComboBox2->EnableWindow(false);
		pComboBox4->EnableWindow(false);

		CEdit* pControl1 = (CEdit*)(pOuter->GetDlgItem(IDC_EDIT_Data1));
		pControl1->EnableWindow(false);
		pControl1->SetWindowText(CString());

		CEdit* pControl2 = (CEdit*)(pOuter->GetDlgItem(IDC_EDIT_Data2));
		pControl2->EnableWindow(false);
		pControl2->SetWindowText(CString());

		CEdit* pControl3 = (CEdit*)(pOuter->GetDlgItem(IDC_EDIT_OperationNumbers));
		pControl3->EnableWindow(false);
		pControl3->SetWindowText(CString());

		CButton* pControl4 = (CButton*)(pOuter->GetDlgItem(IDC_CHECK_JikokuDisplay));
		pControl3->EnableWindow(false);

		CButton* pButtonAdd = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_OperationAdd);
		CButton* pButtonIns = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_OperationInsert);
		CButton* pButtonCAdd = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_ChildOperationAdd);
		CButton* pButtonCLR = (CButton*)pOuter->GetDlgItem(IDC_BUTTON_OperationClear);

		pButtonAdd->EnableWindow(false);
		pButtonIns->EnableWindow(false);
		pButtonCAdd->EnableWindow(false);
		pButtonCLR->EnableWindow(false);
	}
	{

		CListBox* pListBoxB = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationBefore);
		pListBoxB->ResetContent();
		for (int idxb = 0; idxb < (int)pUiData->sOperationB.size(); idxb++)
		{
			bool bIsAfterOperation = false;
			if (pUiData->sOperationB[idxb].iLevel.size() > 1)
			{
				/**
					iLevel2vfȏ゠ꍇ́AqƂȂ̂ŁAOƂƂׂKv܂
				*/
				vector<int> iLevelSearch = pUiData->sOperationB[idxb].iLevel;
				iLevelSearch.pop_back();
				for (int idxp = 0; idxp < (int)pUiData->sOperationB.size(); idxp++)
				{
					if (pUiData->sOperationB[idxp].iLevel == iLevelSearch)
					{
						if (idxp < idxb)
						{
							//idxp()Oɂ遨
							bIsAfterOperation = true;
						}
						break;
					}
				}
			}
			tstring strOperation = CreateOperationString(pUiData->sOperationB[idxb], bIsAfterOperation);
			pListBoxB->AddString(strOperation.c_str());
		}
		if (!pUiData->bSelectedAfter)
		{
			pListBoxB->SetCurSel(pUiData->iListSelected);
		}


		CListBox* pListBoxA = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationAfter);
		pListBoxA->ResetContent();
		for (int idxa = 0; idxa < (int)pUiData->sOperationA.size(); idxa++)
		{
			bool bIsAfterOperation = true;
			if (pUiData->sOperationA[idxa].iLevel.size() > 1)
			{
				/**
					iLevel2vfȏ゠ꍇ́AqƂȂ̂ŁAOƂƂׂKv܂
				*/
				vector<int> iLevelSearch = pUiData->sOperationA[idxa].iLevel;
				iLevelSearch.pop_back();
				for (int idxp = 0; idxp < (int)pUiData->sOperationA.size(); idxp++)
				{
					if (pUiData->sOperationA[idxp].iLevel == iLevelSearch)
					{
						if (idxp > idxa)
						{
							//idxp()ɂ遨O
							bIsAfterOperation = false;
						}
						break;
					}
				}
			}
			tstring strOperation = CreateOperationString(pUiData->sOperationA[idxa], bIsAfterOperation);
			pListBoxA->AddString(strOperation.c_str());
		}
		if (pUiData->bSelectedAfter)
		{
			pListBoxA->SetCurSel(pUiData->iListSelected);
		}

	}
	//IDC_CHECK_SyubetsuChange
	{
		CButton* pControl = (CButton*)( pOuter->GetDlgItem(IDC_CHECK_SyubetsuChange) ) ;
		if (pOuter->m_iHatsuEkiOrder < 0 && pUiData->sOperationA.back().iOperation == 5)
		{
			pControl->EnableWindow(true);
			pControl->SetCheck(pUiData->bSyubetsuChange ? BST_CHECKED : BST_UNCHECKED);
		}
		else
		{
			pControl->SetCheck(false);
			pControl->EnableWindow(false);
		}
	}
}


void  CDlgOperationProp::CPropEditUiInternal::UiDataFromUi( UIDATA* pUiData )
{
	int iRv = 0 ; 
	CDlgOperationProp* pOuter = (CDlgOperationProp*)( (BYTE*)this - offsetof( CDlgOperationProp , m_PropEditUiInternal ) ) ;

	if ( iRv >= 0 )
	{
		if ( !pOuter->UpdateData( TRUE ) )
		{
			iRv = -1 ;	//	̓G[
		}
	}

	/**
		iUiOperation0̎ȊÓA̓̓XLbv̂ŁA
		iUiOperation0łƉ肵Đi߂
	*/
	if ( iRv >= 0 )
	{
		if (pUiData->iListSelected >= 0)
		{
			Operation* pOprationSel;
			if (pUiData->bSelectedAfter)
			{
				pOprationSel = &pUiData->sOperationA[pUiData->iListSelected];
			}
			else
			{
				pOprationSel = &pUiData->sOperationB[pUiData->iListSelected];
			}

			//IDC_RADIO_Operation
			{
				pOprationSel->iOperation = pOuter->m_iRADIO_OperationType;
				if (pOprationSel->iOperation == -1)
				{
					pOprationSel->iOperation = 7;//(Ƃǉ)
				}
			}

			//IDC_COMBO_Data1
			if (pOprationSel->iOperation == 0 ) {
				CComboBox* pComboBox = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_0);
				int iSel = pComboBox->GetCurSel();
				if (iSel != CB_ERR)
				{
					pOprationSel->iComboData1 = iSel;
				}
			}
			else if ( pOprationSel->iOperation == 1) {
				CComboBox* pComboBox = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_1);
				int iSel = pComboBox->GetCurSel();
				if (iSel != CB_ERR)
				{
					pOprationSel->iComboData1 = iSel;
				}
			}
			else if (pOprationSel->iOperation == 2) {
				CComboBox* pComboBox = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_2);
				int iSel = pComboBox->GetCurSel();
				if (iSel != CB_ERR)
				{
					pOprationSel->iComboData1 = iSel;
				}
			}
			else if (pOprationSel->iOperation == 4) {
				CComboBox* pComboBox = (CComboBox*)pOuter->GetDlgItem(IDC_COMBO_Data1_4);
				int iSel = pComboBox->GetCurSel();
				if (iSel != CB_ERR)
				{
					pOprationSel->iComboData1 = iSel;
				}
			}

			//IDC_EDIT_Data1
			{
				CString strText;
				CEdit* pControl = (CEdit*)(pOuter->GetDlgItem(IDC_EDIT_Data1));
				pControl->GetWindowText(strText);
				pOprationSel->strEditData1 = (LPCTSTR)strText;
			}
			//IDC_EDIT_Data2
			if (pOprationSel->iOperation == 0 || pOprationSel->iOperation == 2 ||
				pOprationSel->iOperation == 4)
			{
				CString strText;
				CEdit* pControl = (CEdit*)(pOuter->GetDlgItem(IDC_EDIT_Data2));
				pControl->GetWindowText(strText);
				pOprationSel->strEditData2 = (LPCTSTR)strText;
			}
			//else
			//{
			//	pOprationSel->strEditData2.empty();
			//}
			//IDC_EDIT_OperationNumbers
			if ((pOprationSel->iOperation == 3 || pOprationSel->iOperation == 4 ||
				pOprationSel->iOperation == 5 || pOprationSel->iOperation == 6)/*&&
				!pUiData->bSelectedAfter*/)
			{
				CString strText;
				CEdit* pControl = (CEdit*)(pOuter->GetDlgItem(IDC_EDIT_OperationNumbers));
				pControl->GetWindowText(strText);
				vector<tstring>strTemp = splitc<vector<tstring>>(';', (LPCTSTR)strText,true);
				pOprationSel->strOperationNumber = strTemp;
			}
			//else
			//{
			//	pOprationSel->strOperationNumber.empty();
			//}

			//IDC_CHECK_JikokuDisplay
			if (pOprationSel->iOperation == 0 || pOprationSel->iOperation == 5)
			{
				CButton* pControl = (CButton*)(pOuter->GetDlgItem(IDC_CHECK_JikokuDisplay));
				pOprationSel->bCheckData1 = (pControl->GetCheck() == BST_CHECKED);
			}
		}

		//IDC_CHECK_SyubetsuChange
		if (pOuter->m_iHatsuEkiOrder < 0 && pUiData->sOperationA.back().iOperation == 5)
		{
			CButton* pControl = (CButton*)(pOuter->GetDlgItem(IDC_CHECK_SyubetsuChange));
			pUiData->bSyubetsuChange = (pControl->GetCheck() == BST_CHECKED);
		}
	}	
}

void CDlgOperationProp::CPropEditUiInternal::SetFocus(int iOffsetofUiDataMember)
{
	CDlgOperationProp* pOuter = (CDlgOperationProp*)((BYTE*)this - offsetof(CDlgOperationProp, m_PropEditUiInternal));
	CWnd* pControl = NULL;

	//IDC_RADIO_Operation
	{
		if (iOffsetofUiDataMember == offsetof(Operation, iOperation))
		{
			pControl = pOuter->GetDlgItem(IDC_RADIO_OperationType);
		}
	}
	//IDC_EDIT_Data1
	{
		if (iOffsetofUiDataMember == offsetof(Operation, strEditData1))
		{
			pControl = pOuter->GetDlgItem(IDC_EDIT_Data1);
		}
	}
	//IDC_EDIT_Data2
	{
		if (iOffsetofUiDataMember == offsetof(Operation, strEditData2))
		{
			pControl = pOuter->GetDlgItem(IDC_EDIT_Data2);
		}

	}
	//IDC_EDIT_OperationNumber
	{
		if (iOffsetofUiDataMember == offsetof(Operation, strOperationNumber))
		{
			pControl = pOuter->GetDlgItem(IDC_EDIT_OperationNumber);
		}

	}

	if ( pControl != NULL )
	{
		pOuter->GotoDlgCtrl( pControl ) ; 
	}
}
//void CDlgOperationProp::CPropEditUiInternal::SetFocus2(
//	int iOffsetofUiDataMember,
//	int iListSelect,
//	bool bSelectedAfter,
//	int iOperation)
//{
//	CDlgOperationProp* pOuter = (CDlgOperationProp*)( (BYTE*)this - offsetof( CDlgOperationProp , m_PropEditUiInternal ) ) ;
//	CWnd* pControl = NULL ;
//
//	//IDC_RADIO_Operation
//	{
//		if (iOffsetofUiDataMember == offsetof(Operation, iOperation))
//		{
//			if (bSelectedAfter)
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationAfter);
//				pListBox->SetCurSel(iListSelect);
//			}
//			else
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationBefore);
//				pListBox->SetCurSel(iListSelect);
//			}
//			pControl = pOuter->GetDlgItem(IDC_RADIO_Operation);
//		}
//	}
//	//IDC_COMBO_Data1_0
//	{
//		if ( iOffsetofUiDataMember == offsetof(Operation, iComboData1) )
//		{
//			if (bSelectedAfter)
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationAfter);
//				pListBox->SetCurSel(iListSelect);
//			}
//			else
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationBefore);
//				pListBox->SetCurSel(iListSelect);
//			}
//			if (iOperation == 0)
//			{
//				pControl = pOuter->GetDlgItem(IDC_COMBO_Data1_0);
//			}
//			else if (iOperation == 1)
//			{
//				pControl = pOuter->GetDlgItem(IDC_COMBO_Data1_1);
//			}
//			else if (iOperation == 2)
//			{
//				pControl = pOuter->GetDlgItem(IDC_COMBO_Data1_2);
//			}
//			else if (iOperation == 4)
//			{
//				pControl = pOuter->GetDlgItem(IDC_COMBO_Data1_4);
//			}
//		}
//	}
//	//IDC_EDIT_Data1
//	{
//		if ( iOffsetofUiDataMember == offsetof(Operation, strEditData1) )
//		{
//			if (bSelectedAfter)
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationAfter);
//				pOuter->GotoDlgCtrl(pListBox);
//				pListBox->SetCurSel(iListSelect);
//				pOuter->OnLbnSelchangeListOperationafter();
//
//			}
//			else
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationBefore);
//				pOuter->GotoDlgCtrl(pListBox);
//				pListBox->SetCurSel(iListSelect);
//				pOuter->OnLbnSelchangeListOperationbefore();
//			}
//			pControl = pOuter->GetDlgItem(IDC_EDIT_Data1)  ;
//		}
//	}
//	//IDC_EDIT_Data2
//	{
//		if ( iOffsetofUiDataMember == offsetof(Operation, strEditData2) )
//		{
//			if (bSelectedAfter)
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationAfter);;
//				pOuter->GotoDlgCtrl(pListBox);
//				pListBox->SetCurSel(iListSelect);
//				pOuter->OnLbnSelchangeListOperationafter();
//			}
//			else
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationBefore);
//				pOuter->GotoDlgCtrl(pListBox);
//				pListBox->SetCurSel(iListSelect);
//				pOuter->OnLbnSelchangeListOperationbefore();
//			}
//			pControl = pOuter->GetDlgItem(IDC_EDIT_Data2) ;
//		}
//
//	}
//	//IDC_CHECK_JikokuDisplay
//	{
//		if (iOffsetofUiDataMember == offsetof(Operation, bCheckData1))
//		{
//			if (bSelectedAfter)
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationAfter);
//				pListBox->SetCurSel(iListSelect);
//			}
//			else
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationBefore);
//				pListBox->SetCurSel(iListSelect);
//			}
//			pControl = pOuter->GetDlgItem(IDC_CHECK_JikokuDisplay);
//		}
//
//	}
//	//IDC_EDIT_OperationNumber
//	{
//		if (iOffsetofUiDataMember == offsetof(Operation, strOperationNumber))
//		{
//			if (bSelectedAfter)
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationAfter);
//				pOuter->GotoDlgCtrl(pListBox);
//				pListBox->SetCurSel(iListSelect);
//			}
//			else
//			{
//				CListBox* pListBox = (CListBox*)pOuter->GetDlgItem(IDC_LIST_OperationBefore);
//				pListBox->SetCurSel(iListSelect);
//			}
//			pControl = pOuter->GetDlgItem(IDC_EDIT_OperationNumber);
//		}
//
//	}
//	////IDC_CHECK_SyubetsuChange
//	//{
//	//	if (iOffsetofUiDataMember == offsetof(UIDATA, iOuterTerminalIndex))
//	//	{
//	//		pControl = pOuter->GetDlgItem(IDC_CHECK_SyubetsuChange);
//	//	}
//
//	//}
//	////IDC_LIST_OperationBefore
//	//{
//	//	if (iOffsetofUiDataMember == offsetof(UIDATA, strOuterHatsuChakuJikoku))
//	//	{
//	//		pControl = pOuter->GetDlgItem(IDC_LIST_OperationBefore);
//	//	}
//
//	//}
//	////IDC_LIST_OperationAfter
//	//{
//	//	if (iOffsetofUiDataMember == offsetof(UIDATA, strOuterHatsuChakuJikoku))
//	//	{
//	//		pControl = pOuter->GetDlgItem(IDC_LIST_OperationAfter);
//	//	}
//
//	//}
//	if ( pControl != NULL )
//	{
//		//pOuter->GotoDlgCtrl( pControl ) ; 
//	}
//}
		
void CDlgOperationProp::CPropEditUiInternal::ShowError(
			const tstring& strErrorReason ,
			const tstring& strInfo )  
{
	CDlgOperationProp* pOuter = (CDlgOperationProp*)( (BYTE*)this - offsetof( CDlgOperationProp , m_PropEditUiInternal ) ) ;
	CString strErrorMsg = strErrorReason.c_str() ;

	if ( strErrorReason == ERRMSG_INVALID_SHUNTHATSUJIKOKU)
	{
		pOuter->GetDlgItem( IDC_ERR_INVALID_SHUNTHATSUJIKOKU)->GetWindowText( strErrorMsg )  ;
	}
	else if ( strErrorReason == ERRMSG_INVALID_SHUNTCHAKUJIKOKU)
	{
		pOuter->GetDlgItem( IDC_ERR_INVALID_SHUNTCHAKUJIKOKU)->GetWindowText( strErrorMsg )  ;
	}
	//else if (strErrorReason == ERRMSG_OUTOFRANGE_SHUNTHATSUJIKOKU)
	//{
	//	//pOuter->GetDlgItem(IDC_ERROR_ShuntTrack)->GetWindowText(strErrorMsg);
	//}
	//else if (strErrorReason == ERRMSG_OUTOFRANGE_SHUNTCHAKUJIKOKU)
	//{
	//	//pOuter->GetDlgItem(IDC_ERROR_OperationHatsuJikokuFormat)->GetWindowText(strErrorMsg);
	//}
	else if (strErrorReason == ERRMSG_INVALID_CONNECTJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_CONNECTJIKOKU)->GetWindowText(strErrorMsg);
	}
	//else if (strErrorReason == ERRMSG_OUTOFRANGE_CONNECTJIKOKU)
	//{
	//	//pOuter->GetDlgItem(IDC_ERROR_OuterHatsuChakuJikokuFormat)->GetWindowText(strErrorMsg);
	//}
	else if (strErrorReason == ERRMSG_INVALID_RELEASEJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_RELEASEJIKOKU)->GetWindowText(strErrorMsg);
	}
	//else if (strErrorReason == ERRMSG_OUTOFRANGE_RELEASEJIKOKU)
	//{
	//	//pOuter->GetDlgItem(IDC_ERROR_ShuntTrack)->GetWindowText(strErrorMsg);
	//}
	else if (strErrorReason == ERRMSG_INVALID_RELEASEINDEX)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_RELEASEINDEX)->GetWindowText(strErrorMsg);
	}
	else if (strErrorReason == ERRMSG_OUTOFRANGE_RELEASEINDEX)
	{
		pOuter->GetDlgItem(IDC_ERR_OUTOFRANGE_RELEASEINDEX)->GetWindowText(strErrorMsg);
	}
	else if (strErrorReason == ERRMSG_INVALID_OUTJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_OUTJIKOKU)->GetWindowText(strErrorMsg);
	}
	//else if (strErrorReason == ERRMSG_OUTOFRANGE_OUTJIKOKU)
	//{
	//	//pOuter->GetDlgItem(IDC_ERROR_HatsujikokuFormat)->GetWindowText(strErrorMsg);
	//}
	else if (strErrorReason == ERRMSG_INVALID_INJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_INJIKOKU)->GetWindowText(strErrorMsg);
	}
	//else if (strErrorReason == ERRMSG_OUTOFRANGE_INJIKOKU)
	//{
	//	//pOuter->GetDlgItem(IDC_ERROR_OperationHatsuJikokuFormat)->GetWindowText(strErrorMsg);
	//}
	else if (strErrorReason == ERRMSG_INVALID_OUTERHATSUJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_OUTERHATSUJIKOKU)->GetWindowText(strErrorMsg);
	}
	else if (strErrorReason == ERRMSG_INVALID_CHAKUJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_CHAKUJIKOKU)->GetWindowText(strErrorMsg);
	}
	//else if (strErrorReason == ERRMSG_OUTOFRANGE_CHAKUJIKOKU)
	//{
	//	//pOuter->GetDlgItem(IDC_ERROR_OuterHatsuChakuJikokuFormat)->GetWindowText(strErrorMsg);
	//}
	else if (strErrorReason == ERRMSG_EMPTY_OUTERHATSUJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_EMPTY_OUTERHATSUJIKOKU)->GetWindowText(strErrorMsg);
	}
	else if (strErrorReason == ERRMSG_INVALID_HATSUJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_HATSUJIKOKU)->GetWindowText(strErrorMsg);
	}
	else if (strErrorReason == ERRMSG_INVALID_OUTERCHAKUJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_OUTERCHAKUJIKOKU)->GetWindowText(strErrorMsg);
	}
	//else if (strErrorReason == ERRMSG_OUTOFRANGE_HATSUJIKOKU)
	//{
	//	//pOuter->GetDlgItem(IDC_ERROR_OperationChakuJikokuFormat)->GetWindowText(strErrorMsg);
	//}
	else if (strErrorReason == ERRMSG_EMPTY_OUTERCHAKUJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_EMPTY_OUTERCHAKUJIKOKU)->GetWindowText(strErrorMsg);
	}
	else if (strErrorReason == ERRMSG_INVALID_ORIGINJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_ORIGINJIKOKU)->GetWindowText(strErrorMsg);
	}
	else if (strErrorReason == ERRMSG_INVALID_TERMINALJIKOKU)
	{
		pOuter->GetDlgItem(IDC_ERR_INVALID_TERMINALJIKOKU)->GetWindowText(strErrorMsg);
	}
	else if (strErrorReason == ERRMSG_UNUSABLE_COMMA)
	{
		pOuter->GetDlgItem(IDC_ERR_UNUSABLE_COMMA)->GetWindowText(strErrorMsg);
	}
	else if (strErrorReason == ERRMSG_EMPTY_OPERATIONNUMBER)
	{
		pOuter->GetDlgItem(IDC_ERR_EMPTY_OPERATIONNUMBER)->GetWindowText(strErrorMsg);
	}
	//strErrorMsg += _T("(");
	strErrorMsg += strInfo.c_str();
	//strErrorMsg += _T(")");
	pOuter->MessageBox( strErrorMsg , NULL , MB_OK | MB_ICONEXCLAMATION ) ;
}
		// ********************************
		//	RXgN^
		// ********************************
CDlgOperationProp::CPropEditUiInternal::CPropEditUiInternal(
			bool bNewItem , 
			Mu<CentDedRessya*>* pTarget , 
			int iChakuEkiOrder ,
			int iHatsuEkiOrder,
			bool bFocusAfter,
			int iFocusIndex,
			int iStandardShuntTrackIndex[],
			vector<vector<int>> iStandardOuterTerminalJikan )
	: CPropEditUI_Operation(
			bNewItem , pTarget , 
			iChakuEkiOrder,
			iHatsuEkiOrder,
			bFocusAfter,
			iFocusIndex,
			iStandardShuntTrackIndex,
			iStandardOuterTerminalJikan)
{
}


/////////////////////////////////////////////////////////////////////////////
// CDlgOperationProp _CAO


// ----------------------------------------------------------------
CDlgOperationProp::CDlgOperationProp(
		Mu<CentDedRessya*>* pMuRessya ,
		int iChakuEkiOrder ,
		int iHatsuEkiOrder,
		int iFocusItem ,
		bool bFocusAfter,
		int iFocusIndex,
		bool bOuterHatsuChakuIsEnable,
		int iStandardShuntTrackIndex[],
		vector<vector<int>> iStandardOuterTerminalJikan,
		CKeyinputSenderToModalDlg*	pCKeyinputSenderToModalDlg ,
		CWnd* pParent  ) 
	: CDialog(CDlgOperationProp::IDD, pParent)
	, m_PropEditUiInternal( false , pMuRessya ,
		iChakuEkiOrder, iHatsuEkiOrder , bFocusAfter, iFocusIndex,
		iStandardShuntTrackIndex, iStandardOuterTerminalJikan)
	, m_iFocusItem( iFocusItem )
	, m_bFocusAfter(bFocusAfter)
	, m_iFocusIndex(iFocusIndex)
	, m_pCKeyinputSenderToModalDlg( pCKeyinputSenderToModalDlg )
	, m_iChakuEkiOrder(iChakuEkiOrder)
	, m_iHatsuEkiOrder(iHatsuEkiOrder)
	, m_bOuterHatsuChakuIsEnable(bOuterHatsuChakuIsEnable)
{
	//{{AFX_DATA_INIT(CDlgOperationProp)
	m_iRADIO_OperationType = -1;
	if (m_iChakuEkiOrder < 0)
	{
		m_iEkiIndex = pMuRessya->get(0)->EkiIndexOfEkiOrder(iHatsuEkiOrder);
	}
	else
	{
		m_iEkiIndex = pMuRessya->get(0)->EkiIndexOfEkiOrder(iChakuEkiOrder);
	}

	//ԔԐ
	{
		if (m_iChakuEkiOrder >= 0)
		{
			m_ChakuJikoku = pMuRessya->get(0)->getCentDedEkiJikoku(m_iChakuEkiOrder).getChakujikoku(true);
		}

		if (m_iHatsuEkiOrder >= 0)
		{
			m_HatsuJikoku = pMuRessya->get(0)->getCentDedEkiJikoku(m_iHatsuEkiOrder).getHatsujikoku(true);
		}

		if (m_iChakuEkiOrder < 0)
		{
			m_iRessyaTrackIndex = pMuRessya->get(0)->getCentDedEkiJikoku(m_iHatsuEkiOrder).getRessyaTrackIndex();
		}
		else
		{
			m_iRessyaTrackIndex = pMuRessya->get(0)->getCentDedEkiJikoku(m_iChakuEkiOrder).getRessyaTrackIndex();
		}
	}
	//}}AFX_DATA_INIT
}


void CDlgOperationProp::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOperationProp)
	DDX_Radio(pDX, IDC_RADIO_OperationType, m_iRADIO_OperationType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgOperationProp, CDialog)
	//{{AFX_MSG_MAP(CDlgOperationProp)
	ON_WM_SHOWWINDOW()

	ON_BN_CLICKED(IDC_RADIO_OperationType, OnRADIOOperationType)
	ON_BN_CLICKED(IDC_RADIO_OperationType2, OnRADIOOperationType2)
	ON_BN_CLICKED(IDC_RADIO_OperationType3, OnRADIOOperationType3)
	ON_BN_CLICKED(IDC_RADIO_OperationType4, OnRADIOOperationType4)
	ON_BN_CLICKED(IDC_RADIO_OperationType5, OnRADIOOperationType5)
	ON_BN_CLICKED(IDC_RADIO_OperationType6, OnRADIOOperationType6)
	ON_BN_CLICKED(IDC_RADIO_OperationType7, OnRADIOOperationType7)
	ON_CBN_SELCHANGE(IDC_COMBO_Data1_0, &CDlgOperationProp::OnCbnSelchangeComboData1_0)
	ON_CBN_SELCHANGE(IDC_COMBO_Data1_1, &CDlgOperationProp::OnCbnSelchangeComboData1_1)
	ON_CBN_SELCHANGE(IDC_COMBO_Data1_2, &CDlgOperationProp::OnCbnSelchangeComboData1_2)
	ON_CBN_SELCHANGE(IDC_COMBO_Data1_4, &CDlgOperationProp::OnCbnSelchangeComboData1_4)
	ON_EN_KILLFOCUS(IDC_EDIT_Data1, &CDlgOperationProp::OnEnKillfocusEditData1)
	ON_EN_KILLFOCUS(IDC_EDIT_Data2, &CDlgOperationProp::OnEnKillfocusEditData2)
	ON_BN_CLICKED(IDC_CHECK_JikokuDisplay, &CDlgOperationProp::OnBnClickedCheckJikokudisplay)
	ON_EN_KILLFOCUS(IDC_EDIT_OperationNumbers, OnKillfocusEDITOperationNumber)

	ON_BN_CLICKED(IDC_CHECK_SyubetsuChange, &CDlgOperationProp::OnBnClickedCheckSyubetsuchange)
	ON_LBN_SELCHANGE(IDC_LIST_OperationBefore, &CDlgOperationProp::OnLbnSelchangeListOperationbefore)
	ON_LBN_SELCHANGE(IDC_LIST_OperationAfter, &CDlgOperationProp::OnLbnSelchangeListOperationafter)
	ON_BN_CLICKED(IDC_BUTTON_OperationAdd, &CDlgOperationProp::OnBnClickedButtonOperationadd)
	ON_BN_CLICKED(IDC_BUTTON_OperationInsert, &CDlgOperationProp::OnBnClickedButtonOperationinsert)
	ON_BN_CLICKED(IDC_BUTTON_ChildOperationAdd, &CDlgOperationProp::OnBnClickedButtonChildoperationadd)
	ON_BN_CLICKED(IDC_BUTTON_OperationClear, &CDlgOperationProp::OnBnClickedButtonOperationclear)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_OperationUp, &CDlgOperationProp::OnBnClickedButtonOperationup)
	ON_BN_CLICKED(IDC_BUTTON_OperationDown, &CDlgOperationProp::OnBnClickedButtonOperationdown)
	ON_BN_CLICKED(IDC_BUTTON_DecEdit1_1Min, &CDlgOperationProp::OnBnClickedButtonDecEdit1_1min)
	ON_BN_CLICKED(IDC_BUTTON_IncEdit1_1Min, &CDlgOperationProp::OnBnClickedButtonIncEdit1_1min)
	ON_BN_CLICKED(IDC_BUTTON_DecEdit1_5Min, &CDlgOperationProp::OnBnClickedButtonDecEdit1_5min)
	ON_BN_CLICKED(IDC_BUTTON_IncEdit1_5Min, &CDlgOperationProp::OnBnClickedButtonIncEdit1_5min)
	ON_BN_CLICKED(IDC_BUTTON_DecEdit1AnySec1, &CDlgOperationProp::OnBnClickedButtonDecEdit1anysec1)
	ON_BN_CLICKED(IDC_BUTTON_IncEdit1AnySec1, &CDlgOperationProp::OnBnClickedButtonIncEdit1anysec1)
	ON_BN_CLICKED(IDC_BUTTON_DecEdit1AnySec2, &CDlgOperationProp::OnBnClickedButtonDecEdit1anysec2)
	ON_BN_CLICKED(IDC_BUTTON_IncEdit1AnySec2, &CDlgOperationProp::OnBnClickedButtonIncEdit1anysec2)
	ON_BN_CLICKED(IDC_BUTTON_DecEdit2_1Min, &CDlgOperationProp::OnBnClickedButtonDecEdit2_1min)
	ON_BN_CLICKED(IDC_BUTTON_IncEdit2_1Min, &CDlgOperationProp::OnBnClickedButtonIncEdit2_1min)
	ON_BN_CLICKED(IDC_BUTTON_DecEdit2_5Min, &CDlgOperationProp::OnBnClickedButtonDecEdit2_5min)
	ON_BN_CLICKED(IDC_BUTTON_IncEdit2_5Min, &CDlgOperationProp::OnBnClickedButtonIncEdit2_5min)
	ON_BN_CLICKED(IDC_BUTTON_DecEdit2AnySec1, &CDlgOperationProp::OnBnClickedButtonDecEdit2anysec1)
	ON_BN_CLICKED(IDC_BUTTON_IncEdit2AnySec1, &CDlgOperationProp::OnBnClickedButtonIncEdit2anysec1)
	ON_BN_CLICKED(IDC_BUTTON_DecEdit2AnySec2, &CDlgOperationProp::OnBnClickedButtonDecEdit2anysec2)
	ON_BN_CLICKED(IDC_BUTTON_IncEdit2AnySec2, &CDlgOperationProp::OnBnClickedButtonIncEdit2anysec2)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOperationProp bZ[W nh

BOOL CDlgOperationProp::OnInitDialog() 
{
	LogMsg(_T("CDlgOperationProp::OnInitDialog()") ) ;

	CDialog::OnInitDialog();
	LogMsg(_T("CDlgOperationProp::OnInitDialog()1 ") ) ;


	//ԔԐ
	{
		CStatic* pStaticTrack = (CStatic*)GetDlgItem(IDC_STATIC_RessyaTrack);
		CStatic* pStaticChaku = (CStatic*)GetDlgItem(IDC_STATIC_ChakuJikoku);
		CStatic* pStaticHatsu = (CStatic*)GetDlgItem(IDC_STATIC_HatsuJikoku);

		/** _CAO{bNXւ̎̏ێ܂B */
		const CdDedJikoku::CConv	g_CdDedJikokuConv(
			false,		//	Colon 
			CdDedJikoku::CConv::EHour_ZeroToNone,		//	HourZeroToNone 
			CdDedJikoku::CConv::ESecond_Output);	//	Output

		if (m_ChakuJikoku.isNull())
		{
			pStaticChaku->SetWindowText(_T("wn"));
		}
		else
		{
			pStaticChaku->SetWindowText(
				g_CdDedJikokuConv.encode(m_ChakuJikoku).c_str());
		}

		if (m_HatsuJikoku.isNull())
		{
			pStaticHatsu->SetWindowText(_T("w~܂"));
		}
		else
		{
			pStaticHatsu->SetWindowText(
				g_CdDedJikokuConv.encode(m_HatsuJikoku).c_str());
		}
		const CentDedRosen* pCentDedRosen = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
		const CentDedEki* pCentDedEki = pCentDedRosen->getCentDedEkiCont()->getMuPtr()->get(m_iEkiIndex);
		pStaticTrack->SetWindowText(pCentDedEki->getEkiTrack2Cont()->get(m_iRessyaTrackIndex).getTrackName().c_str());
	}

	//IDC_COMBO_Data1_0 (Ԑ)
	{
		const CentDedRosen* pCentDedRosen = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
		const Mu<const CentDedEkiTrack2*>* pMuCentDedEkiTrack2 =
			pCentDedRosen->getCentDedEkiCont()->getMuPtr()->get(m_iEkiIndex)->getEkiTrack2Cont()->getMuPtr();

		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_COMBO_Data1_0);

		for (int idxEkiTrack2 = 0;
			idxEkiTrack2 < pMuCentDedEkiTrack2->size();
			idxEkiTrack2++)
		{
			const CentDedEkiTrack2* pCentDedEkiTrack2 =
				pMuCentDedEkiTrack2->get(idxEkiTrack2);

			tstring	strTrackName = pCentDedEkiTrack2->getTrackName();
			strTrackName = stringOf(idxEkiTrack2)
				+ _T(". ")
				+ strTrackName;

			pCComboBox->AddString(strTrackName.c_str());
		}
	}

	//IDC_COMBO_Data1_1(ʒu)
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_COMBO_Data1_1);

		tstring strTemp1 = _T("Ґɑ");
		pCComboBox->AddString(strTemp1.c_str());
		tstring strTemp2 = _T("ҐOɑ");
		pCComboBox->AddString(strTemp2.c_str());
	}

	//IDC_COMBO_Data1_2(ʒu)
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_COMBO_Data1_2);

		tstring strTemp1 = _T("Ґ(w)");
		pCComboBox->AddString(strTemp1.c_str());
		tstring strTemp2 = _T("OҐ");
		pCComboBox->AddString(strTemp2.c_str());
		tstring strTemp3 = _T("Ґ(Ow)");
		pCComboBox->AddString(strTemp3.c_str());
	}

	//IDC_COMBO_Data1_4(HOnw)
	{
		const CentDedRosen* pCentDedRosen = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
		CentDedEki aCentDedEki = pCentDedRosen->getCentDedEkiCont()->get(m_iEkiIndex);

		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_COMBO_Data1_4);

		for (int idx = 0;
			idx < aCentDedEki.getOuterTerminalEkimeiCount();
			idx++)
		{
			pCComboBox->AddString(aCentDedEki.getOuterTerminalEkimei(idx).c_str());
		}
	}
	{
		LOGFONT lf;
		this->GetFont()->GetLogFont(&lf);
		//int a = lf.lfHeight;
		lf.lfHeight = 100;
		CFont font;
		font.CreatePointFontIndirect(&lf);
		CStatic* pStatic = (CStatic*)GetDlgItem(IDC_STATIC_ChakuJikoku);
		CStatic* pStatic2 = (CStatic*)GetDlgItem(IDC_STATIC_ChakuJikokuCaption);
		CStatic* pStatic3 = (CStatic*)GetDlgItem(IDC_STATIC_HatsuJikoku);
		CStatic* pStatic4 = (CStatic*)GetDlgItem(IDC_STATIC_HatsuJikokuCaption);
		CStatic* pStatic5 = (CStatic*)GetDlgItem(IDC_STATIC_RessyaTrackCaption);
		CStatic* pStatic6 = (CStatic*)GetDlgItem(IDC_STATIC_RessyaTrack);
		CStatic* pStatic7 = (CStatic*)GetDlgItem(IDC_STATIC_OperationBefore);
		CStatic* pStatic8 = (CStatic*)GetDlgItem(IDC_STATIC_OperationAfter);
		pStatic->SetFont(&font);
		pStatic2->SetFont(&font);
		pStatic3->SetFont(&font);
		pStatic4->SetFont(&font);
		pStatic5->SetFont(&font);
		pStatic6->SetFont(&font);
		pStatic7->SetFont(&font);
		pStatic8->SetFont(&font);
		font.Detach();
	}
	{
		int iAnySec1 = abs(getCDiagramEditDoc()->getCDedRosenFileData()
			->getCdDedDispProp().getAnySecondIncDec1());
		int iAnySec2 = abs(getCDiagramEditDoc()->getCDedRosenFileData()
			->getCdDedDispProp().getAnySecondIncDec2());

		m_AnySec1 = min(iAnySec1, iAnySec2);
		m_AnySec2 = max(iAnySec1, iAnySec2);

		CStatic* pStaticAnySec1 = (CStatic*)GetDlgItem(IDC_STATIC_AnySec1);
		CStatic* pStaticAnySec2 = (CStatic*)GetDlgItem(IDC_STATIC_AnySec2);

		tstring strAnySec1 = to_tstring(m_AnySec1) + _T("b");
		pStaticAnySec1->SetWindowText(strAnySec1.c_str());
		tstring strAnySec2 = to_tstring(m_AnySec2) + _T("b");
		pStaticAnySec2->SetWindowText(strAnySec2.c_str());

	}
	m_PropEditUiInternal.StartEdit() ;

	LogMsg(_T("CDlgOperationProp::OnInitDialog()= ") ) ;
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgOperationProp::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	LogMsg(_T("CDlgOperationProp::OnShowWindow() ") ) ;
	CDialog::OnShowWindow(bShow, nStatus);
	LogMsg(_T("_T(CDlgOperationProp::OnShowWindow()1 ") ) ;
	
	if ( bShow ){
		CWnd* pControl = NULL ;
		switch( m_iFocusItem ){
		 case 0	:	//	w
			pControl = GetDlgItem(IDC_RADIO_OperationType) ;
			break ;
		 case 1	:	//	R{1 Ԑ
			pControl = GetDlgItem(IDC_COMBO_Data1_0) ;
			break ;
		 case 2	:	//	GfBbg1
			pControl = GetDlgItem( IDC_EDIT_Data1 ) ;
			break ;
		 case 3:	//	GfBbg2
			 pControl = GetDlgItem(IDC_EDIT_Data2);
			 break;
		 case 4:	//	^pԍ
			 pControl = GetDlgItem(IDC_EDIT_OperationNumbers);
			 break;
		 case 5:	//	`FbN1
			 pControl = GetDlgItem(IDC_CHECK_JikokuDisplay);
			 break;
		 case 6:	//	ʕύX
			 pControl = GetDlgItem(IDC_CHECK_SyubetsuChange);
			 break;
		 case 7:	//	R{1 ʒu
			 pControl = GetDlgItem(IDC_COMBO_Data1_1);
			 break;
		 case 8:	//	R{1 ʒu
			 pControl = GetDlgItem(IDC_COMBO_Data1_2);
			 break;
		 case 9:	//	R{1 HOw
			 pControl = GetDlgItem(IDC_COMBO_Data1_4);
			 break;
		}
		if ( pControl != NULL ){
			GotoDlgCtrl( pControl ) ;
			if ( m_pCKeyinputSenderToModalDlg != NULL ){
				m_pCKeyinputSenderToModalDlg->registerCtrl( 
					pControl->GetSafeHwnd() ) ;
			}
		}
	}
	LogMsg(_T("CDlgOperationProp::OnShowWindow()= ") ) ;
	
	
}

void CDlgOperationProp::OnOK() 
{
	int iRv = 0 ;

	int iResult = m_PropEditUiInternal.EndEdit() ;
	if ( iResult >= 0 )
	{
		CDialog::OnOK();
	}
}


void CDlgOperationProp::OnRADIOOperationType()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}

void CDlgOperationProp::OnRADIOOperationType2()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}

void CDlgOperationProp::OnRADIOOperationType3()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}

void CDlgOperationProp::OnRADIOOperationType4()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}

void CDlgOperationProp::OnRADIOOperationType5()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}

void CDlgOperationProp::OnRADIOOperationType6()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}

void CDlgOperationProp::OnRADIOOperationType7()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}

void CDlgOperationProp::OnKillfocusEDITOperationNumber()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}

//void CDlgOperationProp::OnCbnSelchangeComboOuterTerminalIndex()
//{
//	m_PropEditUiInternal.OnUiChanged();
//}
//
//void CDlgOperationProp::OnKillfocusEDITOuterHatsuChakuJikoku()
//{
//	m_PropEditUiInternal.OnUiChanged();
//}


void ViewJikokuhyou::CDlgOperationProp::OnCbnSelchangeComboData1_0()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}
void ViewJikokuhyou::CDlgOperationProp::OnCbnSelchangeComboData1_1()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}
void ViewJikokuhyou::CDlgOperationProp::OnCbnSelchangeComboData1_2()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}
void ViewJikokuhyou::CDlgOperationProp::OnCbnSelchangeComboData1_4()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnEnKillfocusEditData1()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnEnKillfocusEditData2()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnBnClickedCheckJikokudisplay()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnBnClickedCheckSyubetsuchange()
{
	m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
	m_PropEditUiInternal.OnUiChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnLbnSelchangeListOperationbefore()
{

	m_PropEditUiInternal.GetUiData()->bSelectedAfter = false;
	CListBox* pListBox = (CListBox*)GetDlgItem(IDC_LIST_OperationBefore);
	m_PropEditUiInternal.GetUiData()->iListSelected = pListBox->GetCurSel();
	m_PropEditUiInternal.GetUiData()->iUiOperation = 1;
	m_PropEditUiInternal.OnUiDataChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnLbnSelchangeListOperationafter()
{
	m_PropEditUiInternal.GetUiData()->bSelectedAfter = true;
	CListBox* pListBox = (CListBox*)GetDlgItem(IDC_LIST_OperationAfter);
	m_PropEditUiInternal.GetUiData()->iListSelected = pListBox->GetCurSel();
	m_PropEditUiInternal.GetUiData()->iUiOperation = 1;
	m_PropEditUiInternal.OnUiDataChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnBnClickedButtonOperationadd()
{
	//UiDataɊOANZXAڍƂǉ܂B
	//̌iLevel̕␳s܂B
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		/**
			ǉꂽƂiLevelłB傫iLevel̂́AÂlJ艺܂
			J艺
			(0)iAddPositionɂ
			(1)iLevel̗vfAiAddiLevelȏ̕
				̒l1,1,1̏ꍇ0E1E1,0ȂiLevel̗vfȂ̂͑ΏۊO
			(2)iLevel̒l̂AiAddiLevel̖vfȊO̒lv
				̒l1,1,1̏ꍇ1,2,0E2,1,1ȂǁAO̒lقȂ̂͏O
			(3)iAddiLevel̖vfƓʒu̒lAiAddiLevel̖vf̒lȏ̂
				̒l1,1,1̏ꍇ1,1,0E1,1,0,1Ȃǂ͏O
		*/
		vector<int> iAddiLevel;

		//ƂǉAsOperation̈ʒułAiLevel␳čsȂ߂ɂp܂B
		int iAddPosition = 0;

		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}


		//ۂɒǉʒuƂiLevel߂܂
		//uƂǉvʒuIĂꍇ́AV()ɒu܂B
		if (sOperation[iListSelected].iOperation == 7)
		{
			sOperation.clear();
			sOperation.push_back(Operation());
			sOperation.front().iLevel = { 0 };
		}
		else 
		{
			if (sOperation[iListSelected].iOperation == 2)
			{
				iAddiLevel = sOperation[iListSelected].iLevel;
				/**
					Ƃ̉ɒǉꍇ́AƂ̌ƌQщzɒǉsB
					ǉꏊ
					(1)iLeveĺAiAddiLevel̖ڂ̒lAiAddiLevel̓Y̒lƈقȂ(傫)
						̏ꍇ́AƂ̈̍(̍ƂȂȂOƂ̍ŏ)̏ꏊ
					(2)iLevel̗vfAiAddiLevelȂ
						̏ꍇ́AƂAeƂȂ鑝Ƃ1Ԗڂ̎qƂɓꍇA
					(3)idx=sOperation.size()-1܂ŒTĂȂꍇ͍Ō(idx=sOperation,size())
						̏ꍇ́AŌ̍Ƃ
				*/
				iAddPosition = sOperation.size();//(3)̏ꍇpA(1)(2)Yꍇ͂ŏ㏑̂ŖȂ
				for (int idx = iListSelected + 1; idx < (int)sOperation.size(); idx++)
				{
					int iAddiLevelLastPos = iAddiLevel.size() - 1;
					if (sOperation[idx].iLevel.size() < iAddiLevel.size())
					{
						iAddPosition = idx;
						break;
					}
					else if (sOperation[idx].iLevel[iAddiLevelLastPos] != iAddiLevel[iAddiLevelLastPos])
					{
						iAddPosition = idx;
						break;
					}
				}
				iAddiLevel.back()++;//iAddLevelLTŗp̂ŁAŉZs
					//(ɉZŁAςĂ悢AinsertƔ莮킹邽)
			}
			else
			{
				iAddiLevel = sOperation[iListSelected].iLevel;
				iAddiLevel.back()++;
				iAddPosition = iListSelected + 1;
			}

			sOperation.insert(sOperation.begin() + iAddPosition, Operation());
			sOperation[iAddPosition].iLevel = iAddiLevel;

			//ڂiLevel̕␳
			for (int idx = iAddPosition + 1; idx < (int)sOperation.size(); idx++)
			{
				//܂AǉꂽvfgƁAǉꂽvfe̗vfO
				if (/*idx != iAddPosition &&*/
					sOperation[idx].iLevel.size() >= iAddiLevel.size())
				{
					//ǉꂽvfƁAeƂꂩۂ`FbN
					bool bMatch = true;
					//iAddiLevel.size()1̏ꍇ́AforɓȂȂBOɒlAƂӖňv
					for (int idxl = 0; idxl < (int)iAddiLevel.size() - 1; idxl++)
					{
						if (sOperation[idx].iLevel[idxl] != iAddiLevel[idxl])
						{
							bMatch = false;
							break;
						}
					}
					if (bMatch &&
						sOperation[idx].iLevel[iAddiLevel.size() - 1] >= iAddiLevel.back())
					{
						sOperation[idx].iLevel[iAddiLevel.size() - 1]++;
					}
				}
			}
		}
		if (bSelectedAfter)
		{
			m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
		}
		else
		{
			m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
		}
		m_PropEditUiInternal.GetUiData()->iUiOperation = 2;
		m_PropEditUiInternal.GetUiData()->iListSelected = iAddPosition;
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

//void AdjustiLevel

void ViewJikokuhyou::CDlgOperationProp::OnBnClickedButtonOperationinsert()
{
	//UiDataɊOANZXAڍƂ}܂B
	//̌iLevel̕␳s܂B
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if ( iListSelected >= 0)
	{
		/**
			ǉꂽƂiLevelłB傫iLevel̂́AÂlJ艺܂
			J艺
			(0)iAddPositionɂ
			(1)iLevel̗vfAiAddiLevelȏ̕
				̒l1,1,1̏ꍇ0E1E1,0ȂiLevel̗vfȂ̂͑ΏۊO
			(2)iLevel̒l̂AiAddiLevel̖vfȊO̒lv
				̒l1,1,1̏ꍇ1,2,0E2,1,1ȂǁAO̒lقȂ̂͏O
			(3)iAddiLevel̖vfƓʒu̒lAiAddiLevel̖vf̒lȏ̂
				̒l1,1,1̏ꍇ1,1,0E1,1,0,1Ȃǂ͏O
		*/
		vector<int> iAddiLevel;

		//ƂǉAsOperation̈ʒułAiLevel␳čsȂ߂ɂp܂B
		int iAddPosition = 0;

		vector<Operation> sOperation;
		if(bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		//ۂɒǉʒuƂiLevel߂܂
		//uƂǉvʒuIĂꍇ́AV()ɒu܂B
		if (sOperation[iListSelected].iOperation == 7)
		{
			sOperation.clear();
			sOperation.push_back(Operation());
			sOperation.front().iLevel = { 0 };
		}
		else
		{
			if (sOperation[iListSelected].iOperation == 1)
			{
				iAddiLevel = sOperation[iListSelected].iLevel;
				/**
					Ƃ̏ꏊɑ}ꍇ́AƂ̑OƌQщzOɒǉsB
					}ꏊ
					(1)iLeveĺAiAddiLevel̖ڂ̒lAiAddiLevel̓Y̒lƈقȂ()
						̏ꍇ́AƂ̈O̍(̍ƂȂǍƂ̍ŉ)̏ꏊ
					(2)iLevel̗vfAiAddiLevelȂ
						̏ꍇ́AƂAeƂȂƂ1Ԗڂ̎qƂɓꍇA
					(3)idx=0܂ŒTĂȂꍇ͍ŏ(idx=0)
						̏ꍇ́Aŏ̍Ƃ
				*/
				iAddPosition = 0;//(3)̏ꍇpA(1)(2)Yꍇ͂ŏ㏑̂ŖȂ
				for (int idx = iListSelected - 1; idx >= 0; idx--)
				{
					int iAddiLevelLastPos = iAddiLevel.size() - 1;
					if (sOperation[idx].iLevel.size() < iAddiLevel.size())
					{
						iAddPosition = idx+1;
						break;
					}
					else if (sOperation[idx].iLevel[iAddiLevelLastPos] != iAddiLevel[iAddiLevelLastPos])
					{
						iAddPosition = idx+1;
						break;
					}
				}
			}
			else
			{
				iAddiLevel = sOperation[iListSelected].iLevel;
				iAddPosition = iListSelected;
			}

			sOperation.insert(sOperation.begin() + iAddPosition, Operation());
			sOperation[iAddPosition].iLevel = iAddiLevel;

			//ڂiLevel̕␳
			for (int idx = iAddPosition + 1; idx < (int)sOperation.size(); idx++)
			{
				//܂AǉꂽvfgƁAǉꂽvfe̗vfO
				if (/*idx != iAddPosition &&*/
					sOperation[idx].iLevel.size() >= iAddiLevel.size())
				{
					//ǉꂽvfƁAeƂꂩۂ`FbN
					bool bMatch = true;
					//iAddiLevel.size()1̏ꍇ́AforɓȂȂBOɒlAƂӖňv
					for (int idxl = 0; idxl < (int)iAddiLevel.size() - 1; idxl++)
					{
						if (sOperation[idx].iLevel[idxl] != iAddiLevel[idxl])
						{
							bMatch = false;
							break;
						}
					}
					if (bMatch &&
						sOperation[idx].iLevel[iAddiLevel.size() - 1] >= iAddiLevel.back())
					{
						sOperation[idx].iLevel[iAddiLevel.size() - 1]++;
					}
				}
			}
		}

		if (bSelectedAfter)
		{
			m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
		}
		else
		{
			m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
		}
		m_PropEditUiInternal.GetUiData()->iUiOperation = 2;
		m_PropEditUiInternal.GetUiData()->iListSelected = iAddPosition;
	}

	m_PropEditUiInternal.OnUiDataChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnBnClickedButtonChildoperationadd()
{
	//UiDataɊOANZXAڍƂ}܂B
	//̌iLevel̕␳s܂B
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		/**
			ǉꂽƂiLevelłB傫iLevel̂́AÂlJ艺܂
			J艺
			(1)iLevel̗vfAiAddiLevelȏ̕
				̒l1,1,1̏ꍇ0E1E1,0ȂiLevel̗vfȂ̂͑ΏۊO
			(2)iLevel̒l̂AiAddiLevel̖vfȊO̒lv
				̒l1,1,1̏ꍇ1,2,0E2,1,1ȂǁAO̒lقȂ̂͏O
			(3)iAddiLevel̖vfƓʒu̒lAiAddiLevel̖vf̒lȏ̂
				̒l1,1,1̏ꍇ1,1,0E1,1,0,1Ȃǂ͏O
			(4)ǉꂽƎg͏BiAddPositionŔ
		*/
		vector<int> iAddiLevel;

		//ƂǉAsOperation̈ʒułAiLevel␳čsȂ߂ɂp܂B
		int iAddPosition = 0;

		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		//ۂɒǉʒuƂiLevel߂܂
		if (sOperation[iListSelected].iOperation == 1)
		{
			/**
				Iʒȕꍇ́AIʒuɑOƂ}܂
			*/
			//iAddiLeveĺAOƍŉʂ̂̂ɁAvf1ẐłB
			//Ƃ̑OƂɂ́AKȏ̍ƂĂ̂ŁAߑłŎ擾ł܂B
			iAddiLevel = sOperation[iListSelected - 1].iLevel;
			iAddiLevel.back()++;
			iAddPosition = iListSelected;
		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			/**
				Iʒȕꍇ́AIʒüɌƂ}܂
			*/
			//iAddiLeveĺAƍŏʂ̂̂p܂B
			//Ƃ̌Ƃɂ́AKȏ̍ƂĂ̂ŁAߑłŎ擾ł܂B
			iAddiLevel = sOperation[iListSelected + 1].iLevel;
			iAddPosition = iListSelected + 1;

			m_PropEditUiInternal.GetUiData()->iListSelected++;
		}

		sOperation.insert(sOperation.begin() + iAddPosition, Operation());
		sOperation[iAddPosition].iLevel = iAddiLevel;

		//ڂiLevel̕␳
		for (int idx = 0; idx < (int)sOperation.size(); idx++)
		{
			//܂AǉꂽvfgƁAǉꂽvfe̗vfO
			if (idx != iAddPosition &&
				sOperation[idx].iLevel.size() >= iAddiLevel.size())
			{
				//ǉꂽvfƁAeƂꂩۂ`FbN
				bool bMatch = true;
				//iAddiLevel.size()1̏ꍇ́AforɓȂȂ.OɒlAƂӖňv
				for (int idxl = 0; idxl < (int)iAddiLevel.size() - 1; idxl++)
				{
					if (sOperation[idx].iLevel[idxl] != iAddiLevel[idxl])
					{
						bMatch = false;
						break;
					}
				}
				if (bMatch &&
					sOperation[idx].iLevel[iAddiLevel.size() - 1] >= iAddiLevel.back())
				{
					sOperation[idx].iLevel[iAddiLevel.size() - 1]++;
				}
			}
		}

		if (bSelectedAfter)
		{
			m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
		}
		else
		{
			m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
		}
		m_PropEditUiInternal.GetUiData()->iUiOperation = 2;
	}

	m_PropEditUiInternal.OnUiDataChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnBnClickedButtonOperationclear()
{
	//UiDataɊOANZXAڍƂ폜܂B
	//폜Ώۂ̏ꍇ́A̎qƂ폜܂B
	//̌iLevel̕␳s܂B
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		/**
			폜ꂽƂiLevelłB傫iLevel̂́AÂlJオ܂
			Jオ
			(0)iDelPositionɂ
			(1)iLevel̗vfAiDeliLevelȏ̕
				̒l1,1,1̏ꍇ0E1E1,0ȂiLevel̗vfȂ̂͑ΏۊO
			(2)iLevel̒l̂AiDeliLevel̖vfȊO̒lv
				̒l1,1,1̏ꍇ1,2,0E2,1,1ȂǁAO̒lقȂ̂͏O
			(3)iAddiLevel̖vfƓʒu̒lAiDeliLevel̖vf̒lȏ̂
				̒l1,1,1̏ꍇ1,1,0E1,1,0,1Ȃǂ͏O
		*/
		vector<int> iDeliLevel;

		//Ƃ폜AsOperation̈ʒułAiLevel␳čsȂ߂ɂp܂B
		int iDelPosition = iListSelected;
		//Ƃ폜łB폜Ώۂ̏ꍇ́A̎qƂ폜̂ŁA
		//܂߂ɂȂ܂B
		int iDelSize = 1;

		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		iDeliLevel = sOperation[iListSelected].iLevel;

		if (sOperation[iListSelected].iOperation == 1)
		{
			/**
				̏ꍇ́AOƂč폜܂
			*/
			for (int idxb = iListSelected - 1; idxb >= 0; idxb--)
			{
				/**
					܂AidxbʒuiLevel̗vfmFAvfiDeliLevelȉȂAqƂł͂Ȃ̂ŒTIł
				*/
				if (sOperation[idxb].iLevel.size() <= iDeliLevel.size())
				{
					break;
				}
				/**
					vfiDeliLevel葽ꍇ́AiDeliLevel̗vf܂ł̒lAv邩ۂ𒲂ׂ܂
				*/
				bool bMatch = true;
				//iAddiLevel.size()1̏ꍇ́AforɓȂȂBOɒlAƂӖňv
				for (int idxl = 0; idxl < (int)iDeliLevel.size() ; idxl++)
				{
					if (sOperation[idxb].iLevel[idxl] != iDeliLevel[idxl])
					{
						/**
							lsv̏ꍇAɂ͎qƂ͖̂ŁAbMatchfalseɂĒT𔲂܂B
						*/
						bMatch = false;
						break;
					}
				}
				if (!bMatch)
				{
					break;
				}
				/**
					iDeliLevel.size()̒lvꍇA̍Ƃ͎qƂłA
					iDelPosition-1AiDelSize+1܂B(폜͌ōs)
				*/
				iDelPosition--;
				iDelSize++;
			}

		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			/**
				̏ꍇ́AƂč폜܂
			*/
			for (int idxa = iListSelected + 1; idxa < (int)sOperation.size(); idxa++)
			{
				/**
					܂AidxaʒuiLevel̗vfmFAvfiDeliLevelȉȂAqƂł͂Ȃ̂ŒTIł
				*/
				if (sOperation[idxa].iLevel.size() <= iDeliLevel.size())
				{
					break;
				}
				/**
					vfiDeliLevel葽ꍇ́AiDeliLevel̗vf܂ł̒lAv邩ۂ𒲂ׂ܂
				*/
				bool bMatch = true;
				//iAddiLevel.size()1̏ꍇ́AforɓȂȂBOɒlAƂӖňv
				for (int idxl = 0; idxl < (int)iDeliLevel.size(); idxl++)
				{
					if (sOperation[idxa].iLevel[idxl] != iDeliLevel[idxl])
					{
						/**
							lsv̏ꍇAɂ͎qƂ͖̂ŁAbMatchfalseɂĒT𔲂܂B
						*/
						bMatch = false;
						break;
					}
				}
				if (!bMatch)
				{
					break;
				}
				/**
					iDeliLevel.size()̒lvꍇA̍Ƃ͎qƂłA
					iDelSize+1܂B(폜͌ōs)
				*/
				iDelSize++;
			}
		}

		sOperation.erase(sOperation.begin() + iDelPosition, sOperation.begin() + iDelPosition + iDelSize);

		//ڂiLevel̕␳
		for (int idx = iDelPosition ; idx < (int)sOperation.size(); idx++)
		{
			//ǉꂽvfe̗vfO
			if (sOperation[idx].iLevel.size() >= iDeliLevel.size())
			{
				//ǉꂽvfƁAeƂꂩۂ`FbN
				bool bMatch = true;
				//iDeliLevel.size()1̏ꍇ́AforɓȂȂBOɒlAƂӖňv
				for (int idxl = 0; idxl < (int)iDeliLevel.size() - 1; idxl++)
				{
					if (sOperation[idx].iLevel[idxl] != iDeliLevel[idxl])
					{
						bMatch = false;
						break;
					}
				}
				if (bMatch &&
					sOperation[idx].iLevel[iDeliLevel.size() - 1] >= iDeliLevel.back())
				{
					sOperation[idx].iLevel[iDeliLevel.size() - 1]--;
				}
			}
		}
		//폜ɁAƐ0ɂȂꍇ́A(Ƃǉ)̍Ƃǉ܂
		if (sOperation.size() == 0)
		{
			Operation sOperationAdd;
			sOperationAdd.iOperation = 7;
			sOperationAdd.iLevel.push_back(0);
			sOperation.push_back(sOperationAdd);
		}
		if (bSelectedAfter)
		{
			m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
		}
		else
		{
			m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
		}
		m_PropEditUiInternal.GetUiData()->iUiOperation = 3;
		if ((int)sOperation.size() <= iListSelected)
		{
			m_PropEditUiInternal.GetUiData()->iListSelected = sOperation.size() - 1;
		}
	}

	m_PropEditUiInternal.OnUiDataChanged();
}

void ViewJikokuhyou::CDlgOperationProp::OnBnClickedButtonOperationup()
{
	//UiDataɊOANZXAڍƂւ܂B
	//̌iLevel̕␳s܂B
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		/**
			ւΏۂƂȂiLevelłB傫iLevel̂́AÂlJ艺܂
			J艺
			(0)iAddPositionɂ
			(1)iLevel̗vfAiAddiLevelȏ̕
				̒l1,1,1̏ꍇ0E1E1,0ȂiLevel̗vfȂ̂͑ΏۊO
			(2)iLevel̒l̂AiAddiLevel̖vfȊO̒lv
				̒l1,1,1̏ꍇ1,2,0E2,1,1ȂǁAO̒lقȂ̂͏O
			(3)iAddiLevel̖vfƓʒu̒lAiAddiLevel̖vf̒lȏ̂
				̒l1,1,1̏ꍇ1,1,0E1,1,0,1Ȃǂ͏O
		*/
		vector<int> iUpperiLevel;
		vector<int> iLoweriLevel;

		//ƂǉAsOperation̈ʒułAiLevel␳čsȂ߂ɂp܂B
		int iUpperPosition = 0;
		int iLowerPosition = iListSelected;
		int iLowerCount = 1;
		int iUpperCount = 1;
		int iFocusShift = 0;

		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		//̈ʒuƂiLevel߂܂
		{
			iLoweriLevel = sOperation[iListSelected].iLevel;
			if (sOperation[iListSelected].iOperation == 1)
			{
				/**
					Ƃړꍇ́AqƂ܂Ƃ߂Ĉړ܂B

				*/
				for (int idx = iListSelected - 1; idx >= 0; idx--)
				{
					if (sOperation[idx].iLevel.size() <= iLoweriLevel.size())
					{
						continue;
					}
					bool bMatchiLevel = true;
					for (int idxiLevel = 0; idxiLevel < (int)iLoweriLevel.size() && bMatchiLevel; idxiLevel++)
					{
						if (sOperation[idx].iLevel[idxiLevel] != iLoweriLevel[idxiLevel])
						{
							bMatchiLevel = false;
						}
						if (idxiLevel == (int)iLoweriLevel.size() - 1 &&
							bMatchiLevel)
						{
							iLowerPosition--;
							iLowerCount++;
							iFocusShift++;
						}
					}
				}
			}
			else if (sOperation[iListSelected].iOperation == 2)
			{
				/**
					Ƃړꍇ́AqƂ܂Ƃ߂Ĉړ܂B

				*/
				for (int idx = iListSelected + 1; idx < (int)sOperation.size(); idx++)
				{
					if (sOperation[idx].iLevel.size() <= iLoweriLevel.size())
					{
						continue;
					}
					bool bMatchiLevel = true;
					for (int idxiLevel = 0; idxiLevel < (int)iLoweriLevel.size() && bMatchiLevel; idxiLevel++)
					{
						if (sOperation[idx].iLevel[idxiLevel] != iLoweriLevel[idxiLevel])
						{
							bMatchiLevel = false;
						}
						if (idxiLevel == (int)iLoweriLevel.size() - 1 &&
							bMatchiLevel)
						{
							iLowerCount++;
						}
					}
				}
			}

			//ւ́AiLevel̖A1Ȃ
			iUpperiLevel = iLoweriLevel;
			iUpperiLevel.back()--;

			for (int idx = iListSelected - 1; idx >= 0; idx--)
			{
				if (sOperation[idx].iLevel.size() != iUpperiLevel.size())
				{
					continue;
				}
				bool bMatchiLevel = true;
				for (int idxiLevel = 0; idxiLevel < (int)iUpperiLevel.size() && bMatchiLevel; idxiLevel++)
				{
					if (sOperation[idx].iLevel[idxiLevel] != iUpperiLevel[idxiLevel])
					{
						bMatchiLevel = false;
					}
					if (idxiLevel == (int)iUpperiLevel.size() - 1 &&
						bMatchiLevel)
					{
						iUpperPosition = idx;
					}
				}
				if (bMatchiLevel)
				{
					break;
				}
			}
			if (sOperation[iUpperPosition].iOperation == 1)
			{
				/**
					ւ悪Ƃ̏ꍇ́A̎qƂ̑OւƂȂ܂B

				*/
				for (int idx = iUpperPosition - 1; idx >= 0; idx--)
				{
					if (sOperation[idx].iLevel.size() <= iUpperiLevel.size())
					{
						continue;
					}
					bool bMatchiLevel = true;
					for (int idxiLevel = 0; idxiLevel < (int)iUpperiLevel.size() && bMatchiLevel; idxiLevel++)
					{
						if (sOperation[idx].iLevel[idxiLevel] != iUpperiLevel[idxiLevel])
						{
							bMatchiLevel = false;
						}
						if (idxiLevel == (int)iUpperiLevel.size() - 1 &&
							bMatchiLevel)
						{
							iUpperPosition--;
							iUpperCount++;
						}
					}
				}
			}
			else if (sOperation[iUpperPosition].iOperation == 2)
			{
				/**
					

				*/
				for (int idx = iUpperPosition + 1; idx < (int)sOperation.size(); idx++)
				{
					if (sOperation[idx].iLevel.size() <= iUpperiLevel.size())
					{
						continue;
					}
					bool bMatchiLevel = true;
					for (int idxiLevel = 0; idxiLevel < (int)iUpperiLevel.size() && bMatchiLevel; idxiLevel++)
					{
						if (sOperation[idx].iLevel[idxiLevel] != iUpperiLevel[idxiLevel])
						{
							bMatchiLevel = false;
						}
						if (idxiLevel == (int)iUpperiLevel.size() - 1 &&
							bMatchiLevel)
						{
							iUpperCount++;
						}
					}
				}
			}
			vector<Operation> contLower(sOperation.begin() + iLowerPosition, sOperation.begin() + iLowerPosition + iLowerCount);
			sOperation.erase(sOperation.begin() + iLowerPosition, sOperation.begin() + iLowerPosition + iLowerCount);

			//ڂiLevel̕␳
			int iLevelAdjustidx = iLoweriLevel.size() - 1;
			for (int idx = 0; idx < (int)contLower.size(); idx++)
			{
				contLower[idx].iLevel[iLevelAdjustidx]--;
			}
			for (int idx = iUpperPosition ; idx < iUpperPosition+ iUpperCount; idx++)
			{
				sOperation[idx].iLevel[iLevelAdjustidx]++;
			}

			sOperation.insert(sOperation.begin() + iUpperPosition, contLower.begin(), contLower.end());

		}

		if (bSelectedAfter)
		{
			m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
		}
		else
		{
			m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
		}
		m_PropEditUiInternal.GetUiData()->iUiOperation = 1;
		m_PropEditUiInternal.GetUiData()->iListSelected = iUpperPosition+ iFocusShift;
	}

	m_PropEditUiInternal.OnUiDataChanged();
}


void ViewJikokuhyou::CDlgOperationProp::OnBnClickedButtonOperationdown()
{
	//UiDataɊOANZXAڍƂւ܂B
	//̌iLevel̕␳s܂B
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		/**
			ւΏۂƂȂiLevelłB傫iLevel̂́AÂlJ艺܂
			J艺
			(0)iAddPositionɂ
			(1)iLevel̗vfAiAddiLevelȏ̕
				̒l1,1,1̏ꍇ0E1E1,0ȂiLevel̗vfȂ̂͑ΏۊO
			(2)iLevel̒l̂AiAddiLevel̖vfȊO̒lv
				̒l1,1,1̏ꍇ1,2,0E2,1,1ȂǁAO̒lقȂ̂͏O
			(3)iAddiLevel̖vfƓʒu̒lAiAddiLevel̖vf̒lȏ̂
				̒l1,1,1̏ꍇ1,1,0E1,1,0,1Ȃǂ͏O
		*/
		vector<int> iUpperiLevel;
		vector<int> iLoweriLevel;

		//ƂǉAsOperation̈ʒułAiLevel␳čsȂ߂ɂp܂B
		int iUpperPosition = iListSelected;
		int iLowerPosition = 0;
		int iLowerCount = 1;
		int iUpperCount = 1;
		int iFocusShift = 0;

		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		//̈ʒuƂiLevel߂܂
		{
			iUpperiLevel = sOperation[iListSelected].iLevel;
			if (sOperation[iListSelected].iOperation == 1)
			{
				/**
					Ƃړꍇ́AqƂ܂Ƃ߂Ĉړ܂B

				*/
				for (int idx = iListSelected - 1; idx >= 0; idx--)
				{
					if (sOperation[idx].iLevel.size() <= iUpperiLevel.size())
					{
						continue;
					}
					bool bMatchiLevel = true;
					for (int idxiLevel = 0; idxiLevel < (int)iUpperiLevel.size() && bMatchiLevel; idxiLevel++)
					{
						if (sOperation[idx].iLevel[idxiLevel] != iUpperiLevel[idxiLevel])
						{
							bMatchiLevel = false;
						}
						if (idxiLevel == (int)iUpperiLevel.size() - 1 &&
							bMatchiLevel)
						{
							iUpperPosition--;
							iUpperCount++;
							iFocusShift++;
						}
					}
				}
			}
			else if (sOperation[iListSelected].iOperation == 2)
			{
				/**
					Ƃړꍇ́AqƂ܂Ƃ߂Ĉړ܂B

				*/
				for (int idx = iListSelected + 1; idx < (int)sOperation.size(); idx++)
				{
					if (sOperation[idx].iLevel.size() <= iUpperiLevel.size())
					{
						continue;
					}
					bool bMatchiLevel = true;
					for (int idxiLevel = 0; idxiLevel < (int)iUpperiLevel.size() && bMatchiLevel; idxiLevel++)
					{
						if (sOperation[idx].iLevel[idxiLevel] != iUpperiLevel[idxiLevel])
						{
							bMatchiLevel = false;
						}
						if (idxiLevel == (int)iUpperiLevel.size() - 1 &&
							bMatchiLevel)
						{
							iUpperCount++;
						}
					}
				}
			}

			//ւ́AiLevel̖A1傫
			iLoweriLevel = iUpperiLevel;
			iLoweriLevel.back()++;

			for (int idx = iListSelected + 1; idx < (int)sOperation.size(); idx++)
			{
				if (sOperation[idx].iLevel.size() != iLoweriLevel.size())
				{
					continue;
				}
				bool bMatchiLevel = true;
				for (int idxiLevel = 0; idxiLevel < (int)iLoweriLevel.size() && bMatchiLevel; idxiLevel++)
				{
					if (sOperation[idx].iLevel[idxiLevel] != iLoweriLevel[idxiLevel])
					{
						bMatchiLevel = false;
					}
					if (idxiLevel == (int)iLoweriLevel.size() - 1 &&
						bMatchiLevel)
					{
						iLowerPosition = idx;
					}
				}
				if (bMatchiLevel)
				{
					break;
				}
			}
			if (sOperation[iLowerPosition].iOperation == 1)
			{
				/**
					ւ悪Ƃ̏ꍇ́A̎qƂ̑OւƂȂ܂B

				*/
				for (int idx = iLowerPosition - 1; idx >= 0; idx--)
				{
					if (sOperation[idx].iLevel.size() <= iLoweriLevel.size())
					{
						continue;
					}
					bool bMatchiLevel = true;
					for (int idxiLevel = 0; idxiLevel < (int)iLoweriLevel.size() && bMatchiLevel; idxiLevel++)
					{
						if (sOperation[idx].iLevel[idxiLevel] != iLoweriLevel[idxiLevel])
						{
							bMatchiLevel = false;
						}
						if (idxiLevel == (int)iLoweriLevel.size() - 1 &&
							bMatchiLevel)
						{
							iLowerPosition--;
							iLowerCount++;
						}
					}
				}
			}
			else if (sOperation[iLowerPosition].iOperation == 2)
			{
				/**
					

				*/
				for (int idx = iLowerPosition + 1; idx < (int)sOperation.size(); idx++)
				{
					if (sOperation[idx].iLevel.size() <= iLoweriLevel.size())
					{
						continue;
					}
					bool bMatchiLevel = true;
					for (int idxiLevel = 0; idxiLevel < (int)iLoweriLevel.size() && bMatchiLevel; idxiLevel++)
					{
						if (sOperation[idx].iLevel[idxiLevel] != iLoweriLevel[idxiLevel])
						{
							bMatchiLevel = false;
						}
						if (idxiLevel == (int)iLoweriLevel.size() - 1 &&
							bMatchiLevel)
						{
							iLowerCount++;
						}
					}
				}
			}
			vector<Operation> contLower(sOperation.begin() + iLowerPosition, sOperation.begin() + iLowerPosition + iLowerCount);
			sOperation.erase(sOperation.begin() + iLowerPosition, sOperation.begin() + iLowerPosition + iLowerCount);

			//ڂiLevel̕␳
			int iLevelAdjustidx = iLoweriLevel.size() - 1;
			for (int idx = 0; idx < (int)contLower.size(); idx++)
			{
				contLower[idx].iLevel[iLevelAdjustidx]--;
			}
			for (int idx = iUpperPosition; idx < iUpperPosition + iUpperCount; idx++)
			{
				sOperation[idx].iLevel[iLevelAdjustidx]++;
			}

			sOperation.insert(sOperation.begin() + iUpperPosition, contLower.begin(), contLower.end());

		}

		if (bSelectedAfter)
		{
			m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
		}
		else
		{
			m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
		}
		m_PropEditUiInternal.GetUiData()->iUiOperation = 1;
		m_PropEditUiInternal.GetUiData()->iListSelected = iUpperPosition + iLowerCount + iFocusShift;
	}

	m_PropEditUiInternal.OnUiDataChanged();
}

/** _CAO{bNXւ̎̏ێ܂B */
const CdDedJikoku::CConv	g_CdDedJikokuConv(
	true,		//	NoColon 
	CdDedJikoku::CConv::EHour_ZeroToNone,		//	HourZeroToNone 
	CdDedJikoku::CConv::ESecond_NotIfZero);	//	NoSecond


void CDlgOperationProp::OnBnClickedButtonDecEdit1_1min()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 1 ||
			sOperation[iListSelected].iOperation == 3 ||
			sOperation[iListSelected].iOperation == 4 ||
			sOperation[iListSelected].iOperation == 5)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData1;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if(sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationChakuJikoku = sOperation[iListSelected].strEditData2;
				if (!strOperationChakuJikoku.empty())
				{
					aJikoku.decode(strOperationChakuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			int iOld = _ttoi(sOperation[iListSelected].strEditData1.c_str());
			if (iOld > 1)
			{
				sOperation[iListSelected].strEditData1 = to_tstring(iOld - 1);

				if (bSelectedAfter)
				{
					m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
				}
				else
				{
					m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
				}
				m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonIncEdit1_1min()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 1 ||
			sOperation[iListSelected].iOperation == 3 ||
			sOperation[iListSelected].iOperation == 4 ||
			sOperation[iListSelected].iOperation == 5)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData1;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationChakuJikoku = sOperation[iListSelected].strEditData2;
				if (!strOperationChakuJikoku.empty())
				{
					aJikoku.decode(strOperationChakuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			int iOld = _ttoi(sOperation[iListSelected].strEditData1.c_str());
			if (iOld < 10)
			{
				sOperation[iListSelected].strEditData1 = to_tstring(iOld + 1);

				if (bSelectedAfter)
				{
					m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
				}
				else
				{
					m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
				}
				m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonDecEdit1_5min()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 1 ||
			sOperation[iListSelected].iOperation == 3 ||
			sOperation[iListSelected].iOperation == 4 ||
			sOperation[iListSelected].iOperation == 5)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData1;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationChakuJikoku = sOperation[iListSelected].strEditData2;
				if (!strOperationChakuJikoku.empty())
				{
					aJikoku.decode(strOperationChakuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			int iOld = _ttoi(sOperation[iListSelected].strEditData1.c_str());
			if (iOld > 1)
			{
				sOperation[iListSelected].strEditData1 = to_tstring(iOld - 1);

				if (bSelectedAfter)
				{
					m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
				}
				else
				{
					m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
				}
				m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonIncEdit1_5min()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 1 ||
			sOperation[iListSelected].iOperation == 3 ||
			sOperation[iListSelected].iOperation == 4 ||
			sOperation[iListSelected].iOperation == 5)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData1;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationChakuJikoku = sOperation[iListSelected].strEditData2;
				if (!strOperationChakuJikoku.empty())
				{
					aJikoku.decode(strOperationChakuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			int iOld = _ttoi(sOperation[iListSelected].strEditData1.c_str());
			if (iOld < 10)
			{
				sOperation[iListSelected].strEditData1 = to_tstring(iOld + 1);

				if (bSelectedAfter)
				{
					m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
				}
				else
				{
					m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
				}
				m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonDecEdit1anysec1()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 1 ||
			sOperation[iListSelected].iOperation == 3 ||
			sOperation[iListSelected].iOperation == 4 ||
			sOperation[iListSelected].iOperation == 5)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData1;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationChakuJikoku = sOperation[iListSelected].strEditData2;
				if (!strOperationChakuJikoku.empty())
				{
					aJikoku.decode(strOperationChakuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			int iOld = _ttoi(sOperation[iListSelected].strEditData1.c_str());
			if (iOld > 1)
			{
				sOperation[iListSelected].strEditData1 = to_tstring(iOld - 1);

				if (bSelectedAfter)
				{
					m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
				}
				else
				{
					m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
				}
				m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonIncEdit1anysec1()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 1 ||
			sOperation[iListSelected].iOperation == 3 ||
			sOperation[iListSelected].iOperation == 4 ||
			sOperation[iListSelected].iOperation == 5)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData1;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationChakuJikoku = sOperation[iListSelected].strEditData2;
				if (!strOperationChakuJikoku.empty())
				{
					aJikoku.decode(strOperationChakuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			int iOld = _ttoi(sOperation[iListSelected].strEditData1.c_str());
			if (iOld < 10)
			{
				sOperation[iListSelected].strEditData1 = to_tstring(iOld + 1);

				if (bSelectedAfter)
				{
					m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
				}
				else
				{
					m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
				}
				m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonDecEdit1anysec2()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 1 ||
			sOperation[iListSelected].iOperation == 3 ||
			sOperation[iListSelected].iOperation == 4 ||
			sOperation[iListSelected].iOperation == 5)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData1;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationChakuJikoku = sOperation[iListSelected].strEditData2;
				if (!strOperationChakuJikoku.empty())
				{
					aJikoku.decode(strOperationChakuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			int iOld = _ttoi(sOperation[iListSelected].strEditData1.c_str());
			if (iOld > 1)
			{
				sOperation[iListSelected].strEditData1 = to_tstring(iOld - 1);

				if (bSelectedAfter)
				{
					m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
				}
				else
				{
					m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
				}
				m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonIncEdit1anysec2()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 1 ||
			sOperation[iListSelected].iOperation == 3 ||
			sOperation[iListSelected].iOperation == 4 ||
			sOperation[iListSelected].iOperation == 5)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData1;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationChakuJikoku = sOperation[iListSelected].strEditData2;
				if (!strOperationChakuJikoku.empty())
				{
					aJikoku.decode(strOperationChakuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData1 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
		else if (sOperation[iListSelected].iOperation == 2)
		{
			int iOld = _ttoi(sOperation[iListSelected].strEditData1.c_str());
			if (iOld < 10)
			{
				sOperation[iListSelected].strEditData1 = to_tstring(iOld + 1);

				if (bSelectedAfter)
				{
					m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
				}
				else
				{
					m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
				}
				m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonDecEdit2_1min()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 2 ||
			sOperation[iListSelected].iOperation == 4)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData2;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationHatsuJikoku = sOperation[iListSelected].strEditData1;
				if (!strOperationHatsuJikoku.empty())
				{
					aJikoku.decode(strOperationHatsuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonIncEdit2_1min()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 2 ||
			sOperation[iListSelected].iOperation == 4)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData2;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationHatsuJikoku = sOperation[iListSelected].strEditData1;
				if (!strOperationHatsuJikoku.empty())
				{
					aJikoku.decode(strOperationHatsuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+60);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonDecEdit2_5min()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 2 ||
			sOperation[iListSelected].iOperation == 4)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData2;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationHatsuJikoku = sOperation[iListSelected].strEditData1;
				if (!strOperationHatsuJikoku.empty())
				{
					aJikoku.decode(strOperationHatsuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonIncEdit2_5min()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 2 ||
			sOperation[iListSelected].iOperation == 4)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData2;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationHatsuJikoku = sOperation[iListSelected].strEditData1;
				if (!strOperationHatsuJikoku.empty())
				{
					aJikoku.decode(strOperationHatsuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+300);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonDecEdit2anysec1()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 2 ||
			sOperation[iListSelected].iOperation == 4)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData2;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationHatsuJikoku = sOperation[iListSelected].strEditData1;
				if (!strOperationHatsuJikoku.empty())
				{
					aJikoku.decode(strOperationHatsuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonIncEdit2anysec1()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 2 ||
			sOperation[iListSelected].iOperation == 4)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData2;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationHatsuJikoku = sOperation[iListSelected].strEditData1;
				if (!strOperationHatsuJikoku.empty())
				{
					aJikoku.decode(strOperationHatsuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec1);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonDecEdit2anysec2()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 2 ||
			sOperation[iListSelected].iOperation == 4)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData2;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationHatsuJikoku = sOperation[iListSelected].strEditData1;
				if (!strOperationHatsuJikoku.empty())
				{
					aJikoku.decode(strOperationHatsuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(-m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}

void CDlgOperationProp::OnBnClickedButtonIncEdit2anysec2()
{
	bool bSelectedAfter = m_PropEditUiInternal.GetUiData()->bSelectedAfter;
	int iListSelected = m_PropEditUiInternal.GetUiData()->iListSelected;
	if (iListSelected >= 0)
	{
		vector<Operation> sOperation;
		if (bSelectedAfter)
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationA;
		}
		else
		{
			sOperation = m_PropEditUiInternal.GetUiData()->sOperationB;
		}

		if (sOperation[iListSelected].iOperation == 0 ||
			sOperation[iListSelected].iOperation == 2 ||
			sOperation[iListSelected].iOperation == 4)
		{
			tstring strJikokuOld = sOperation[iListSelected].strEditData2;
			if (!strJikokuOld.empty())
			{
				CdDedJikoku aJikoku(strJikokuOld);
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else if (sOperation[iListSelected].iOperation == 0)
			{
				CdDedJikoku aJikoku;
				tstring strOperationHatsuJikoku = sOperation[iListSelected].strEditData1;
				if (!strOperationHatsuJikoku.empty())
				{
					aJikoku.decode(strOperationHatsuJikoku);
				}
				if (aJikoku.isNull())
				{
					if (m_iHatsuEkiOrder == -1 ||
						!bSelectedAfter && m_iChakuEkiOrder >= 0)
					{
						aJikoku = m_ChakuJikoku;
					}
					else
					{
						aJikoku = m_HatsuJikoku;
					}
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
			else
			{
				CdDedJikoku aJikoku;
				if (m_iHatsuEkiOrder == -1 ||
					!bSelectedAfter && m_iChakuEkiOrder >= 0)
				{
					aJikoku = m_ChakuJikoku;
				}
				else
				{
					aJikoku = m_HatsuJikoku;
				}
				if (!aJikoku.isNull())
				{
					aJikoku.addSeconds(+m_AnySec2);
					CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
					sOperation[iListSelected].strEditData2 = aJikokuConv.encode(aJikoku);

					if (bSelectedAfter)
					{
						m_PropEditUiInternal.GetUiData()->sOperationA = sOperation;
					}
					else
					{
						m_PropEditUiInternal.GetUiData()->sOperationB = sOperation;
					}
					m_PropEditUiInternal.GetUiData()->iUiOperation = 0;
				}
			}
		}
	}
	m_PropEditUiInternal.OnUiDataChanged();
}


} //namespace ViewJikokuhyou
