/*
OuDiaSecond Copyright (C) 2017-2020 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	$Id: CPropEditUI_Operation.cpp 357 2016-08-18 16:59:16Z okm $
// ****************************************************************

/** @file */

#include "stdafx.h"
#include "NsMu\CConvTable.h"
#include "CPropEditUI_Operation.h"
#include "str\CStrCharSizeMb.h"
#include "str\strLf.h"
//#include "Str\tstring.h"
#include "Str\strToWstr.h"
#include "NsOu/dynamic_castOu.h"
#include "NsOu/OuNew.h"
#include "..\entDed\entDed.h"
#include "Str\stringSplit.h"
#include <stdexcept>

namespace ViewJikokuhyou{
	using namespace OuLib::Str;

		
/** _CAO{bNXւ̎̏ێ܂B */
const CdDedJikoku::CConv	g_CdDedJikokuConv(
	true ,		//	NoColon 
	CdDedJikoku::CConv::EHour_ZeroToNone ,		//	HourZeroToNone 
	CdDedJikoku::CConv::ESecond_NotIfZero ) ;	//	NoSecond


/**
	UI`߂āAɕϊ܂B
	GfBbgRg[̓e2̏ꍇ́A
	ỎwOrderƂɁA⊮܂B
@param strUIJikoku [in]
	UI`̎w肵ĂB
@param jikokuRevOrder [in]
	ÓwwxB
	̒ĺAstrControl̂(2)̏ꍇA⊮̂Ɏg܂B
	wNULLԁx̏ꍇA̕⊮͍s܂B
@param pCdDedJikoku [out]
	̊֐́Ả߂ɐA̓eϊ
	ɏ݂܂B
@param bBefore
	truȅꍇAjikokuRevOrderO̎Ƃ悤ɕϊ܂
@return
	 0 ȏBւ̕ϊłȂΕ̐łB
	-	-1 ;	//	ڐsĂ܂B
	-	-2 ;	//	EEb̕\LsłB
*/
static int	getJikokuFromUI( 
	const tstring& strUIJikoku , 
	const CdDedJikoku& jikokuRevOrder , 
	CdDedJikoku* pCdDedJikoku ,
	const bool bBefore) 
{
	int	iRv = 0 ;
	CdDedJikoku	aCdDedJikoku ;
	tstring	strControl = tstringOf(CStrCharSizeMb::strToSingleByte( 
		stringOf(OuLib::Str::strTrim( strUIJikoku) ) ) ) ;

	int iResult = aCdDedJikoku.decode( strControl ) ;
	if ( iResult < 0 )
	{
		iRv = iResult ;
		//	񂪉߂ł܂B
	}
	//iRv = 
	//-	-1 ;	//	ڐsĂ܂B
	//-	-2 ;	//	EEb̕\LsłB

	//	2ŁAỎwꍇ́A
	//	Ɏ⊮
	if ( iRv == -1 && 
		 !jikokuRevOrder.isNull() && 
		strControl.size() == 2 && 
		isdigit( strControl[0] ) && 
		isdigit( strControl[1] ) )
	{
		if (bBefore)
		{
			int iMin = _ttoi(strControl.c_str());
			if (0 <= iMin && iMin < 60)
			{
				aCdDedJikoku.setTime(jikokuRevOrder.getHour(), iMin);
				CdDedJikan	jikanSub = aCdDedJikoku.subJikoku(
					jikokuRevOrder);
				if (jikanSub.getTotalSeconds() > 0)
				{
					aCdDedJikoku = aCdDedJikoku.getTotalSeconds() - 60 * 60;
				}
				//aCdDedJikoku = ݓ͂ꂽ2̕ɁA
				//	jikokuRevOrder ȌƂȂ鎞⊮

				iRv = 0;	//	⊮ɐ܂B 
			}
		}
		else
		{
			int iMin = _ttoi(strControl.c_str());
			if (0 <= iMin && iMin < 60)
			{
				aCdDedJikoku.setTime(jikokuRevOrder.getHour(), iMin);
				CdDedJikan	jikanSub = aCdDedJikoku.subJikoku(
					jikokuRevOrder);
				if (jikanSub.getTotalSeconds() < 0)
				{
					aCdDedJikoku = aCdDedJikoku.getTotalSeconds() + 60 * 60;
				}
				//aCdDedJikoku = ݓ͂ꂽ2̕ɁA
				//	jikokuRevOrder ȌƂȂ鎞⊮

				iRv = 0;	//	⊮ɐ܂B 
			}
		}
	}

	// --------------------------------
	if ( pCdDedJikoku != NULL )
	{
		*pCdDedJikoku = aCdDedJikoku ;
	}
	return iRv ;
}

	// ********************************
	//@name G[bZ[W
	// ********************************

const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_SHUNTHATSUJIKOKU = _T("Invalid ShuntHatsuJikoku.");//01
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_SHUNTCHAKUJIKOKU = _T("Invalid ShuntChakuJikoku.");//02
//const TCHAR* const CPropEditUI_Operation::ERRMSG_OUTOFRANGE_SHUNTHATSUJIKOKU = _T("OutOfRange ShuntHatsuJikoku.");//03
//const TCHAR* const CPropEditUI_Operation::ERRMSG_OUTOFRANGE_SHUNTCHAKUJIKOKU = _T("OutOfRange ShuntChakuJikoku.");//04
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_CONNECTJIKOKU = _T("Invalid ConnectJikoku.");//11
//const TCHAR* const CPropEditUI_Operation::ERRMSG_OUTOFRANGE_CONNECTJIKOKU = _T("OutOfRange ConnectJikoku.");//12
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_RELEASEJIKOKU = _T("Invalid ReleaseJikoku.");//21
//const TCHAR* const CPropEditUI_Operation::ERRMSG_OUTOFRANGE_RELEASEJIKOKU = _T("OutOfRange ReleaseJikoku.");//22
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_RELEASEINDEX = _T("Invalid ReleaseIndex.");//23
const TCHAR* const CPropEditUI_Operation::ERRMSG_OUTOFRANGE_RELEASEINDEX = _T("OutOfRange ReleaseIndex.");//24,25
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_OUTJIKOKU = _T("Invalid OutJikoku.");//31
//const TCHAR* const CPropEditUI_Operation::ERRMSG_OUTOFRANGE_OUTJIKOKU = _T("OutOfRange OutJikoku.");//32
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_INJIKOKU = _T("Invalid InJikoku.");//33
//const TCHAR* const CPropEditUI_Operation::ERRMSG_OUTOFRANGE_INJIKOKU = _T("OutOfRange InJikoku.");//34
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_OUTERHATSUJIKOKU = _T("Invalid OuterHatsuJikoku.");//41
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_CHAKUJIKOKU = _T("Invalid ChakuJikoku.");//42
//const TCHAR* const CPropEditUI_Operation::ERRMSG_OUTOFRANGE_CHAKUJIKOKU = _T("OutOfRange ChakuJikoku.");//43
const TCHAR* const CPropEditUI_Operation::ERRMSG_EMPTY_OUTERHATSUJIKOKU = _T("Empty OuterHatsuJikoku.");//44
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_HATSUJIKOKU = _T("Invalid HatsuJikoku.");//45
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_OUTERCHAKUJIKOKU = _T("Invalid OuterChakuJikoku.");//46
//const TCHAR* const CPropEditUI_Operation::ERRMSG_OUTOFRANGE_HATSUJIKOKU = _T("OutOfRange HatsuJikoku.");//47
const TCHAR* const CPropEditUI_Operation::ERRMSG_EMPTY_OUTERCHAKUJIKOKU = _T("Empty OuterChakuJikoku.");//48
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_ORIGINJIKOKU = _T("Invalid OriginJikoku.");//51
const TCHAR* const CPropEditUI_Operation::ERRMSG_INVALID_TERMINALJIKOKU = _T("Invalid TerminalJikoku.");//52
const TCHAR* const CPropEditUI_Operation::ERRMSG_UNUSABLE_COMMA = _T("OperationNumber Unusable comma.");//35
const TCHAR* const CPropEditUI_Operation::ERRMSG_EMPTY_OPERATIONNUMBER = _T("Empty OperationNumber.");//61




	// ================================
	//@name ֐
	// ================================

//const CConvTable<CentDedOperationBeforeRelease::EBReleasePos, int>& getBReleasePosConvTable()
//{
//	static CConvTable<CentDedOperationBeforeRelease::EBReleasePos, int>	aTable;
//	if (aTable.size() == 0)
//	{
//		aTable.add(CentDedOperationBeforeRelease::BReleasePos_Back, 0);//	㕔
//		aTable.add(CentDedOperationBeforeRelease::BReleasePos_Front, 1);//	O
//		aTable.add(CentDedOperationBeforeRelease::BReleasePos_FrontLeave, 2);//	OҐw
//	}
//	return aTable;
//}
//const CConvTable<CentDedOperationAfterRelease::EAReleasePos, int>& getAReleasePosConvTable()
//{
//	static CConvTable<CentDedOperationAfterRelease::EAReleasePos, int>	aTable;
//	if (aTable.size() == 0)
//	{
//		aTable.add(CentDedOperationAfterRelease::AReleasePos_Back, 0);//	㕔
//		aTable.add(CentDedOperationAfterRelease::AReleasePos_Front, 1);//	O
//		aTable.add(CentDedOperationAfterRelease::AReleasePos_FrontLeave, 2);//	OҐw
//	}
//	return aTable;
//}
	// ================================
	//@name UiData - TargetԂ̃f[^]
	// ================================

	

vector<Operation> CPropEditUI_Operation::BeforeOperationFromTarget(
	const CentDedBeforeOperationCont * pCentDedBeforeOperationCont,
	const vector<int> iLevel)
{
	vector<Operation> sOperationB;
	CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);

	for (int idx = 0; idx < pCentDedBeforeOperationCont->size(); idx++)
	{
		const CentDedBeforeOperation*	pBeforeOperation
			= pCentDedBeforeOperationCont->getMuPtr()->get(idx);
		if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 0;
			sOperationTemp.iComboData1 = pBeforeOperation->getShuntTrackIndex();
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pBeforeOperation->getOperationHatsuJikoku());
			sOperationTemp.strEditData2 = aJikokuConv.encode(
				pBeforeOperation->getOperationChakuJikoku(false));
			sOperationTemp.bCheckData1 = pBeforeOperation->getIsDisplayChakuJikoku();
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationB.push_back(sOperationTemp);

		}
		else if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Connect)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 1;
			sOperationTemp.iComboData1 =
				pBeforeOperation->getIsConnectToFront() ? 1 : 0;
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pBeforeOperation->getConnectJikoku());
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			vector<Operation> sOperationBTemp =
				BeforeOperationFromTarget(
					pBeforeOperation->getCentDedBeforeOperationCont(),
					sOperationTemp.iLevel);

			//̏ꍇAnɉāAɎqƂUiDataɒǉƁȂƂǉ
			sOperationB.insert(sOperationB.end(), sOperationBTemp.begin(), sOperationBTemp.end());
			sOperationB.push_back(sOperationTemp);
		}
		else if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Release)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 2;
			sOperationTemp.iComboData1 = pBeforeOperation->getReleasePos();
			sOperationTemp.strEditData1 = to_tstring(pBeforeOperation->getReleaseIndexCount());
			sOperationTemp.strEditData2 = aJikokuConv.encode(
				pBeforeOperation->getReleaseJikoku());
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			vector<Operation> sOperationATemp =
				AfterOperationFromTarget(
					pBeforeOperation->getCentDedAfterOperationCont(),
					sOperationTemp.iLevel);

			//̏ꍇAnɉāAɂ̉ƂǉƁAqƂǉ
			sOperationB.push_back(sOperationTemp);
			sOperationB.insert(sOperationB.end(), sOperationATemp.begin(), sOperationATemp.end());
		}
		else if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Out)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 3;
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pBeforeOperation->getOutJikoku());
			sOperationTemp.strOperationNumber = pBeforeOperation->getOperationNumber();
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationB.push_back(sOperationTemp);
		}
		else if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Outer)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 4;
			sOperationTemp.iComboData1 = pBeforeOperation->getOuterShihatsuekiIndex();
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pBeforeOperation->getOuterShihatsuJikoku());
			sOperationTemp.strEditData2 = aJikokuConv.encode(
				pBeforeOperation->getChakuJikoku());
			sOperationTemp.strOperationNumber = pBeforeOperation->getOperationNumber();
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationB.push_back(sOperationTemp);
		}
		else if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Junction)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 5;
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pBeforeOperation->getOriginJikoku());
			sOperationTemp.bCheckData1 = pBeforeOperation->getDisableReleaseDisplay();
			sOperationTemp.strOperationNumber = pBeforeOperation->getOperationNumberTemp();
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationB.push_back(sOperationTemp);
		}
		else if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_NumberChange)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 6;
			sOperationTemp.strOperationNumber = pBeforeOperation->getOperationNumber();
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationB.push_back(sOperationTemp);
		}
	}
	return sOperationB;
}

vector<Operation> CPropEditUI_Operation::AfterOperationFromTarget(
	const CentDedAfterOperationCont * pCentDedAfterOperationCont,
	const vector<int> iLevel)
{
	//pCentDedOperationAfterContɂ́AƂn񏇂Ɏ߂Ă
	vector<Operation> sOperationA;
	CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
	for (int idx = 0; idx < pCentDedAfterOperationCont->size(); idx++)
	{
		const CentDedAfterOperation*	pAfterOperation
			= pCentDedAfterOperationCont->getMuPtr()->get(idx);
		if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 0;
			sOperationTemp.iComboData1 = pAfterOperation->getShuntTrackIndex();
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pAfterOperation->getOperationHatsuJikoku());
			sOperationTemp.strEditData2 = aJikokuConv.encode(
				pAfterOperation->getOperationChakuJikoku(false));
			sOperationTemp.bCheckData1 = pAfterOperation->getIsDisplayHatsuJikoku();
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationA.push_back(sOperationTemp);

		}
		else if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Connect)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 1;
			sOperationTemp.iComboData1 =
				pAfterOperation->getIsConnectToFront() ? 1 : 0;
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pAfterOperation->getConnectJikoku());
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			vector<Operation> sOperationBTemp =
				BeforeOperationFromTarget(
					pAfterOperation->getCentDedBeforeOperationCont(),
					sOperationTemp.iLevel);

			sOperationA.insert(sOperationA.end(), sOperationBTemp.begin(), sOperationBTemp.end());
			sOperationA.push_back(sOperationTemp);
		}
		else if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Release)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 2;
			sOperationTemp.iComboData1 = pAfterOperation->getReleasePos();
			sOperationTemp.strEditData1 = to_tstring(pAfterOperation->getReleaseIndexCount());
			sOperationTemp.strEditData2 = aJikokuConv.encode(
				pAfterOperation->getReleaseJikoku());
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			vector<Operation> sOperationATemp =
				AfterOperationFromTarget(
					pAfterOperation->getCentDedAfterOperationCont(),
					sOperationTemp.iLevel);

			sOperationA.push_back(sOperationTemp);
			sOperationA.insert(sOperationA.end(), sOperationATemp.begin(), sOperationATemp.end());
		}
		else if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_In)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 3;
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pAfterOperation->getInJikoku());
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationA.push_back(sOperationTemp);
		}
		else if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Outer)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 4;
			sOperationTemp.iComboData1 = pAfterOperation->getOuterShuchakuekiIndex();
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pAfterOperation->getHatsuJikoku());
			sOperationTemp.strEditData2 = aJikokuConv.encode(
				pAfterOperation->getOuterShuchakuJikoku());
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationA.push_back(sOperationTemp);
		}
		else if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Junction)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 5;
			sOperationTemp.strEditData1 = aJikokuConv.encode(
				pAfterOperation->getTerminalJikoku());
			sOperationTemp.bCheckData1 = pAfterOperation->getDisableConnectDisplay();
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationA.push_back(sOperationTemp);
		}
		else if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_NumberChange)
		{
			Operation sOperationTemp;
			sOperationTemp.iOperation = 6;
			sOperationTemp.strOperationNumber = pAfterOperation->getOperationNumber();
			sOperationTemp.iLevel = iLevel;
			sOperationTemp.iLevel.push_back(idx);

			sOperationA.push_back(sOperationTemp);
		}
	}
	return sOperationA;
}

void CPropEditUI_Operation::UiDataFromTarget(UIDATA* pUiData)
{
	CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);
	CentDedRessya* pRessya = m_pTarget->get(0);
	CentDedEkiJikoku aChakuEkiJikoku;
	CentDedEkiJikoku aHatsuEkiJikoku;
	if (m_iChakuEkiOrder == -1)
	{
		aChakuEkiJikoku = pRessya->getCentDedEkiJikoku(m_iHatsuEkiOrder);
	}
	else
	{
		aChakuEkiJikoku = pRessya->getCentDedEkiJikoku(m_iChakuEkiOrder);
	}
	if (m_iHatsuEkiOrder == -1)
	{
		aHatsuEkiJikoku = pRessya->getCentDedEkiJikoku(m_iChakuEkiOrder);
	}
	else
	{
		aHatsuEkiJikoku = pRessya->getCentDedEkiJikoku(m_iHatsuEkiOrder);
	}

	/**
		
	*/
	pUiData->strChakujikoku = aJikokuConv.encode(
		aChakuEkiJikoku.getChakujikoku());

	/**
		
	*/
	pUiData->strHatsujikoku = aJikokuConv.encode(
		aHatsuEkiJikoku.getHatsujikoku());

	/**
		O
	*/
	pUiData->sOperationB = BeforeOperationFromTarget(
		aChakuEkiJikoku.getCentDedBeforeOperationCont(),
		vector<int>());
	if (pUiData->sOperationB.empty())
	{
		pUiData->sOperationB.push_back(Operation());
		pUiData->sOperationB.front().iOperation = 7;
		pUiData->sOperationB.front().iLevel = { 0 };
	}


	/**
		
	*/
	pUiData->sOperationA = AfterOperationFromTarget(
		aHatsuEkiJikoku.getCentDedAfterOperationCont(),
		vector<int>());
	if (pUiData->sOperationA.empty())
	{
		pUiData->sOperationA.push_back(Operation());
		pUiData->sOperationA.front().iOperation = 7;
		pUiData->sOperationA.front().iLevel = { 0 };
	}

	/**
		ʕύX
	*/
	if (m_iHatsuEkiOrder < 0 && pUiData->sOperationA.back().iOperation == 5)
	{
		pUiData->bSyubetsuChange = pRessya->getSyubetsuChange();
	}
	else
	{
		pUiData->bSyubetsuChange = false;
	}
	if (m_iFocusIndex >= 0)
	{
		pUiData->bSelectedAfter = m_bFocusAfter;
		vector<int> iFocusLevel = { m_iFocusIndex };

		if (m_bFocusAfter)
		{
			for (int idxa = 0; idxa < (int)pUiData->sOperationA.size(); idxa++)
			{
				if (pUiData->sOperationA[idxa].iLevel == iFocusLevel)
				{
					pUiData->iListSelected = idxa;
					break;
				}
			}
		}
		else
		{
			for (int idxb = 0; idxb < (int)pUiData->sOperationB.size(); idxb++)
			{
				if (pUiData->sOperationB[idxb].iLevel == iFocusLevel)
				{
					pUiData->iListSelected = idxb;
					break;
				}
			}
		}
	}
}
void CPropEditUI_Operation::AdjustUiData( 
		UIDATA* pUiData , 
		const UIDATA* pUiDataPrev , 
		bool bStartEdit )
{
	/**
		iUiOperation0(ڍוύX)̂Ƃɍs܂B
		EiOperation̕ύXɔAsvp[^̍폜
		E͂ꂽꍇ̐K
	*/
	if (pUiData->iUiOperation == 0 &&
		pUiData->iListSelected >= 0)
	{
		vector<Operation> sOperationCont;
		vector<Operation> sOperationContPrev;
		if (pUiData->bSelectedAfter)
		{
			sOperationCont = pUiData->sOperationA;
			sOperationContPrev = pUiDataPrev->sOperationA;
		}
		else
		{
			sOperationCont = pUiData->sOperationB;
			sOperationContPrev = pUiDataPrev->sOperationB;
		}
		Operation sOprationSel;
		Operation sOprationSelPrev;
		sOprationSel = sOperationCont[pUiData->iListSelected];
		sOprationSelPrev = sOperationContPrev[pUiData->iListSelected];

		//if (pUiData->bSelectedAfter)
		//{
		//	pOprationSel = &pUiData->sOperationA[pUiData->iListSelected];
		//	pOprationSelPrev = &pUiDataPrev->sOperationA[pUiData->iListSelected];
		//}
		//else
		//{
		//	pOprationSel = &pUiData->sOperationB[pUiData->iListSelected];
		//	pOprationSelPrev = &pUiDataPrev->sOperationB[pUiData->iListSelected];
		//}

		//	Ǝ
		if (bStartEdit || sOprationSelPrev.iOperation != sOprationSel.iOperation)
		{
			if (sOprationSelPrev.iOperation == 1)
			{
				//Ƃ̏ꍇ́AOƂ폜B
				vector<int> iLevelParent = sOprationSelPrev.iLevel;
				int iDelSize = 0;
				for (int idxb = pUiData->iListSelected - 1; idxb >= 0; idxb--)
				{
					/**
						܂AidxbʒuiLevel̗vfmFAvfiDeliLevelȉȂAqƂł͂Ȃ̂ŒTIł
					*/
					if (sOperationCont[idxb].iLevel.size() <= iLevelParent.size())
					{
						break;
					}
					/**
						vfiDeliLevel葽ꍇ́AiDeliLevel̗vf܂ł̒lAv邩ۂ𒲂ׂ܂
					*/
					bool bMatch = true;
					//iAddiLevel.size()1̏ꍇ́AforɓȂȂBOɒlAƂӖňv
					for (int idxl = 0; idxl < (int)iLevelParent.size(); idxl++)
					{
						if (sOperationCont[idxb].iLevel[idxl] != iLevelParent[idxl])
						{
							/**
								lsv̏ꍇAɂ͎qƂ͖̂ŁAbMatchfalseɂĒT𔲂܂B
							*/
							bMatch = false;
							break;
						}
					}
					if (!bMatch)
					{
						break;
					}
					/**
						iDeliLevel.size()̒lvꍇA̍Ƃ͎qƂłA
						iDelPosition-1AiDelSize+1܂B(폜͌ōs)
					*/
					iDelSize++;
				}

				sOperationCont.erase(
					sOperationCont.begin() + pUiData->iListSelected - iDelSize, 
					sOperationCont.begin() + pUiData->iListSelected );
				//OƂ폜AIʒuړ
				pUiData->iListSelected -= iDelSize;
			}
			if (sOprationSelPrev.iOperation == 2)
			{
				//Ƃ̏ꍇ́AƂ폜B
				vector<int> iLevelParent = sOprationSelPrev.iLevel;
				int iDelSize = 0;
				for (int idxa = pUiData->iListSelected + 1; idxa < (int)sOperationCont.size(); idxa++)
				{
					/**
						܂AidxaʒuiLevel̗vfmFAvfiDeliLevelȉȂAqƂł͂Ȃ̂ŒTIł
					*/
					if (sOperationCont[idxa].iLevel.size() <= iLevelParent.size())
					{
						break;
					}
					/**
						vfiDeliLevel葽ꍇ́AiDeliLevel̗vf܂ł̒lAv邩ۂ𒲂ׂ܂
					*/
					bool bMatch = true;
					//iAddiLevel.size()1̏ꍇ́AforɓȂȂBOɒlAƂӖňv
					for (int idxl = 0; idxl < (int)iLevelParent.size(); idxl++)
					{
						if (sOperationCont[idxa].iLevel[idxl] != iLevelParent[idxl])
						{
							/**
								lsv̏ꍇAɂ͎qƂ͖̂ŁAbMatchfalseɂĒT𔲂܂B
							*/
							bMatch = false;
							break;
						}
					}
					if (!bMatch)
					{
						break;
					}
					/**
						iDeliLevel.size()̒lvꍇA̍Ƃ͎qƂłA
						iDelSize+1܂B(폜͌ōs)
					*/
					iDelSize++;
				}

				sOperationCont.erase(
					sOperationCont.begin() + pUiData->iListSelected + 1,
					sOperationCont.begin() + pUiData->iListSelected + iDelSize + 1);
			}

			if (sOprationSel.iOperation == 0)
			{
				/**
					ƎޕύX̏ꍇAOƂɂāAcp[^Ep[^܂
					E
						Aɂ܂B̓Zbg܂
					E
						Aɂ܂B̓Zbg܂
					E^pԍύX
						lZbg܂
				*/
				if (sOprationSelPrev.iOperation == 1)
				{
					//strEditData1AEȂ̂ŁÂ܂܎c܂
					if (pUiData->bSelectedAfter)
					{
						sOperationCont[pUiData->iListSelected].iComboData1 = m_iStandardShuntTrackIndex[1];
					}
					else
					{
						sOperationCont[pUiData->iListSelected].iComboData1 = m_iStandardShuntTrackIndex[0];
					}
					sOperationCont[pUiData->iListSelected].strEditData2.clear();
				}
				else if (sOprationSelPrev.iOperation == 2)
				{
					if (pUiData->bSelectedAfter)
					{
						sOperationCont[pUiData->iListSelected].iComboData1 = m_iStandardShuntTrackIndex[1];
					}
					else
					{
						sOperationCont[pUiData->iListSelected].iComboData1 = m_iStandardShuntTrackIndex[0];
					}
					sOperationCont[pUiData->iListSelected].strEditData1 =
						sOperationCont[pUiData->iListSelected].strEditData2;
					sOperationCont[pUiData->iListSelected].strEditData2.clear();
				}
				//else if (sOprationSelPrev.iOperation == 6)
				//{
				//	sOperationCont[pUiData->iListSelected].strOperationNumber.clear();
				//}
			}
			else if (sOprationSel.iOperation == 1)
			{
				/**
					ƎޕύX̏ꍇAOƂɂāAcp[^Ep[^܂
					E
						Aɂ܂B̓Zbg܂
					E
						Aɂ܂B̓Zbg܂
					E^pԍύX
						lZbg܂
				*/
				if (sOprationSelPrev.iOperation == 0)
				{
					//strEditData1AEȂ̂ŁÂ܂܎c܂
					sOperationCont[pUiData->iListSelected].iComboData1 = 0;
					sOperationCont[pUiData->iListSelected].strEditData2.clear();
				}
				else if (sOprationSelPrev.iOperation == 2)
				{
					sOperationCont[pUiData->iListSelected].iComboData1 = 0;
					sOperationCont[pUiData->iListSelected].strEditData1 =
						sOperationCont[pUiData->iListSelected].strEditData2;
					sOperationCont[pUiData->iListSelected].strEditData2.clear();
				}
				//else if (sOprationSelPrev.iOperation == 6)
				//{
				//	sOperationCont[pUiData->iListSelected].strOperationNumber.clear();
				//}

				//Ƃɕςꍇ́AOƂǉ܂
				Operation sOperationAdd;
				sOperationAdd.iOperation = 5;
				sOperationAdd.iLevel = sOprationSel.iLevel;
				sOperationAdd.iLevel.push_back(0);
				sOperationCont.insert(
					sOperationCont.begin() + pUiData->iListSelected,
					sOperationAdd);
				//ƒǉɂAIʒu̕␳s܂
				pUiData->iListSelected++;
			}
			else if (sOprationSel.iOperation == 2)
			{
				/**
					ƎޕύX̏ꍇAOƂɂāAcp[^Ep[^܂
					E
						Aɂ܂B̓Zbg܂
					E
						Aɂ܂B̓Zbg܂
					E^pԍύX
						lZbg܂
				*/
				if (sOprationSelPrev.iOperation == 0)
				{
					sOperationCont[pUiData->iListSelected].iComboData1 = 0;
					sOperationCont[pUiData->iListSelected].strEditData2 =
						sOperationCont[pUiData->iListSelected].strEditData1;
					sOperationCont[pUiData->iListSelected].strEditData1 = _T("1");
				}
				else if (sOprationSelPrev.iOperation == 1)
				{
					sOperationCont[pUiData->iListSelected].iComboData1 = 0;
					sOperationCont[pUiData->iListSelected].strEditData2 =
						sOperationCont[pUiData->iListSelected].strEditData1;
					sOperationCont[pUiData->iListSelected].strEditData1 = _T("1");
				}
				//else if (sOprationSelPrev.iOperation == 6)
				//{
				//	sOperationCont[pUiData->iListSelected].strOperationNumber.clear();
				//}
				//Ƃɕςꍇ́AƂǉ܂
				Operation sOperationAdd;
				sOperationAdd.iOperation = 5;
				sOperationAdd.iLevel = sOprationSel.iLevel;
				sOperationAdd.iLevel.push_back(0);
				sOperationCont.insert(
					sOperationCont.begin() + pUiData->iListSelected + 1,
					sOperationAdd);
			}
			else if (sOprationSel.iOperation == 6)
			{
				/**
					ōčl
					ƎޕύX̏ꍇAOƂɂāAcp[^Ep[^܂
					E
						lZbg܂
					E
						lZbg܂
					E
						lZbg܂
				*/
				//if (sOprationSelPrev.iOperation == 0)
				//{
				//	sOperationCont[pUiData->iListSelected].iComboData1 = 0;
				//	sOperationCont[pUiData->iListSelected].strEditData1.clear();
				//	sOperationCont[pUiData->iListSelected].strEditData2.clear();
				//}
				//if (sOprationSelPrev.iOperation == 1)
				//{
				//	//strEditData1AEȂ̂ŁÂ܂܎c܂
				//	sOperationCont[pUiData->iListSelected].iComboData1 = 0;
				//	sOperationCont[pUiData->iListSelected].strEditData2.clear();
				//}
				//else if (sOprationSelPrev.iOperation == 2)
				//{
				//	sOperationCont[pUiData->iListSelected].iComboData1 = 0;
				//	sOperationCont[pUiData->iListSelected].strEditData1 =
				//		sOperationCont[pUiData->iListSelected].strEditData2;
				//	sOperationCont[pUiData->iListSelected].strEditData2.clear();
				//}
			}
			else
			{
				bool bIsBeforeOperation = !pUiData->bSelectedAfter;
				if (sOprationSel.iLevel.size() > 1)
				{
					vector<int> iLevelSearch = sOprationSel.iLevel;
					iLevelSearch.pop_back();
					for (int idxp = 0; idxp < (int)sOperationCont.size(); idxp++)
					{
						if (sOperationCont[idxp].iLevel == iLevelSearch &&
							idxp > pUiData->iListSelected)
						{
							bIsBeforeOperation = true;
							break;
						}
						else if (sOperationCont[idxp].iLevel == iLevelSearch &&
							idxp < pUiData->iListSelected)
						{
							bIsBeforeOperation = false;
							break;
						}
					}

				}
				if (sOprationSel.iOperation == 3)
				{
					if (sOprationSel.iLevel.size() == 1)
					{
						pUiData->bSyubetsuChange = false;
					}
					if (bIsBeforeOperation &&
						sOprationSelPrev.iOperation == 4)
					{
						sOperationCont[pUiData->iListSelected].strEditData1 =
							sOperationCont[pUiData->iListSelected].strEditData2;
						sOperationCont[pUiData->iListSelected].strEditData2.clear();
					}
				}
				else if (sOprationSel.iOperation == 4)
				{
					if (sOprationSel.iLevel.size() == 1)
					{
						pUiData->bSyubetsuChange = false;
					}
					if (bIsBeforeOperation &&
						(sOprationSelPrev.iOperation == 3 ||
						sOprationSelPrev.iOperation == 5))
					{
						if ((int)m_iStandardOuterTerminalJikan.size() > sOprationSel.iComboData1 &&
							m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][0] != 0)
						{
							CdDedJikoku aBaseJikoku(pUiData->strHatsujikoku);
							if (aBaseJikoku.isNull())
							{
								aBaseJikoku.decode(pUiData->strChakujikoku);
							}
							CdDedJikoku aOuterHatsuJikoku =
								aBaseJikoku.addSeconds(-(m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][0]));
							CdDedJikoku aChakuJikoku =
								aBaseJikoku.addSeconds(-(m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][1]));
							sOperationCont[pUiData->iListSelected].strEditData1 =
								g_CdDedJikokuConv.encode(aOuterHatsuJikoku);
							sOperationCont[pUiData->iListSelected].strEditData2 =
								g_CdDedJikokuConv.encode(aChakuJikoku);
						}
						else
						{
							sOperationCont[pUiData->iListSelected].strEditData2 =
								sOperationCont[pUiData->iListSelected].strEditData1;
							sOperationCont[pUiData->iListSelected].strEditData1.clear();
						}
					}
					if (!bIsBeforeOperation &&
						(sOprationSelPrev.iOperation == 3 ||
							sOprationSelPrev.iOperation == 5))
					{
						if ((int)m_iStandardOuterTerminalJikan.size() > sOprationSel.iComboData1 &&
							m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][0] != 0)
						{
							CdDedJikoku aBaseJikoku(pUiData->strChakujikoku);
							if (aBaseJikoku.isNull())
							{
								aBaseJikoku.decode(pUiData->strHatsujikoku);
							}
							CdDedJikoku aHatsuJikoku =
								aBaseJikoku.addSeconds(m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][1]);
							CdDedJikoku aOuterChakuJikoku =
								aBaseJikoku.addSeconds(m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][0]);
							sOperationCont[pUiData->iListSelected].strEditData1 =
								g_CdDedJikokuConv.encode(aHatsuJikoku);
							sOperationCont[pUiData->iListSelected].strEditData2 =
								g_CdDedJikokuConv.encode(aOuterChakuJikoku);
						}
					}
				}
				else if (sOprationSel.iOperation == 5)
				{
					if (bIsBeforeOperation &&
						sOprationSelPrev.iOperation == 4)
					{
						sOperationCont[pUiData->iListSelected].strEditData1 =
							sOperationCont[pUiData->iListSelected].strEditData2;
						sOperationCont[pUiData->iListSelected].strEditData2.clear();
					}
				}
			}
		}



		//	iComboData1
		if (bStartEdit || sOprationSelPrev.iComboData1 != sOprationSel.iComboData1)
		{
			if (sOprationSel.iOperation == 4)
			{
				bool bIsBeforeOperation = !pUiData->bSelectedAfter;
				if (sOprationSel.iLevel.size() > 1)
				{
					vector<int> iLevelSearch = sOprationSel.iLevel;
					iLevelSearch.pop_back();
					for (int idxp = 0; idxp < (int)sOperationCont.size(); idxp++)
					{
						if (sOperationCont[idxp].iLevel == iLevelSearch &&
							idxp > pUiData->iListSelected)
						{
							bIsBeforeOperation = true;
							break;
						}
						else if (sOperationCont[idxp].iLevel == iLevelSearch &&
							idxp < pUiData->iListSelected)
						{
							bIsBeforeOperation = false;
							break;
						}
					}
				}

				if (bIsBeforeOperation)
				{
					if ((int)m_iStandardOuterTerminalJikan.size() > sOprationSel.iComboData1 &&
						m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][0] != 0)
					{
						CdDedJikoku aBaseJikoku(pUiData->strHatsujikoku);
						if (aBaseJikoku.isNull())
						{
							aBaseJikoku.decode(pUiData->strChakujikoku);
						}
						CdDedJikoku aOuterHatsuJikoku = aBaseJikoku;
						aOuterHatsuJikoku.addSeconds(-(m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][0]));
						sOperationCont[pUiData->iListSelected].strEditData1 =
							g_CdDedJikokuConv.encode(aOuterHatsuJikoku);
						if (sOprationSel.strEditData2.empty())
						{
							CdDedJikoku aChakuJikoku = aBaseJikoku;
							aChakuJikoku.addSeconds(-(m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][1]));
							sOperationCont[pUiData->iListSelected].strEditData2 =
								g_CdDedJikokuConv.encode(aChakuJikoku);
						}
					}
				}
				else
				{
					if ((int)m_iStandardOuterTerminalJikan.size() > sOprationSel.iComboData1 &&
						m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][0] != 0)
					{
						CdDedJikoku aBaseJikoku(pUiData->strChakujikoku);
						if (aBaseJikoku.isNull())
						{
							aBaseJikoku.decode(pUiData->strHatsujikoku);
						}
						CdDedJikoku aOuterChakuJikoku = aBaseJikoku;
						aOuterChakuJikoku.addSeconds(m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][0]);
						sOperationCont[pUiData->iListSelected].strEditData2 =
							g_CdDedJikokuConv.encode(aOuterChakuJikoku);
						if (sOprationSel.strEditData1.empty())
						{
							CdDedJikoku aHatsuJikoku = aBaseJikoku;
							aHatsuJikoku.addSeconds(m_iStandardOuterTerminalJikan[sOprationSel.iComboData1][1]);
							sOperationCont[pUiData->iListSelected].strEditData1 =
								g_CdDedJikokuConv.encode(aHatsuJikoku);
						}
					}
				}
			}
		}

		//--------------------------------------------------------------------------------
		//	strEditData1
		//--------------------------------------------------------------------------------
		if (bStartEdit || sOprationSelPrev.strEditData1 != sOprationSel.strEditData1)
		{
			if (sOprationSel.iOperation == 0 || sOprationSel.iOperation == 1 ||
				sOprationSel.iOperation == 3 || sOprationSel.iOperation == 4 ||
				sOprationSel.iOperation == 5)
			{
				/**
					̐K
					(1)pϊ
					(2)̕⊮
						⊮Ƃ
						(a)nwOƁEIwƁȆOƂ͌⊮
						(b)IwƁEnwOƁĚƂ͑O⊮
					ȂȀꍇ́Aŏɓ̕⊮s܂
					HOn̏ꍇ́Aŏɓw̕⊮s܂
					HOȈꍇ́AIw̕⊮͍s܂
				*/
				CdDedJikoku aJikokuOpeChaku;
				if (sOprationSel.iOperation == 0)
				{
					aJikokuOpeChaku = CdDedJikoku(
						sOprationSel.strEditData2);
					if (!aJikokuOpeChaku.isNull())
					{
						CdDedJikoku aJikokuTemp;
						int iResult = getJikokuFromUI(
							sOprationSel.strEditData1,
							aJikokuOpeChaku,
							&aJikokuTemp,
							true);
						if (iResult >= 0)
						{
							sOperationCont[pUiData->iListSelected].strEditData1 =
								g_CdDedJikokuConv.encode(aJikokuTemp);
						}
					}
				}
				if (aJikokuOpeChaku.isNull() && sOprationSel.iLevel.size() > 1)
				{
					/**
						iLevel2vfȏ゠ꍇ́AqƂȂ̂ŁAOƂƂׂKv܂
					*/
					vector<int> iLevelSearch = sOprationSel.iLevel;
					iLevelSearch.pop_back();
					for (int idxp = 0; idxp < (int)sOperationCont.size(); idxp++)
					{
						if (sOperationCont[idxp].iLevel == iLevelSearch &&
							idxp > pUiData->iListSelected)
						{
							//idxp()ɂ遨⊮AƂ
							CdDedJikoku JikokuNext;

							if (sOprationSel.iOperation == 4)//HOn
							{
								JikokuNext = CdDedJikoku(
									sOprationSel.strEditData2);
							}

							for (int idxb = pUiData->iListSelected + 1;
								idxb <= idxp && JikokuNext.isNull(); idxb++)
							{
								if (sOperationCont[idxb].iLevel.size() > sOprationSel.iLevel.size())
								{
									/**
										TӏiLevelvfAsOprationSelꍇ́A
										ʍƂ̎qƂȂ̂ŁAXLbv
									*/
									continue;
								}
								if (sOperationCont[idxb].iOperation == 0 ||
									sOperationCont[idxb].iOperation == 1)
								{
									/**
										Ȅꍇ́AstrEditData1(E)
									*/
									CdDedJikoku aJikoku(
										sOperationCont[idxb].strEditData1);
									if (!aJikoku.isNull())
									{
										JikokuNext = aJikoku;
										break;
									}
								}
								if (sOperationCont[idxb].iOperation == 0 ||
									sOperationCont[idxb].iOperation == 2)
								{
									/**
										Ȅꍇ́AstrEditData2(E)
										݂ꍇ́Abreakłɂ͓ȂB
										ƂāA̓LԂ͂ȂAꉞ
									*/
									CdDedJikoku aJikoku(
										sOperationCont[idxb].strEditData2);
									if (!aJikoku.isNull())
									{
										JikokuNext = aJikoku;
										break;
									}
								}
							}
							if (!JikokuNext.isNull())
							{
								CdDedJikoku aJikokuTemp;
								int iResult = getJikokuFromUI(
									sOprationSel.strEditData1,
									JikokuNext,
									&aJikokuTemp,
									true);
								if (iResult >= 0)
								{
									sOperationCont[pUiData->iListSelected].strEditData1 =
										g_CdDedJikokuConv.encode(aJikokuTemp);
								}
							}
							break;
						}
						else if (sOperationCont[idxp].iLevel == iLevelSearch &&
							idxp < pUiData->iListSelected)
						{
							//idxp()Oɂ遨O⊮AƂ
							CdDedJikoku JikokuPrev;
							for (int idxa = pUiData->iListSelected - 1;
								idxa >= idxp; idxa--)
							{
								if (sOperationCont[idxa].iLevel.size() > sOprationSel.iLevel.size())
								{
									/**
										TӏiLevelvfAsOprationSelꍇ́A
										ʍƂ̎qƂȂ̂ŁAXLbv
									*/
									continue;
								}
								if (sOperationCont[idxa].iOperation == 0 ||
									sOperationCont[idxa].iOperation == 2)
								{
									/**
										Ȅꍇ́AstrEditData2(E)
									*/
									CdDedJikoku aJikoku(
										sOperationCont[idxa].strEditData2);
									if (!aJikoku.isNull())
									{
										JikokuPrev = aJikoku;
										break;
									}
								}
								if (sOperationCont[idxa].iOperation == 0 ||
									sOperationCont[idxa].iOperation == 1)
								{
									/**
										Ȅꍇ́AstrEditData1(E)
										݂ꍇ́Abreakłɂ͓ȂB
									*/
									CdDedJikoku aJikoku(
										sOperationCont[idxa].strEditData1);
									if (!aJikoku.isNull())
									{
										JikokuPrev = aJikoku;
										break;
									}
								}
							}
							if (!JikokuPrev.isNull())
							{
								CdDedJikoku aJikokuTemp;
								int iResult = getJikokuFromUI(
									sOprationSel.strEditData1,
									JikokuPrev,
									&aJikokuTemp,
									false);
								if (iResult >= 0)
								{
									sOperationCont[pUiData->iListSelected].strEditData1 =
										g_CdDedJikokuConv.encode(aJikokuTemp);
								}
							}
							break;
						}
					}
				}
				else if (aJikokuOpeChaku.isNull() && ((m_iHatsuEkiOrder >= 0 && pUiData->bSelectedAfter) ||
					(m_iChakuEkiOrder < 0 && !pUiData->bSelectedAfter)))
				{
					CdDedJikoku JikokuNext;
					if (m_iChakuEkiOrder < 0 && !pUiData->bSelectedAfter)
					{
						/**
							nwOƂ̏ꍇ́A܂OƂɌB
							HOn̏ꍇ́AwŏɌ
						*/

						if (sOprationSel.iOperation == 4)//HOn
						{
							JikokuNext = CdDedJikoku(
								sOprationSel.strEditData2);
						}

						for (int idxb = pUiData->iListSelected + 1;
							idxb < (int)pUiData->sOperationB.size() && JikokuNext.isNull(); idxb++)
						{
							if (pUiData->sOperationB[idxb].iLevel.size() > 1)
							{
								continue;
							}
							if (pUiData->sOperationB[idxb].iOperation == 0 ||
								pUiData->sOperationB[idxb].iOperation == 1)
							{
								/**
									Ȅꍇ́AstrEditData1(E)
								*/
								CdDedJikoku aJikoku(
									pUiData->sOperationB[idxb].strEditData1);
								if (!aJikoku.isNull())
								{
									JikokuNext = aJikoku;
									break;
								}
							}
							if (pUiData->sOperationB[idxb].iOperation == 0 ||
								pUiData->sOperationB[idxb].iOperation == 2)
							{
								/**
									Ȅꍇ́AstrEditData2(E)
									݂ꍇ́Abreakłɂ͓ȂB
									ƂāA̓LԂ͂ȂAꉞ
								*/
								CdDedJikoku aJikoku(
									pUiData->sOperationB[idxb].strEditData2);
								if (!aJikoku.isNull())
								{
									JikokuNext = aJikoku;
									break;
								}
							}
						}
					}
					int idxa = 0;
					if (m_iHatsuEkiOrder >= 0 && pUiData->bSelectedAfter)
					{
						/**
							ƒT̏ʒuB
							nwOƂȂ0A
							ƂȂAXgIʒü
						*/
						idxa = pUiData->iListSelected + 1;
					}
					for (; idxa < (int)pUiData->sOperationA.size() && JikokuNext.isNull()
						; idxa++)
					{
						if (pUiData->sOperationA[idxa].iLevel.size() > 1)
						{
							continue;
						}
						if (pUiData->sOperationA[idxa].iOperation == 0 ||
							pUiData->sOperationA[idxa].iOperation == 1)
						{
							/**
								Ȅꍇ́AstrEditData1(E)
							*/
							CdDedJikoku aJikoku(
								pUiData->sOperationA[idxa].strEditData1);
							if (!aJikoku.isNull())
							{
								JikokuNext = aJikoku;
								break;
							}

						}
						if (pUiData->sOperationA[idxa].iOperation == 0 ||
							pUiData->sOperationA[idxa].iOperation == 2)
						{
							/**
								Ȅꍇ́AstrEditData2(E)
								݂ꍇ́Abreakłɂ͓ȂB
								ƂāA̓LԂ͂ȂAꉞ
							*/
							CdDedJikoku aJikoku(
								pUiData->sOperationA[idxa].strEditData2);
							if (!aJikoku.isNull())
							{
								JikokuNext = aJikoku;
								break;
							}

						}
					}
					if (JikokuNext.isNull())
					{
						/**
							ƂׂČāA̎ȂA
						*/
						JikokuNext = CdDedJikoku(pUiData->strHatsujikoku);
					}
					if (!JikokuNext.isNull())
					{
						CdDedJikoku aJikokuTemp;
						int iResult = getJikokuFromUI(
							sOprationSel.strEditData1,
							JikokuNext,
							&aJikokuTemp,
							true);
						if (iResult >= 0)
						{
							sOperationCont[pUiData->iListSelected].strEditData1 =
								g_CdDedJikokuConv.encode(aJikokuTemp);
						}
					}

				}
				else if (aJikokuOpeChaku.isNull())
				{
					CdDedJikoku JikokuPrev;
					if (m_iHatsuEkiOrder < 0 && pUiData->bSelectedAfter)
					{
						/**
							IwƂ̏ꍇ́A܂ƂOɌB
						*/
						for (int idxa = pUiData->iListSelected - 1;
							idxa >= 0 && JikokuPrev.isNull(); idxa--)
						{
							if (pUiData->sOperationA[idxa].iLevel.size() > 1)
							{
								continue;
							}
							if (pUiData->sOperationA[idxa].iOperation == 0 ||
								pUiData->sOperationA[idxa].iOperation == 2)
							{
								/**
									Ȅꍇ́AstrEditData2(E)
								*/
								CdDedJikoku aJikoku(
									pUiData->sOperationA[idxa].strEditData2);
								if (!aJikoku.isNull())
								{
									JikokuPrev = aJikoku;
									break;
								}
							}
							if (pUiData->sOperationA[idxa].iOperation == 0 ||
								pUiData->sOperationA[idxa].iOperation == 1)
							{
								/**
									Ȅꍇ́AstrEditData1(E)
									݂ꍇ́Abreakłɂ͓ȂB
								*/
								CdDedJikoku aJikoku(
									pUiData->sOperationA[idxa].strEditData1);
								if (!aJikoku.isNull())
								{
									JikokuPrev = aJikoku;
									break;
								}
							}
						}
					}
					int idxb = pUiData->sOperationB.size() - 1;
					if (m_iChakuEkiOrder >= 0 && !pUiData->bSelectedAfter)
					{
						/**
							OƒT̏ʒuB
							IwƂȂ烊XgA
							OƂȂAXgIʒüォ
						*/
						idxb = pUiData->iListSelected - 1;
					}
					for (; idxb >= 0 && JikokuPrev.isNull()
						; idxb--)
					{
						if (pUiData->sOperationB[idxb].iLevel.size() > 1)
						{
							continue;
						}
						if (pUiData->sOperationB[idxb].iOperation == 0 ||
							pUiData->sOperationB[idxb].iOperation == 2)
						{
							/**
								Ȅꍇ́AstrEditData2(E)
							*/
							CdDedJikoku aJikoku(
								pUiData->sOperationB[idxb].strEditData2);
							if (!aJikoku.isNull())
							{
								JikokuPrev = aJikoku;
								break;
							}

						}
						if (pUiData->sOperationB[idxb].iOperation == 0 ||
							pUiData->sOperationB[idxb].iOperation == 1)
						{
							/**
								Ȅꍇ́AstrEditData1(E)
								݂ꍇ́Abreakłɂ͓ȂB
							*/
							CdDedJikoku aJikoku(
								pUiData->sOperationB[idxb].strEditData1);
							if (!aJikoku.isNull())
							{
								JikokuPrev = aJikoku;
								break;
							}

						}
					}
					if (JikokuPrev.isNull())
					{
						/**
							OƂׂČāAO̎ȂA
						*/
						JikokuPrev = CdDedJikoku(pUiData->strChakujikoku);
					}
					if (!JikokuPrev.isNull())
					{
						CdDedJikoku aJikokuTemp;
						int iResult = getJikokuFromUI(
							sOprationSel.strEditData1,
							JikokuPrev,
							&aJikokuTemp,
							false);
						if (iResult >= 0)
						{
							sOperationCont[pUiData->iListSelected].strEditData1 =
								g_CdDedJikokuConv.encode(aJikokuTemp);
						}
					}
				}
			}

			if (sOprationSel.iOperation == 0)
			{
				//	̑OlEݒlE̓͂擾
				CdDedJikoku	jikokuOperationHatsuPrev(sOprationSelPrev.strEditData1);
				CdDedJikoku	jikokuOperationHatsu(sOprationSel.strEditData1);
				CdDedJikoku jikokuOperationChaku(sOprationSel.strEditData2);
				if (!jikokuOperationHatsuPrev.isNull()
					&& !jikokuOperationHatsu.isNull()
					&& !jikokuOperationChaku.isNull())
				{
					jikokuOperationChaku.addSeconds(jikokuOperationHatsu.subJikoku(jikokuOperationHatsuPrev));
					sOperationCont[pUiData->iListSelected].strEditData2 = g_CdDedJikokuConv.encode(jikokuOperationChaku);
				}
			}
		}


		//--------------------------------------------------------------------------------
		//	strEditData2
		//--------------------------------------------------------------------------------
		if (bStartEdit || sOprationSelPrev.strEditData2 != sOprationSel.strEditData2)
		{
			if (sOprationSel.iOperation == 0 || sOprationSel.iOperation == 2 ||
				sOprationSel.iOperation == 4)
			{
				/**
					̐K
					(1)pϊ
					(2)̕⊮
						⊮Ƃ
						(a)nwOƁEIwƁȆOƂ͌⊮
						(b)IwƁEnwOƁĚƂ͑O⊮
					ȂȀꍇ́Aŏɓ̕⊮s
					HOn̏ꍇ́Anw̕⊮͍sȂ
					HOȈꍇ́Aw̕⊮s
				*/
				CdDedJikoku aJikokuOpeHatsu;
				if (sOprationSel.iOperation == 0)
				{
					aJikokuOpeHatsu = CdDedJikoku(
						sOprationSel.strEditData1);
					if (!aJikokuOpeHatsu.isNull())
					{
						CdDedJikoku aJikokuTemp;
						int iResult = getJikokuFromUI(
							sOprationSel.strEditData2,
							aJikokuOpeHatsu,
							&aJikokuTemp,
							false);
						if (iResult >= 0)
						{
							sOperationCont[pUiData->iListSelected].strEditData2 =
								g_CdDedJikokuConv.encode(aJikokuTemp);
						}
					}
				}
				if (aJikokuOpeHatsu.isNull() && sOprationSel.iLevel.size() > 1)
				{

					/**
						iLevel2vfȏ゠ꍇ́AqƂȂ̂ŁAOƂƂׂKv܂
					*/
					vector<int> iLevelSearch = sOprationSel.iLevel;
					iLevelSearch.pop_back();
					for (int idxp = 0; idxp < (int)sOperationCont.size(); idxp++)
					{
						if (sOperationCont[idxp].iLevel == iLevelSearch &&
							idxp > pUiData->iListSelected)
						{
							//idxp()ɂ遨⊮AƂ
							CdDedJikoku JikokuNext;
							for (int idxb = pUiData->iListSelected + 1;
								idxb <= idxp && JikokuNext.isNull(); idxb++)
							{
								if (sOperationCont[idxb].iLevel.size() > sOprationSel.iLevel.size())
								{
									/**
										TӏiLevelvfAsOprationSelꍇ́A
										ʍƂ̎qƂȂ̂ŁAXLbv
									*/
									continue;
								}
								if (sOperationCont[idxb].iOperation == 0 ||
									sOperationCont[idxb].iOperation == 1)
								{
									/**
										Ȅꍇ́AstrEditData1(E)
									*/
									CdDedJikoku aJikoku(
										sOperationCont[idxb].strEditData1);
									if (!aJikoku.isNull())
									{
										JikokuNext = aJikoku;
										break;
									}
								}
								if (sOperationCont[idxb].iOperation == 0 ||
									sOperationCont[idxb].iOperation == 2)
								{
									/**
										Ȅꍇ́AstrEditData2(E)
										݂ꍇ́Abreakłɂ͓ȂB
										ƂāA̓LԂ͂ȂAꉞ
									*/
									CdDedJikoku aJikoku(
										sOperationCont[idxb].strEditData2);
									if (!aJikoku.isNull())
									{
										JikokuNext = aJikoku;
										break;
									}
								}
							}
							if (!JikokuNext.isNull())
							{
								CdDedJikoku aJikokuTemp;
								int iResult = getJikokuFromUI(
									sOprationSel.strEditData2,
									JikokuNext,
									&aJikokuTemp,
									true);
								if (iResult >= 0)
								{
									sOperationCont[pUiData->iListSelected].strEditData2 =
										g_CdDedJikokuConv.encode(aJikokuTemp);
								}
							}
							break;
						}
						else if (sOperationCont[idxp].iLevel == iLevelSearch &&
							idxp < pUiData->iListSelected)
						{
							//idxp()Oɂ遨O⊮AƂ
							CdDedJikoku JikokuPrev;

							if (sOprationSel.iOperation == 4)//HOI
							{
								JikokuPrev = CdDedJikoku(
									sOprationSel.strEditData1);
							}

							for (int idxa = pUiData->iListSelected - 1;
								idxa >= idxp && JikokuPrev.isNull(); idxa--)
							{
								if (sOperationCont[idxa].iLevel.size() > sOprationSel.iLevel.size())
								{
									/**
										TӏiLevelvfAsOprationSelꍇ́A
										ʍƂ̎qƂȂ̂ŁAXLbv
									*/
									continue;
								}
								if (sOperationCont[idxa].iOperation == 0 ||
									sOperationCont[idxa].iOperation == 2)
								{
									/**
										Ȅꍇ́AstrEditData2(E)
									*/
									CdDedJikoku aJikoku(
										sOperationCont[idxa].strEditData2);
									if (!aJikoku.isNull())
									{
										JikokuPrev = aJikoku;
										break;
									}
								}
								if (sOperationCont[idxa].iOperation == 0 ||
									sOperationCont[idxa].iOperation == 1)
								{
									/**
										Ȅꍇ́AstrEditData1(E)
										݂ꍇ́Abreakłɂ͓ȂB
									*/
									CdDedJikoku aJikoku(
										sOperationCont[idxa].strEditData1);
									if (!aJikoku.isNull())
									{
										JikokuPrev = aJikoku;
										break;
									}
								}
							}
							if (!JikokuPrev.isNull())
							{
								CdDedJikoku aJikokuTemp;
								int iResult = getJikokuFromUI(
									sOprationSel.strEditData2,
									JikokuPrev,
									&aJikokuTemp,
									false);
								if (iResult >= 0)
								{
									sOperationCont[pUiData->iListSelected].strEditData2 =
										g_CdDedJikokuConv.encode(aJikokuTemp);
								}
							}
							break;
						}
					}
				}
				else if (aJikokuOpeHatsu.isNull() && ((m_iHatsuEkiOrder >= 0 && pUiData->bSelectedAfter) ||
					(m_iChakuEkiOrder < 0 && !pUiData->bSelectedAfter)))
				{
					CdDedJikoku JikokuNext;
					if (m_iChakuEkiOrder < 0 && !pUiData->bSelectedAfter)
					{
						/**
							nwOƂ̏ꍇ́A܂OƂɌB
						*/
						for (int idxb = pUiData->iListSelected + 1;
							idxb < (int)pUiData->sOperationB.size(); idxb++)
						{
							if (pUiData->sOperationB[idxb].iLevel.size() > 1)
							{
								continue;
							}
							if (pUiData->sOperationB[idxb].iOperation == 0 ||
								pUiData->sOperationB[idxb].iOperation == 1)
							{
								/**
									Ȅꍇ́AstrEditData1(E)
								*/
								CdDedJikoku aJikoku(
									pUiData->sOperationB[idxb].strEditData1);
								if (!aJikoku.isNull())
								{
									JikokuNext = aJikoku;
									break;
								}
							}
							if (pUiData->sOperationB[idxb].iOperation == 0 ||
								pUiData->sOperationB[idxb].iOperation == 2)
							{
								/**
									Ȅꍇ́AstrEditData2(E)
									݂ꍇ́Abreakłɂ͓ȂB
									ƂāA̓LԂ͂ȂAꉞ
								*/
								CdDedJikoku aJikoku(
									pUiData->sOperationB[idxb].strEditData2);
								if (!aJikoku.isNull())
								{
									JikokuNext = aJikoku;
									break;
								}
							}
						}
					}
					int idxa = 0;
					if (m_iHatsuEkiOrder >= 0 && pUiData->bSelectedAfter)
					{
						/**
							ƒT̏ʒuB
							nwOƂȂ0A
							ƂȂAXgIʒü
						*/
						idxa = pUiData->iListSelected + 1;
					}
					for (; idxa < (int)pUiData->sOperationA.size() && JikokuNext.isNull()
						; idxa++)
					{
						if (pUiData->sOperationA[idxa].iLevel.size() > 1)
						{
							continue;
						}
						if (pUiData->sOperationA[idxa].iOperation == 0 ||
							pUiData->sOperationA[idxa].iOperation == 1)
						{
							/**
								Ȅꍇ́AstrEditData1(E)
							*/
							CdDedJikoku aJikoku(
								pUiData->sOperationA[idxa].strEditData1);
							if (!aJikoku.isNull())
							{
								JikokuNext = aJikoku;
								break;
							}

						}
						if (pUiData->sOperationA[idxa].iOperation == 0 ||
							pUiData->sOperationA[idxa].iOperation == 2)
						{
							/**
								Ȅꍇ́AstrEditData2(E)
								݂ꍇ́Abreakłɂ͓ȂB
								ƂāA̓LԂ͂ȂAꉞ
							*/
							CdDedJikoku aJikoku(
								pUiData->sOperationA[idxa].strEditData2);
							if (!aJikoku.isNull())
							{
								JikokuNext = aJikoku;
								break;
							}

						}
					}
					if (JikokuNext.isNull())
					{
						/**
							ƂׂČāA̎ȂA
						*/
						JikokuNext = CdDedJikoku(pUiData->strHatsujikoku);
					}
					if (!JikokuNext.isNull())
					{
						CdDedJikoku aJikokuTemp;
						int iResult = getJikokuFromUI(
							sOprationSel.strEditData2,
							JikokuNext,
							&aJikokuTemp,
							true);
						if (iResult >= 0)
						{
							sOperationCont[pUiData->iListSelected].strEditData2 =
								g_CdDedJikokuConv.encode(aJikokuTemp);
						}
					}

				}
				else if (aJikokuOpeHatsu.isNull())
				{
					CdDedJikoku JikokuPrev;
					if (m_iHatsuEkiOrder < 0 && pUiData->bSelectedAfter)
					{
						/**
							IwƂ̏ꍇ́A܂ƂOɌB
							AHOȈꍇ́AwŏɌ
						*/
						if (sOprationSel.iOperation == 4)//HOI
						{
							JikokuPrev = CdDedJikoku(
								sOprationSel.strEditData1);
						}
						for (int idxa = pUiData->iListSelected - 1;
							idxa >= 0 && JikokuPrev.isNull(); idxa--)
						{
							if (pUiData->sOperationA[idxa].iLevel.size() > 1)
							{
								continue;
							}
							if (pUiData->sOperationA[idxa].iOperation == 0 ||
								pUiData->sOperationA[idxa].iOperation == 2)
							{
								/**
									Ȅꍇ́AstrEditData2(E)
								*/
								CdDedJikoku aJikoku(
									pUiData->sOperationA[idxa].strEditData2);
								if (!aJikoku.isNull())
								{
									JikokuPrev = aJikoku;
									break;
								}
							}
							if (pUiData->sOperationA[idxa].iOperation == 0 ||
								pUiData->sOperationA[idxa].iOperation == 1)
							{
								/**
									Ȅꍇ́AstrEditData1(E)
									݂ꍇ́Abreakłɂ͓ȂB
								*/
								CdDedJikoku aJikoku(
									pUiData->sOperationA[idxa].strEditData1);
								if (!aJikoku.isNull())
								{
									JikokuPrev = aJikoku;
									break;
								}
							}
						}
					}
					int idxb = pUiData->sOperationB.size() - 1;
					if (m_iChakuEkiOrder >= 0 && !pUiData->bSelectedAfter)
					{
						/**
							OƒT̏ʒuB
							IwƂȂ烊XgA
							OƂȂAXgIʒüォ
						*/
						idxb = pUiData->iListSelected - 1;
					}
					for (;idxb >= 0 && JikokuPrev.isNull()
						; idxb--)
					{
						if (pUiData->sOperationB[idxb].iLevel.size() > 1)
						{
							continue;
						}
						if (pUiData->sOperationB[idxb].iOperation == 0 ||
							pUiData->sOperationB[idxb].iOperation == 2)
						{
							/**
								Ȅꍇ́AstrEditData2(E)
							*/
							CdDedJikoku aJikoku(
								pUiData->sOperationB[idxb].strEditData2);
							if (!aJikoku.isNull())
							{
								JikokuPrev = aJikoku;
								break;
							}

						}
						if (pUiData->sOperationB[idxb].iOperation == 0 ||
							pUiData->sOperationB[idxb].iOperation == 1)
						{
							/**
								Ȅꍇ́AstrEditData1(E)
								݂ꍇ́Abreakłɂ͓ȂB
							*/
							CdDedJikoku aJikoku(
								pUiData->sOperationB[idxb].strEditData1);
							if (!aJikoku.isNull())
							{
								JikokuPrev = aJikoku;
								break;
							}

						}
					}
					if (JikokuPrev.isNull())
					{
						/**
							OƂׂČāAO̎ȂA
						*/
						JikokuPrev = CdDedJikoku(pUiData->strChakujikoku);
					}
					if (!JikokuPrev.isNull())
					{
						CdDedJikoku aJikokuTemp;
						int iResult = getJikokuFromUI(
							sOprationSel.strEditData2,
							JikokuPrev,
							&aJikokuTemp,
							false);
						if (iResult >= 0)
						{
							sOperationCont[pUiData->iListSelected].strEditData2 =
								g_CdDedJikokuConv.encode(aJikokuTemp);
						}
					}
				}
			}
		}

		if (pUiData->bSelectedAfter)
		{
			pUiData->sOperationA = sOperationCont;
		}
		else
		{
			pUiData->sOperationB = sOperationCont;
		}
	}
	if (pUiData->iUiOperation == 2 &&
		pUiData->iListSelected >= 0)
	{
		vector<Operation> sOperationCont;
		if (pUiData->bSelectedAfter)
		{
			sOperationCont = pUiData->sOperationA;
		}
		else
		{
			sOperationCont = pUiData->sOperationB;
		}

		if (sOperationCont[pUiData->iListSelected].iOperation == 0)
		{
			if (pUiData->bSelectedAfter)
			{
				sOperationCont[pUiData->iListSelected].iComboData1 = m_iStandardShuntTrackIndex[1];
			}
			else
			{
				sOperationCont[pUiData->iListSelected].iComboData1 = m_iStandardShuntTrackIndex[0];
			}
		}

		if (pUiData->bSelectedAfter)
		{
			pUiData->sOperationA = sOperationCont;
		}
		else
		{
			pUiData->sOperationB = sOperationCont;
		}
	}
}

int CPropEditUI_Operation::CheckBeforeOperation(
	const vector<Operation>& sOperationB,
	const vector<int> iLevelSearch,
	int& iListErrorPos,
	vector<int>& iLevelErrorPos)
{
	int iRv = 0;
	/**
		܂́A͈͂̍vюƎʂłȂ`FbNA
		̌A󔒎̕⊮sB**󔒎̕⊮́AUiDataToTargetōsB
	*/

		for (int idx = 0; idx < (int)sOperationB.size() && iRv >= 0; idx++)
		{

			const Operation& pOperation = sOperationB[idx];
			/**
				`FbNΏۂƂȂ̂
				(1)iLevel̏ʁuiLevelSearch.size()vAiLevelSearch.size()ƈv
				(2)iLevel.size()iLevelSearch.size()+1Ɠ
				(1)iLevelSearch̏ꍇ́AiLevel.size()1̕SĂΏۂɂȂB
				(2)iLevelSearch(1,2)̏ꍇ́AiLevel(1.2.0)(1.2.2)ΏۂƂȂA
					(1.1.0)(1.2.1.0)͑ΏۂɂȂȂ
			*/

			if (pOperation.iLevel.size() != iLevelSearch.size() + 1)
			{
				continue;
			}
			bool bMatchiLevel = true;
			for (int idxl = 0; idxl < (int)iLevelSearch.size() && bMatchiLevel; idxl++)
			{
				if (pOperation.iLevel[idxl] != iLevelSearch[idxl])
				{
					bMatchiLevel = false;
				}
			}
			if (!bMatchiLevel)
			{
				continue;
			}

			if (pOperation.iOperation == 0)
			{
				/**
					̏ꍇ
						EsłȂ𒲂ׂ
				*/
				if (iRv >= 0)
				{
					CdDedJikoku aJikoku;
					int iResult = aJikoku.decode(pOperation.strEditData1);
					if (iResult < 0)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -201;
					}
				}

				if (iRv >= 0)
				{
					CdDedJikoku aJikoku;
					int iResult = aJikoku.decode(pOperation.strEditData2);
					if (iResult < 0)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -202;
					}
				}
			}
			else if (pOperation.iOperation == 1)
			{
				/**
					̏ꍇ
						słȂ𒲂ׂ

					Ґ̑OƂ̃`FbNsB
				*/
				if (iRv >= 0)
				{
					CdDedJikoku aJikoku;
					int iResult = aJikoku.decode(pOperation.strEditData1);
					if (iResult < 0)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -211;
					}
				}
				if (iRv >= 0)
				{
					iRv = CheckBeforeOperation(
						sOperationB,
						pOperation.iLevel,
						iListErrorPos,
						iLevelErrorPos);
				}
			}
			else if (pOperation.iOperation == 2)
			{
				/**
					̏ꍇ
						słȂ𒲂ׂ
						ʒuIndexł邩ǂA1-10͈̔͂Ɏ܂Ă邩𒲂ׂ

					̏ꍇApJikokuBackƂ݂ȂA
					Ґ̌Ƃ̃`FbNsB
				*/
				if (iRv >= 0)
				{
					CdDedJikoku aJikoku;
					int iResult = aJikoku.decode(pOperation.strEditData2);
					if (iResult < 0)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -221;
					}
				}

				if (iRv >= 0 && !pOperation.strEditData1.empty())
				{
					try
					{
						int iResult = stoi(pOperation.strEditData1);

						if (iResult < 1 || iResult>10)
						{
							iListErrorPos = idx;
							iLevelErrorPos = pOperation.iLevel;
							iRv = -225;
						}
					}
					catch (std::invalid_argument e)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -223;
					}
					catch (std::out_of_range e)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -224;
					}

				}

				if (iRv >= 0)
				{
					iRv = CheckAfterOperation(
						sOperationB,
						pOperation.iLevel,
						iListErrorPos,
						iLevelErrorPos);
				}
			}
			else if (pOperation.iOperation == 3)
			{
				/**
					ȍꍇ
						o掞słȂ𒲂ׂ
						^pԍ','܂܂ĂȂǂ𒲂ׂ
				*/
				if (iRv >= 0)
				{
					CdDedJikoku aJikoku;
					int iResult = aJikoku.decode(pOperation.strEditData1);
					if (iResult < 0)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -231;
					}
				}

				if (iRv >= 0 && !pOperation.strOperationNumber.empty())
				{
					for (int idxon = 0; idxon < (int)pOperation.strOperationNumber.size(); idxon++)
					{
						if (pOperation.strOperationNumber[idxon].find(',') != tstring::npos)
						{
							iListErrorPos = idx;
							iLevelErrorPos = pOperation.iLevel;
							iRv = -235;
							break;
						}
					}

				}
			}
			else if (pOperation.iOperation == 4)
			{
				/**
					HOn̏ꍇ
						HOnwEwsłȂ𒲂ׂ
						HOnẃȀꍇłG[ɂ
						^pԍ','܂܂ĂȂǂ𒲂ׂ
				*/
				if (iRv >= 0)
				{
					CdDedJikoku aJikoku;
					int iResult = aJikoku.decode(pOperation.strEditData1);
					if (iResult < 0)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -241;
					}
				}

				if (iRv >= 0)
				{
					CdDedJikoku aJikoku;
					int iResult = aJikoku.decode(pOperation.strEditData2);
					if (iResult < 0)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -242;
					}
				}

				if (iRv >= 0 && pOperation.strEditData1.empty())
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -244;
				}

				if (iRv >= 0 && !pOperation.strOperationNumber.empty())
				{
					for (int idxon = 0; idxon < (int)pOperation.strOperationNumber.size(); idxon++)
					{
						if (pOperation.strOperationNumber[idxon].find(',') != tstring::npos)
						{
							iListErrorPos = idx;
							iLevelErrorPos = pOperation.iLevel;
							iRv = -235;
							break;
						}
					}
				}
			}
			else if (pOperation.iOperation == 5)
			{
				/**
					OԐڑ̏ꍇ
						N_słȂ𒲂ׂ
						^pԍ','܂܂ĂȂǂ𒲂ׂ
				*/
				if (iRv >= 0)
				{
					CdDedJikoku aJikoku;
					int iResult = aJikoku.decode(pOperation.strEditData1);
					if (iResult < 0)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -251;
					}
				}
				if (iRv >= 0 && !pOperation.strOperationNumber.empty())
				{
					for (int idxon = 0; idxon < (int)pOperation.strOperationNumber.size(); idxon++)
					{
						if (pOperation.strOperationNumber[idxon].find(',') != tstring::npos)
						{
							iListErrorPos = idx;
							iLevelErrorPos = pOperation.iLevel;
							iRv = -235;
							break;
						}
					}

				}
			}
			else if (pOperation.iOperation == 6)
			{
				/**
					^pԍύX̏ꍇ
						^pԍ󔒂ǂ𒲂ׂ
						^pԍ','܂܂ĂȂǂ𒲂ׂ
				*/
				if (iRv >= 0)
				{
					if (pOperation.strOperationNumber.empty())
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -261;
					}
				}
				if (iRv >= 0 && !pOperation.strOperationNumber.empty())
				{
					for (int idxon = 0; idxon < (int)pOperation.strOperationNumber.size(); idxon++)
					{
						if (pOperation.strOperationNumber[idxon].find(',') != tstring::npos)
						{
							iListErrorPos = idx;
							iLevelErrorPos = pOperation.iLevel;
							iRv = -235;
							break;
						}
					}

				}
			}
		}
	return iRv;
}

int CPropEditUI_Operation::CheckAfterOperation(
	const vector<Operation>& sOperationA,
	const vector<int> iLevelSearch,
	int& iListErrorPos,
	vector<int>& iLevelErrorPos)
{
	int iRv = 0;
	/**
		܂́A͈͂̍vюƎʂłȂ`FbNA
		̌A󔒎̕⊮sB**󔒎̕⊮́AUiDataToTargetōsB
	*/
	for (int idx = 0; idx < (int)sOperationA.size() && iRv >= 0; idx++)
	{

		const Operation& pOperation = sOperationA[idx];
		/**
			`FbNΏۂƂȂ̂
			(1)iLevel̏ʁuiLevelSearch.size()vAiLevelSearch.size()ƈv
			(2)iLevel.size()iLevelSearch.size()+1Ɠ
			(1)iLevelSearch̏ꍇ́AiLevel.size()1̕SĂΏۂɂȂB
			(2)iLevelSearch(1,2)̏ꍇ́AiLevel(1.2.0)(1.2.2)ΏۂƂȂA
				(1.1.0)(1.2.1.0)͑ΏۂɂȂȂ
		*/
		if (pOperation.iLevel.size() != iLevelSearch.size() + 1)
		{
			continue;
		}
		bool bMatchiLevel = true;
		for (int idxl = 0; idxl < (int)iLevelSearch.size() && bMatchiLevel; idxl++)
		{
			if (pOperation.iLevel[idxl] != iLevelSearch[idxl])
			{
				bMatchiLevel = false;
			}
		}
		if (!bMatchiLevel)
		{
			continue;
		}

		if (pOperation.iOperation == 0)
		{
			/**
				̏ꍇ
					EsłȂ𒲂ׂ
			*/
			if (iRv >= 0)
			{
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pOperation.strEditData1);
				if (iResult < 0)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -301;
				}
			}

			if (iRv >= 0)
			{
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pOperation.strEditData2);
				if (iResult < 0)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -302;
				}
			}
		}
		else if (pOperation.iOperation == 1)
		{
			/**
				̏ꍇ
					słȂ𒲂ׂ

				̏ꍇApJikokuFrontƂ݂ȂA
				Ґ̑OƂ̃`FbNsB
			*/
			if (iRv >= 0)
			{
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pOperation.strEditData1);
				if (iResult < 0)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -311;
				}
			}


			if (iRv >= 0)
			{
				iRv = CheckBeforeOperation(
					sOperationA,
					pOperation.iLevel,
					iListErrorPos,
					iLevelErrorPos);
			}

		}
		else if (pOperation.iOperation == 2)
		{
			/**
				̏ꍇ
					słȂ𒲂ׂ
					ʒuIndexł邩ǂA1-10͈̔͂Ɏ܂Ă邩𒲂ׂ

				̏ꍇApJikokuFrontƂ݂ȂA
				Ґ̌Ƃ̃`FbNsB
			*/
			if (iRv >= 0)
			{
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pOperation.strEditData2);
				if (iResult < 0)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -321;
				}
			}

			if (iRv >= 0 && !pOperation.strEditData1.empty())
			{
				try
				{
					int iResult = stoi(pOperation.strEditData1);

					if (iResult < 1 || iResult>10)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -325;
					}
				}
				catch (std::invalid_argument e)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -323;
				}
				catch (std::out_of_range e)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -324;
				}

			}

			if (iRv >= 0)
			{
				iRv = CheckAfterOperation(
					sOperationA,
					pOperation.iLevel,
					iListErrorPos,
					iLevelErrorPos);
			}
		}
		else if (pOperation.iOperation == 3)
		{
			/**
				̏ꍇ
					掞słȂ𒲂ׂ
			*/
			if (iRv >= 0)
			{
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pOperation.strEditData1);
				if (iResult < 0)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -333;
				}
			}
		}
		else if (pOperation.iOperation == 4)
		{
			/**
				HOȈꍇ
					wEHOIwsłȂ𒲂ׂ
					HOIẃA͈̓`FbN̑Ώۂɂ͂ȂB
					HOIẃȀꍇłG[ɂ
			*/
			if (iRv >= 0)
			{
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pOperation.strEditData1);
				if (iResult < 0)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -345;
				}
			}

			if (iRv >= 0)
			{
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pOperation.strEditData2);
				if (iResult < 0)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -346;
				}
			}

			if (iRv >= 0 && pOperation.strEditData2.empty())
			{
				iListErrorPos = idx;
				iLevelErrorPos = pOperation.iLevel;
				iRv = -348;
			}
		}
		else if (pOperation.iOperation == 5)
		{
			/**
				Ԑڑ̏ꍇ
					I_słȂ𒲂ׂ
			*/
			if (iRv >= 0)
			{
				CdDedJikoku aJikoku;
				int iResult = aJikoku.decode(pOperation.strEditData1);
				if (iResult < 0)
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -352;
				}
			}
		}
		else if (pOperation.iOperation == 6)
		{
			/**
				^pԍύX̏ꍇ
						^pԍ󔒂ǂ𒲂ׂ
					^pԍ','܂܂ĂȂǂ𒲂ׂ
			*/
			if (iRv >= 0)
			{
				if (pOperation.strOperationNumber.empty())
				{
					iListErrorPos = idx;
					iLevelErrorPos = pOperation.iLevel;
					iRv = -361;
				}
			}
			if (iRv >= 0 && !pOperation.strOperationNumber.empty())
			{
				for (int idxon = 0; idxon < (int)pOperation.strOperationNumber.size(); idxon++)
				{
					if (pOperation.strOperationNumber[idxon].find(',') != tstring::npos)
					{
						iListErrorPos = idx;
						iLevelErrorPos = pOperation.iLevel;
						iRv = -335;
						break;
					}
				}
			}
		}
	}
	return iRv;
}

int CPropEditUI_Operation::CheckUiData( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{
	int iRv = 0 ; 

	/**
		̃`FbN
			ҏWΏۂԉw̏ꍇ́AɑSĂ̎܂ĂȂ΂ȂȂ
				ȂAT́AOƁƂ̏ɂȂ̂ŁA
				Ƃ͈̔͂́AOƂ̍ŏIɂȂB
			nw̏ꍇ́AO24ԈȓɑSĂ̎܂ĂȂ΂ȂȂ
				ȂAT́AƁOƂ̏ɂȂ̂ŁA
				OƂ͈̔͂́AƂ̔24ԑOŏ̎ɂȂB
			Iw̏ꍇ́A24ԈȓɑSĂ̎܂ĂȂ΂ȂȂ
				ȂAT́AOƁƂ̏ɂȂ̂ŁA
				Ƃ͈̔͂́AOƂ̍ŏI24ԌɂȂB

		̏`FbN͕svɂAs`̌ôݍsB
	*/
	vector<int> iLevelErrorPos;
	int iListErrorPos = -1;
	bool bErrorIsAfter;

	if (iRv >= 0)
	{
		bErrorIsAfter = false;
		iRv = CheckBeforeOperation(
			pUiData->sOperationB,
			vector<int>(),
			iListErrorPos,
			iLevelErrorPos);
	}

	if (iRv >= 0)
	{
		bErrorIsAfter = true;
		iRv = CheckAfterOperation(
			pUiData->sOperationA,
			vector<int>(),
			iListErrorPos,
			iLevelErrorPos);
	}
	//// --------------------------------
	////	G[bZ[W\܂
	//// --------------------------------
	if ( iRv < 0 )
	{
		tstring strInfo;
		if (bErrorIsAfter)
		{
			strInfo = _T("(");
		}
		else
		{
			strInfo = _T("(O");
		}

		vector<tstring> strLevel;
		for (int idx = 0; idx < (int)iLevelErrorPos.size(); idx++)
		{
			strLevel.push_back(to_tstring(iLevelErrorPos[idx]));
		}
		strInfo += joinc('.', strLevel);
		strInfo += _T(")");

		switch( iRv )
		{
		case -101:
		case -201:
		case -301:
		case -401:
			ShowError(ERRMSG_INVALID_SHUNTHATSUJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			//SetFocus2(offsetof(Operation, strEditData1),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		case -102:
		case -202:
		case -302:
		case -402:
			ShowError(ERRMSG_INVALID_SHUNTCHAKUJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData2));
			//SetFocus2(offsetof(Operation, strEditData2),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		//case -103:
		//case -203:
		//case -303:
		//case -403:
		//	ShowError(ERRMSG_OUTOFRANGE_SHUNTHATSUJIKOKU);
		//	SetFocus2(offsetof(Operation, strEditData1),
		//		iListErrorPos,
		//		bErrorIsAfter);
		//	break;
		//case -104:
		//case -204:
		//case -304:
		//case -404:
		//	ShowError(ERRMSG_OUTOFRANGE_SHUNTCHAKUJIKOKU);
		//	SetFocus2(offsetof(Operation, strEditData2),
		//		iListErrorPos,
		//		bErrorIsAfter);
		//	break;

		case -111:
		case -211:
		case -311:
		case -411:
			ShowError(ERRMSG_INVALID_CONNECTJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			//SetFocus2(offsetof(Operation, strEditData1),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		//case -112:
		//case -212:
		//case -312:
		//case -412:
		//	ShowError(ERRMSG_OUTOFRANGE_CONNECTJIKOKU);
		//	SetFocus2(offsetof(Operation, strEditData1),
		//		iListErrorPos,
		//		bErrorIsAfter);
		//	break;

		case -121:
		case -221:
		case -321:
		case -421:
			ShowError(ERRMSG_INVALID_RELEASEJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData2));
			//SetFocus2(offsetof(Operation, strEditData2),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		//case -122:
		//case -222:
		//case -322:
		//case -422:
		//	ShowError(ERRMSG_OUTOFRANGE_RELEASEJIKOKU);
		//	SetFocus2(offsetof(Operation, strEditData2),
		//		iListErrorPos,
		//		bErrorIsAfter);
		//	break;

		case -123:
		case -223:
		case -323:
		case -423:
			ShowError(ERRMSG_INVALID_RELEASEINDEX,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			//SetFocus2(offsetof(Operation, strEditData1),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		case -124:
		case -224:
		case -324:
		case -424:
		case -125:
		case -225:
		case -325:
		case -425:
			ShowError(ERRMSG_OUTOFRANGE_RELEASEINDEX,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			//SetFocus2(offsetof(Operation, strEditData1),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;

		case -131:
		case -231:
		case -331:
		case -431:
			ShowError(ERRMSG_INVALID_OUTJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			//SetFocus2(offsetof(Operation, strEditData1),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		//case -132:
		//case -232:
		//case -332:
		//case -432:
		//	ShowError(ERRMSG_OUTOFRANGE_OUTJIKOKU);
		//	SetFocus2(offsetof(Operation, strEditData1),
		//		iListErrorPos,
		//		bErrorIsAfter);
		//	break;
		case -133:
		case -233:
		case -333:
		case -433:
			ShowError(ERRMSG_INVALID_INJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			//SetFocus2(offsetof(Operation, strEditData1),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		//case -134:
		//case -234:
		//case -334:
		//case -434:
		//	ShowError(ERRMSG_OUTOFRANGE_INJIKOKU);
		//	SetFocus2(offsetof(Operation, strEditData1),
		//		iListErrorPos,
		//		bErrorIsAfter);
		//	break;
		case -235:
		case -335:
			ShowError(ERRMSG_UNUSABLE_COMMA);
			SetFocus(offsetof(Operation, strOperationNumber));
			break;

		case -141:
		case -241:
		case -341:
		case -441:
			ShowError(ERRMSG_INVALID_OUTERHATSUJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			//SetFocus2(offsetof(Operation, strEditData1),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		case -142:
		case -242:
		case -342:
		case -442:
			ShowError(ERRMSG_INVALID_CHAKUJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData2));
			//SetFocus2(offsetof(Operation, strEditData2),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		//case -143:
		//case -243:
		//case -343:
		//case -443:
		//	ShowError(ERRMSG_OUTOFRANGE_CHAKUJIKOKU);
		//	SetFocus2(offsetof(Operation, strEditData2),
		//		iListErrorPos,
		//		bErrorIsAfter);
		//	break;
		case -144:
		case -244:
		case -344:
		case -444:
			ShowError(ERRMSG_EMPTY_OUTERHATSUJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			//SetFocus2(offsetof(Operation, strEditData1),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		case -145:
		case -245:
		case -345:
		case -445:
			ShowError(ERRMSG_INVALID_HATSUJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			//SetFocus2(offsetof(Operation, strEditData1),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		case -146:
		case -246:
		case -346:
		case -446:
			ShowError(ERRMSG_INVALID_OUTERCHAKUJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData2));
			//SetFocus2(offsetof(Operation, strEditData2),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		//case -147:
		//case -247:
		//case -347:
		//case -447:
		//	ShowError(ERRMSG_OUTOFRANGE_HATSUJIKOKU);
		//	SetFocus2(offsetof(Operation, strEditData1),
		//		iListErrorPos,
		//		bErrorIsAfter);
		//	break;
		case -148:
		case -248:
		case -348:
		case -448:
			ShowError(ERRMSG_EMPTY_OUTERCHAKUJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData2));
			//SetFocus2(offsetof(Operation, strEditData2),
			//	iListErrorPos,
			//	bErrorIsAfter);
			break;
		case -251:
			ShowError(ERRMSG_INVALID_ORIGINJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			break;
		case -352:
			ShowError(ERRMSG_INVALID_TERMINALJIKOKU,
				strInfo);
			SetFocus(offsetof(Operation, strEditData1));
			break;
		//case -161:
		case -261:
		case -361:
		//case -461:
			ShowError(ERRMSG_EMPTY_OPERATIONNUMBER,
				strInfo);
			SetFocus(offsetof(Operation, strOperationNumber));
		}
	}
	return iRv ;
}

void CPropEditUI_Operation::BeforeOperationComplement(
	vector<Operation>& sOperationB,
	const vector<int> iLevelTarget,
	CdDedJikoku& pSourceJikoku,
	const bool bSupplyFromFront,
	const bool bIsTeisya)
{
	CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);

	if (bSupplyFromFront)
	{
		for (int idx = 0; idx < (int)sOperationB.size(); idx++)
		{
			Operation& pOperation = sOperationB[idx];
			/**
				`FbNΏۂƂȂ̂
				(1)iLevel̏ʁuiLevelSearch.size()vAiLevelSearch.size()ƈv
				(2)iLevel.size()iLevelSearch.size()+1Ɠ
				(1)iLevelSearch̏ꍇ́AiLevel.size()1̕SĂΏۂɂȂB
				(2)iLevelSearch(1,2)̏ꍇ́AiLevel(1.2.0)(1.2.2)ΏۂƂȂA
					(1.1.0)(1.2.1.0)͑ΏۂɂȂȂ
			*/

			if (pOperation.iLevel.size() != iLevelTarget.size() + 1)
			{
				continue;
			}
			bool bMatchiLevel = true;
			for (int idxl = 0; idxl < (int)iLevelTarget.size() && bMatchiLevel; idxl++)
			{
				if (pOperation.iLevel[idxl] != iLevelTarget[idxl])
				{
					bMatchiLevel = false;
				}
			}
			if (!bMatchiLevel)
			{
				continue;
			}

			if (pOperation.iOperation == 0)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikoku1̂ŕ⊮
						AłȂꍇ́Aŕ⊮
						łȂꍇ́AXVB
						͋ł悢̂ŁA̍XV̂ݍs
				*/
				if (pOperation.strEditData1.empty())
				{
					if (pOperation.strEditData2.empty())
					{
						pSourceJikoku.addSeconds(+60);
						pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
					}
					else
					{
						pOperation.strEditData1 = pOperation.strEditData2;
					}
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData1);
				}

				if (!pOperation.strEditData2.empty())
				{
					pSourceJikoku.decode(pOperation.strEditData2);
				}


			}
			else if (pOperation.iOperation == 1)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikokuŕ⊮

					Ґ̑OƂ̃`FbNsB
				*/
				if (pOperation.strEditData1.empty())
				{
					pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData1);
				}
				CdDedJikoku aConnectJikoku(pOperation.strEditData1);
				BeforeOperationComplement(
					sOperationB,
					pOperation.iLevel,
					aConnectJikoku,
					false,
					bIsTeisya);
			}
			else if (pOperation.iOperation == 2)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikokuŕ⊮
						ʒuIndex̏ꍇ́A1

					Ґ̌Ƃ̃`FbNsB
				*/
				if (pOperation.strEditData2.empty())
				{
					pOperation.strEditData2 = aJikokuConv.encode(pSourceJikoku);
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData2);
				}
				if (pOperation.strEditData1.empty())
				{
					pOperation.strEditData1 = _T("1");
				}
				CdDedJikoku aReleaseJikoku(pOperation.strEditData2);
				AfterOperationComplement(
					sOperationB,
					pOperation.iLevel,
					aReleaseJikoku,
					true,
					bIsTeisya);
			}
		}
	}
	else
	{
		for (int idx = sOperationB.size() - 1; idx >= 0; idx--)
		{
			Operation& pOperation = sOperationB[idx];
			/**
				`FbNΏۂƂȂ̂
				(1)iLevel̏ʁuiLevelSearch.size()vAiLevelSearch.size()ƈv
				(2)iLevel.size()iLevelSearch.size()+1Ɠ
				(1)iLevelSearch̏ꍇ́AiLevel.size()1̕SĂΏۂɂȂB
				(2)iLevelSearch(1,2)̏ꍇ́AiLevel(1.2.0)(1.2.2)ΏۂƂȂA
					(1.1.0)(1.2.1.0)͑ΏۂɂȂȂ
			*/

			if (pOperation.iLevel.size() != iLevelTarget.size() + 1)
			{
				continue;
			}
			bool bMatchiLevel = true;
			for (int idxl = 0; idxl < (int)iLevelTarget.size() && bMatchiLevel; idxl++)
			{
				if (pOperation.iLevel[idxl] != iLevelTarget[idxl])
				{
					bMatchiLevel = false;
				}
			}
			if (!bMatchiLevel)
			{
				continue;
			}

			if (pOperation.iOperation == 0)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikoku1Ẑŕ⊮B
						AłȂꍇ́Aŕ⊮
						łȂꍇ́AXVB
						͋ł悢̂ŁA̍XV̂ݍs
				*/
				if (pOperation.strEditData1.empty())
				{
					if (pOperation.strEditData2.empty())
					{
						pSourceJikoku.addSeconds(-60);
						pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
					}
					else
					{
						pOperation.strEditData1 = pOperation.strEditData2;
					}
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData1);
				}

			}
			else if (pOperation.iOperation == 1)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikokuŕ⊮

					Ґ̑OƂ̃`FbNsB
				*/
				if (pOperation.strEditData1.empty())
				{
					pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData1);
				}
				CdDedJikoku aConnectJikoku(pOperation.strEditData1);
				BeforeOperationComplement(
					sOperationB,
					pOperation.iLevel,
					aConnectJikoku,
					false,
					bIsTeisya);
			}
			else if (pOperation.iOperation == 2)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikokuŕ⊮
						ʒuIndex̏ꍇ́A1

					Ґ̌Ƃ̃`FbNsB
				*/
				if (pOperation.strEditData2.empty())
				{
					pOperation.strEditData2 = aJikokuConv.encode(pSourceJikoku);
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData2);
				}
				if (pOperation.strEditData1.empty())
				{
					pOperation.strEditData1 = _T("1");
				}
				CdDedJikoku aReleaseJikoku(pOperation.strEditData2);
				AfterOperationComplement(
					sOperationB,
					pOperation.iLevel,
					aReleaseJikoku,
					true,
					bIsTeisya);
			}
			else if (pOperation.iOperation == 3)
			{
				/**
					ȍꍇ
						o掞̏ꍇ́ApSourceJikoku1Ẑŕ⊮
				*/
				if (pOperation.strEditData1.empty())
				{
					pSourceJikoku.addSeconds(-60);
					pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
				}
			}
			//19.11.26 HOnɂāAw͋ł悢Ƃɂ
			//19.12.22 ʉ߂̏ꍇ̂݁Aŵ܂܂ɂ悤ɕύX
			else if (pOperation.iOperation == 4 &&
				bIsTeisya)
			{
				/**
					HOn̏ꍇ
						HOnw̏ꍇ̓G[Ȃ̂ŁAł̓`FbNȂB
						w̏ꍇ́ApSourceJikoku1Ẑŕ⊮
				*/
				if (pOperation.strEditData2.empty())
				{
					pSourceJikoku.addSeconds(-60);
					pOperation.strEditData2 = aJikokuConv.encode(pSourceJikoku);
				}
			}
		}
	}
}

void CPropEditUI_Operation::BeforeOperationToTarget(
	CentDedBeforeOperationCont * pCentDedBeforeOperationCont,
	const vector<Operation> sOperationB/*,
	const vector<int> iLevelTarget,
	CdDedJikoku& pSourceJikoku,
	const bool bSupplyFromFront*/)
{
	int iSetInsertCount = 0;
	for (int idx = 0; idx < (int)sOperationB.size(); idx++)
	{
		Operation sOperationTemp = sOperationB[idx];
		CentDedBeforeOperation aBeforeOperation;
		if (sOperationTemp.iLevel.size() > 1)
		{
			/**
				iLevel.size() > 1ɊYƂ́A
				pCentDedBeforOperationeContɊi[Ƃ̎qƂɂ邽߁A
				XLbvB
			*/
			continue;
		}
		else if (sOperationTemp.iOperation == 0)//
		{
			aBeforeOperation =
				CentDedBeforeOperation(
					CentDedBeforeOperation::BOperation_Shunt,
					sOperationTemp.iComboData1,
					CdDedJikoku(sOperationTemp.strEditData1),
					CdDedJikoku(sOperationTemp.strEditData2),
					sOperationTemp.bCheckData1);
		}
		else if (sOperationTemp.iOperation == 1)//
		{
			aBeforeOperation =
				CentDedBeforeOperation(
					CentDedBeforeOperation::BOperation_Connect,
					sOperationTemp.iComboData1,
					CdDedJikoku(sOperationTemp.strEditData1));
			/**
				̍Ƃ̎qƂ߂
				sOperationBTemp͂̍Ƃ̎qƂƂȂOperationzƂȂB
				ƂsOperationBA
				(1)iLevel[0]̍Ƃƈv́@
				(2)̍ƎgȊO(indexvȂ)
				𔲂óB̎AiLevel[0]͍폜Ă
			*/
			vector<Operation> sOperationBTemp;
			for (int idxb = 0; idxb < (int)sOperationB.size(); idxb++)
			{
				Operation sOperationTemp2 = sOperationB[idxb];
				if (sOperationTemp2.iLevel.front() == sOperationTemp.iLevel.front()
					&& idx != idxb)
				{
					sOperationTemp2.iLevel.erase(sOperationTemp2.iLevel.begin());
					sOperationBTemp.push_back(sOperationTemp2);
				}
			}
			BeforeOperationToTarget(
				aBeforeOperation.getCentDedBeforeOperationCont(),
				sOperationBTemp);
		}
		else if (sOperationTemp.iOperation == 2)//
		{
			aBeforeOperation =
				CentDedBeforeOperation(
					CentDedBeforeOperation::BOperation_Release,
					sOperationTemp.iComboData1,
					stoi(sOperationTemp.strEditData1),
					CdDedJikoku(sOperationTemp.strEditData2));
			/**
				̍Ƃ̎qƂ߂
				sOperationATemp͂̍Ƃ̎qƂƂȂOperationzƂȂB
				ƂsOperationBA
				(1)pCentDedBeforeOperationContɓƁiLevel.size()=1̂
				(2)pCentDedBeforeOperationContɓ鑼̍Ƃ̎qƂƂȂ
					iLevel[0]̒lA̍ƂƈقȂ
				菜́B̎AiLevel[0]͍폜Ă
			*/
			vector<Operation> sOperationATemp;
			for (int idxa = 0; idxa < (int)sOperationB.size(); idxa++)
			{
				Operation sOperationTemp2 = sOperationB[idxa];
				if (sOperationTemp2.iLevel.front() == sOperationTemp.iLevel.front()
					&& idx != idxa)
				{
					sOperationTemp2.iLevel.erase(sOperationTemp2.iLevel.begin());
					sOperationATemp.push_back(sOperationTemp2);
				}
			}
			AfterOperationToTarget(
				aBeforeOperation.getCentDedAfterOperationCont(),
				sOperationATemp);
		}
		else if (sOperationTemp.iOperation == 3)//o
		{
			aBeforeOperation =
				CentDedBeforeOperation(
					CentDedBeforeOperation::BOperation_Out,
					CdDedJikoku(sOperationTemp.strEditData1),
					sOperationTemp.strOperationNumber);
		}
		else if (sOperationTemp.iOperation == 4)//HOn
		{
			aBeforeOperation =
				CentDedBeforeOperation(
					CentDedBeforeOperation::BOperation_Outer,
					sOperationTemp.iComboData1,
					CdDedJikoku(sOperationTemp.strEditData1),
					CdDedJikoku(sOperationTemp.strEditData2),
					sOperationTemp.strOperationNumber);
		}
		else if (sOperationTemp.iOperation == 5)//OԐڑ
		{
			aBeforeOperation =
				CentDedBeforeOperation(
					CentDedBeforeOperation::BOperation_Junction,
					CdDedJikoku(sOperationTemp.strEditData1),
					sOperationTemp.bCheckData1,
					sOperationTemp.strOperationNumber);
		}
		else if (sOperationTemp.iOperation == 6)//^pԍύX
		{
			aBeforeOperation =
				CentDedBeforeOperation(
					CentDedBeforeOperation::BOperation_NumberChange,
					sOperationTemp.strOperationNumber);
		}
		else//(Ƃǉ)
		{
			continue;
		}

		if (sOperationTemp.iLevel.front() < pCentDedBeforeOperationCont->size())
		{
			pCentDedBeforeOperationCont->set(aBeforeOperation, sOperationTemp.iLevel.front());
		}
		else
		{
			pCentDedBeforeOperationCont->insert(aBeforeOperation);
		}
		iSetInsertCount++;
	}

	if (iSetInsertCount < pCentDedBeforeOperationCont->size())
	{
		pCentDedBeforeOperationCont->erase(iSetInsertCount, INT_MAX);
	}

}
void CPropEditUI_Operation::AfterOperationComplement(
	vector<Operation>& sOperationA,
	const vector<int> iLevelTarget,
	CdDedJikoku & pSourceJikoku,
	const bool bSupplyFromFront,
	const bool bIsTeisya)
{
	CdDedJikoku::CConv	aJikokuConv(g_CdDedJikokuConv);

	if (bSupplyFromFront)
	{
		for (int idx = 0; idx < (int)sOperationA.size(); idx++)
		{
			Operation& pOperation = sOperationA[idx];
			/**
				`FbNΏۂƂȂ̂
				(1)iLevel̏ʁuiLevelSearch.size()vAiLevelSearch.size()ƈv
				(2)iLevel.size()iLevelSearch.size()+1Ɠ
				(1)iLevelSearch̏ꍇ́AiLevel.size()1̕SĂΏۂɂȂB
				(2)iLevelSearch(1,2)̏ꍇ́AiLevel(1.2.0)(1.2.2)ΏۂƂȂA
					(1.1.0)(1.2.1.0)͑ΏۂɂȂȂ
			*/

			if (pOperation.iLevel.size() != iLevelTarget.size() + 1)
			{
				continue;
			}
			bool bMatchiLevel = true;
			for (int idxl = 0; idxl < (int)iLevelTarget.size() && bMatchiLevel; idxl++)
			{
				if (pOperation.iLevel[idxl] != iLevelTarget[idxl])
				{
					bMatchiLevel = false;
				}
			}
			if (!bMatchiLevel)
			{
				continue;
			}

			if (pOperation.iOperation == 0)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikoku1̂ŕ⊮
						AłȂꍇ́Aŕ⊮
						łȂꍇ́AXVB
						͋ł悢̂ŁA̍XV̂ݍs
				*/
				if (pOperation.strEditData1.empty())
				{
					if (pOperation.strEditData2.empty())
					{
						pSourceJikoku.addSeconds(+60);
						pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
					}
					else
					{
						pOperation.strEditData1 = pOperation.strEditData2;
					}
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData1);
				}

				if (!pOperation.strEditData2.empty())
				{
					pSourceJikoku.decode(pOperation.strEditData2);
				}


			}
			else if (pOperation.iOperation == 1)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikokuŕ⊮

					Ґ̑OƂ̃`FbNsB
				*/
				if (pOperation.strEditData1.empty())
				{
					pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData1);
				}
				CdDedJikoku aConnectJikoku(pOperation.strEditData1);
				BeforeOperationComplement(
					sOperationA,
					pOperation.iLevel,
					aConnectJikoku,
					false,
					bIsTeisya);
			}
			else if (pOperation.iOperation == 2)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikokuŕ⊮
						ʒuIndex̏ꍇ́A1

					Ґ̌Ƃ̃`FbNsB
				*/
				if (pOperation.strEditData2.empty())
				{
					pOperation.strEditData2 = aJikokuConv.encode(pSourceJikoku);
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData2);
				}
				if (pOperation.strEditData1.empty())
				{
					pOperation.strEditData1 = _T("1");
				}
				CdDedJikoku aReleaseJikoku(pOperation.strEditData2);
				AfterOperationComplement(
					sOperationA,
					pOperation.iLevel,
					aReleaseJikoku,
					true,
					bIsTeisya);
			}
			else if (pOperation.iOperation == 3)
			{
				/**
					̏ꍇ
						掞̏ꍇ́ApSourceJikoku1̂ŕ⊮
				*/
				if (pOperation.strEditData1.empty())
				{
					pSourceJikoku.addSeconds(+60);
					pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
				}
			}
			//19.11.26 HOIɂāAw͋ł悢Ƃɂ
			//19.12.22 ʉ߂̏ꍇ̂݁Aŵ܂܂ɂ悤ɕύX
			else if (pOperation.iOperation == 4 &&
				bIsTeisya)
			{
				/**
					HOȈꍇ
						HOIw̏ꍇ̓G[Ȃ̂ŁAł̓`FbNȂB
						w̏ꍇ́ApSourceJikoku1̂ŕ⊮
				*/
				if (pOperation.strEditData1.empty())
				{
					pSourceJikoku.addSeconds(+60);
					pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
				}
			}
		}
	}
	else
	{
		for (int idx = sOperationA.size() - 1; idx >= 0; idx--)
		{
			Operation& pOperation = sOperationA[idx];
			/**
				`FbNΏۂƂȂ̂
				(1)iLevel̏ʁuiLevelSearch.size()vAiLevelSearch.size()ƈv
				(2)iLevel.size()iLevelSearch.size()+1Ɠ
				(1)iLevelSearch̏ꍇ́AiLevel.size()1̕SĂΏۂɂȂB
				(2)iLevelSearch(1,2)̏ꍇ́AiLevel(1.2.0)(1.2.2)ΏۂƂȂA
					(1.1.0)(1.2.1.0)͑ΏۂɂȂȂ
			*/

			if (pOperation.iLevel.size() != iLevelTarget.size() + 1)
			{
				continue;
			}
			bool bMatchiLevel = true;
			for (int idxl = 0; idxl < (int)iLevelTarget.size() && bMatchiLevel; idxl++)
			{
				if (pOperation.iLevel[idxl] != iLevelTarget[idxl])
				{
					bMatchiLevel = false;
				}
			}
			if (!bMatchiLevel)
			{
				continue;
			}

			if (pOperation.iOperation == 0)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikoku1Ẑŕ⊮B
						AłȂꍇ́Aŕ⊮
						łȂꍇ́AXVB
						͋ł悢̂ŁA̍XV̂ݍs
				*/
				if (pOperation.strEditData1.empty())
				{
					if (pOperation.strEditData2.empty())
					{
						pSourceJikoku.addSeconds(-60);
						pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
					}
					else
					{
						pOperation.strEditData1 = pOperation.strEditData2;
					}
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData1);
				}

			}
			else if (pOperation.iOperation == 1)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikokuŕ⊮

					Ґ̑OƂ̃`FbNsB
				*/
				if (pOperation.strEditData1.empty())
				{
					pOperation.strEditData1 = aJikokuConv.encode(pSourceJikoku);
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData1);
				}
				CdDedJikoku aConnectJikoku(pOperation.strEditData1);
				BeforeOperationComplement(
					sOperationA,
					pOperation.iLevel,
					aConnectJikoku,
					false,
					bIsTeisya);
			}
			else if (pOperation.iOperation == 2)
			{
				/**
					̏ꍇ
						̏ꍇ́ApSourceJikokuŕ⊮
						ʒuIndex̏ꍇ́A1

					Ґ̌Ƃ̃`FbNsB
				*/
				if (pOperation.strEditData2.empty())
				{
					pOperation.strEditData2 = aJikokuConv.encode(pSourceJikoku);
				}
				else
				{
					pSourceJikoku.decode(pOperation.strEditData2);
				}
				if (pOperation.strEditData1.empty())
				{
					pOperation.strEditData1 = _T("1");
				}
				CdDedJikoku aReleaseJikoku(pOperation.strEditData2);
				AfterOperationComplement(
					sOperationA,
					pOperation.iLevel,
					aReleaseJikoku,
					true,
					bIsTeisya);
			}
		}
	}
}
void CPropEditUI_Operation::AfterOperationToTarget(
	CentDedAfterOperationCont * pCentDedAfterOperationCont,
	const vector<Operation> sOperationA/*,
	CdDedJikoku& pSourceJikoku,
	const bool bSupplyFromFront*/)
{
	int iSetInsertCount = 0;
	for (int idx = 0; idx < (int)sOperationA.size(); idx++)
	{
		Operation sOperationTemp = sOperationA[idx];
		CentDedAfterOperation aAfterOperation;
		if (sOperationTemp.iLevel.size() > 1)
		{
			/**
				iLevel.size() > 1ɊYƂ́A
				pCentDedOperationAfterContɊi[Ƃ̎qƂɂ邽߁A
				XLbvB
			*/
			continue;
		}
		else if (sOperationTemp.iOperation == 0)//
		{
			aAfterOperation =
				CentDedAfterOperation(
					CentDedAfterOperation::AOperation_Shunt,
					sOperationTemp.iComboData1,
					CdDedJikoku(sOperationTemp.strEditData1),
					CdDedJikoku(sOperationTemp.strEditData2),
					sOperationTemp.bCheckData1);
		}
		else if (sOperationTemp.iOperation == 1)//
		{
			aAfterOperation =
				CentDedAfterOperation(
					CentDedAfterOperation::AOperation_Connect,
					sOperationTemp.iComboData1,
					CdDedJikoku(sOperationTemp.strEditData1));
			/**
				̍Ƃ̎qƂ߂
				sOperationBTemp͂̍Ƃ̎qƂƂȂOperationzƂȂB
				ƂsOperationAA
				(1)iLevel[0]̍Ƃƈv́@
				(2)̍ƎgȊO(indexvȂ)
				𔲂óB̎AiLevel[0]͍폜Ă
			*/
			vector<Operation> sOperationBTemp;
			for (int idxb = 0; idxb < (int)sOperationA.size(); idxb++)
			{
				Operation sOperationTemp2 = sOperationA[idxb];
				if (sOperationTemp2.iLevel.front() == sOperationTemp.iLevel.front()
					&& idx != idxb)
				{
					sOperationTemp2.iLevel.erase(sOperationTemp2.iLevel.begin());
					sOperationBTemp.push_back(sOperationTemp2);
				}
			}
			BeforeOperationToTarget(
				aAfterOperation.getCentDedBeforeOperationCont(),
				sOperationBTemp);
		}
		else if (sOperationTemp.iOperation == 2)//
		{
			aAfterOperation =
				CentDedAfterOperation(
					CentDedAfterOperation::AOperation_Release,
					sOperationTemp.iComboData1,
					stoi(sOperationTemp.strEditData1),
					CdDedJikoku(sOperationTemp.strEditData2));
			/**
				̍Ƃ̎qƂ߂
				sOperationATemp͂̍Ƃ̎qƂƂȂOperationzƂȂB
				ƂsOperationBA
				(1)pCentDedBeforeOperationContɓƁiLevel.size()=1̂
				(2)pCentDedBeforeOperationContɓ鑼̍Ƃ̎qƂƂȂ
					iLevel[0]̒lA̍ƂƈقȂ
				菜́B̎AiLevel[0]͍폜Ă
			*/
			vector<Operation> sOperationATemp;
			for (int idxa = 0; idxa < (int)sOperationA.size(); idxa++)
			{
				Operation sOperationTemp2 = sOperationA[idxa];
				if (sOperationTemp2.iLevel.front() == sOperationTemp.iLevel.front()
					&& idx != idxa)
				{
					sOperationTemp2.iLevel.erase(sOperationTemp2.iLevel.begin());
					sOperationATemp.push_back(sOperationTemp2);
				}
			}
			AfterOperationToTarget(
				aAfterOperation.getCentDedAfterOperationCont(),
				sOperationATemp);
		}
		else if (sOperationTemp.iOperation == 3)//
		{
			aAfterOperation =
				CentDedAfterOperation(
					CentDedAfterOperation::AOperation_In,
					CdDedJikoku(sOperationTemp.strEditData1));
		}
		else if (sOperationTemp.iOperation == 4)//HOI
		{
			aAfterOperation =
				CentDedAfterOperation(
					CentDedAfterOperation::AOperation_Outer,
					sOperationTemp.iComboData1,
					CdDedJikoku(sOperationTemp.strEditData1),
					CdDedJikoku(sOperationTemp.strEditData2));
		}
		else if (sOperationTemp.iOperation == 5)//Ԑڑ
		{
			aAfterOperation =
				CentDedAfterOperation(
					CentDedAfterOperation::AOperation_Junction,
					CdDedJikoku(sOperationTemp.strEditData1),
					sOperationTemp.bCheckData1);
		}
		else if (sOperationTemp.iOperation == 6)//^pԍύX
		{
			aAfterOperation =
				CentDedAfterOperation(
					CentDedAfterOperation::AOperation_NumberChange,
					sOperationTemp.strOperationNumber);
		}
		else//(Ƃǉ)
		{
			continue;
		}

		if (sOperationTemp.iLevel.front() < pCentDedAfterOperationCont->size())
		{
			pCentDedAfterOperationCont->set(aAfterOperation, sOperationTemp.iLevel.front());
		}
		else
		{
			pCentDedAfterOperationCont->insert(aAfterOperation);
		}
		iSetInsertCount++;
	}

	if (iSetInsertCount < pCentDedAfterOperationCont->size())
	{
		pCentDedAfterOperationCont->erase(iSetInsertCount, INT_MAX);
	}
}

int CPropEditUI_Operation::UiDataToTarget( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{

	int iRv = 0 ; 
	CentDedRessya* pRessya = m_pTarget->get( 0 ) ; 

	int iChakuEkiOrder = m_iChakuEkiOrder;
	if (iChakuEkiOrder == -1)
	{
		iChakuEkiOrder = m_iHatsuEkiOrder;
	}
	int iHatsuEkiOrder = m_iHatsuEkiOrder;
	if (iHatsuEkiOrder == -1)
	{
		iHatsuEkiOrder = m_iChakuEkiOrder;
	}

	bool bIsTeisya = pRessya->getCentDedEkiJikokuCont()
		->getMuPtr()->get(iChakuEkiOrder)->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya;

	vector<Operation> sOperationB = pUiData->sOperationB;
	vector<Operation> sOperationA = pUiData->sOperationA;
	if (m_iChakuEkiOrder == -1)//wn
	{

		/**
			 ⊮
		*/
		CdDedJikoku aHatsuJikoku(pUiData->strHatsujikoku);

		AfterOperationComplement(
			sOperationA,
			vector<int>(),
			aHatsuJikoku,
			false,
			bIsTeisya);

		/**
			O ⊮ sA͌Ƃp
		*/
		BeforeOperationComplement(
			sOperationB,
			vector<int>(),
			aHatsuJikoku,
			false,
			bIsTeisya);
	}
	else if (m_iHatsuEkiOrder == -1)//w~܂
	{
		/**
			O ⊮
		*/
		CdDedJikoku aChakuJikoku(pUiData->strChakujikoku);

		BeforeOperationComplement(
			sOperationB,
			vector<int>(),
			aChakuJikoku,
			true,
			bIsTeisya);

		/**
			 ⊮ OsA͑OƂp
		*/
		AfterOperationComplement(
			sOperationA,
			vector<int>(),
			aChakuJikoku,
			true,
			bIsTeisya);

	}
	else
	{
		/**
			O ⊮
		*/
		CdDedJikoku aChakuJikoku(pUiData->strChakujikoku);

		BeforeOperationComplement(
			sOperationB,
			vector<int>(),
			aChakuJikoku,
			true,
			bIsTeisya);

		/**
			 ⊮
		*/
		CdDedJikoku aHatsuJikoku(pUiData->strHatsujikoku);

		AfterOperationComplement(
			sOperationA,
			vector<int>(),
			aHatsuJikoku,
			false,
			bIsTeisya);

	}
	/**
		O
	*/
	CentDedEkiJikoku* pChakuEkiJikoku = pRessya->getCentDedEkiJikokuCont()
		->getMuPtr()->get(iChakuEkiOrder);
	
	BeforeOperationToTarget(
		pChakuEkiJikoku->getCentDedBeforeOperationCont(),
		sOperationB);

	/**
		
	*/
	CentDedEkiJikoku* pHatsuEkiJikoku = pRessya->getCentDedEkiJikokuCont()
		->getMuPtr()->get(iHatsuEkiOrder);

	AfterOperationToTarget(
		pHatsuEkiJikoku->getCentDedAfterOperationCont(),
		sOperationA);
	
	/**
		ʕύX
	*/
	if (bNewItem
		|| pUiDataStartEdit->bSyubetsuChange != pUiData->bSyubetsuChange)
	{
		if (m_iHatsuEkiOrder < 0 && pUiData->sOperationA.back().iOperation == 5)
		{
			pRessya->setSyubetsuChange(pUiData->bSyubetsuChange);
		}
		else
		{
			pRessya->setSyubetsuChange(false);
		}
	}
	return iRv ;
}	



	// ********************************
	//	RXgN^
	// ********************************
CPropEditUI_Operation::CPropEditUI_Operation( 
		bool bNewItem , 
		Mu<CentDedRessya*>* pTarget , 
		int iChakuEkiOrder,
		int iHatsuEkiOrder,
		bool bFocusAfter,
		int iFocusIndex,
		int iStandardShuntTrackIndex[],
		vector<vector<int>> iStandardOuterTerminalJikan)
		: CPropEditUi2( bNewItem ) 
		, m_pTarget( pTarget ) 
		, m_iChakuEkiOrder(iChakuEkiOrder)
		, m_iHatsuEkiOrder(iHatsuEkiOrder)
		,m_iStandardOuterTerminalJikan(iStandardOuterTerminalJikan)
	, m_bFocusAfter(bFocusAfter)
	, m_iFocusIndex(iFocusIndex)
{
	m_iStandardShuntTrackIndex[0] = iStandardShuntTrackIndex[0];
	m_iStandardShuntTrackIndex[1] = iStandardShuntTrackIndex[1];
}



} //namespace ViewJikokuhyou

