/*
	OuDiaSecond Copyright (C) 2017-2020 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdDedJikoku.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include "CdDedJikoku.h"
#include "str\strprintf.h"
#include <tchar.h>

using namespace std ;

#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif

namespace entDed{
	using namespace OuLib::Str;

// ****************************************************************
//	CdDedJikoku::CConv
// ****************************************************************
CdDedJikoku::CConv::CConv() 
	: m_bNoColon( false )
	, m_eHour( EHour_Zero )
	, m_eSecond( ESecond_Output )
	, m_eSecondRoundChaku(ESecondRound_RoundDown)
	, m_eSecondRoundHatsu(ESecondRound_RoundDown)
	, m_bDisplay2400(false)
{
} ;

CdDedJikoku::CConv::CConv( 
	bool bNoColon ,
	CdDedJikoku::CConv::EHour	eHour  ,
	CdDedJikoku::CConv::ESecond eSecond,
	ESecondRound eSecondRoundChaku,
	ESecondRound eSecondRoundHatsu,
	bool bDisplay2400)
	: m_bNoColon( bNoColon )
	, m_eHour( eHour )
	, m_eSecond( eSecond )
	, m_eSecondRoundChaku(eSecondRoundChaku)
	, m_eSecondRoundHatsu(eSecondRoundHatsu)
	, m_bDisplay2400(bDisplay2400)
{
	int a = 0;
}

		
tstring CdDedJikoku::CConv::encode( const CdDedJikoku& aJikoku,
	const bool& bIsChakuJikoku,
	const CdDedJikoku& aCompareJikoku)const
{
	tstring	strRv ;
	if ( !aJikoku.isNull() ){
		if (m_eSecond == ESecond_NoSecond)
		{
			/**
				ESecond_NoSecond̏ꍇ́AbPʊۂߏs܂B
				bPʂۂ߂ꍇAyюɂeyڂ̂ŒӂKvłB
			*/

			CdDedJikoku aTempJikoku(aJikoku);
			if (aCompareJikoku.isNull())
			{
				//؂グ̏ꍇ́A̎59bẐAbPʂ𖳎邱ƂŁAƕ܂
				//30bȏ؂グ̏ꍇ́A30bZēlɏ܂
				if (bIsChakuJikoku &&
					m_eSecondRoundChaku == ESecondRound_RoundUp ||
					!bIsChakuJikoku &&
					m_eSecondRoundHatsu == ESecondRound_RoundUp)
				{
					aTempJikoku.addSeconds(59);
				}
				else if (bIsChakuJikoku &&
					m_eSecondRoundChaku == ESecondRound_Round ||
					!bIsChakuJikoku &&
					m_eSecondRoundHatsu == ESecondRound_Round)
				{
					aTempJikoku.addSeconds(30);
				}
			}
			else
			{
				//aCompareJikokuNullłȂꍇ́Aꂼ̕bPʏ@ɂẮȀt]邱Ƃ܂
				//t]Nꍇ́A؂̂Ă܂͐؂グ~߂܂
				if (aJikoku.getHour() == aCompareJikoku.getHour() &&
					aJikoku.getMinute() == aCompareJikoku.getMinute())
				{
					if (bIsChakuJikoku &&
						m_eSecondRoundChaku == ESecondRound_RoundUp &&
						(m_eSecondRoundHatsu == ESecondRound_RoundDown ||
							m_eSecondRoundHatsu == ESecondRound_Round) &&
						aJikoku.getSecond() > 0 && aJikoku.getSecond() < 30 &&
						aCompareJikoku.getSecond() > 0 && aCompareJikoku.getSecond() < 30)
					{
						//؂グŁA30bȏ؂グ܂͐؂̂ĂA
						//Ƃ1-29b̏ꍇAt]̂ŁA
						//̕b؂̂Ă邱Ƃŏێ܂B

						//؂̂ĂȂ̂œɏȂ
					}
					else if(!bIsChakuJikoku &&
						(m_eSecondRoundChaku == ESecondRound_RoundUp ||
							m_eSecondRoundChaku == ESecondRound_Round) &&
						m_eSecondRoundHatsu == ESecondRound_RoundDown &&
						aJikoku.getSecond() >= 30 &&
						aCompareJikoku.getSecond() >= 30)
					{
						//ۂ߂܂͐؂グŁA؂̂ĂA
						//Ƃ30-59b̏ꍇAt]̂ŁA
						//̕b؂グ邱Ƃŏێ܂B
						aTempJikoku.addSeconds(59);
					}
					else if (bIsChakuJikoku &&
						m_eSecondRoundChaku == ESecondRound_RoundUp &&
						m_eSecondRoundHatsu == ESecondRound_RoundDown &&
						aJikoku.getSecond() > 0 && aJikoku.getSecond() < 30 &&
						aCompareJikoku.getSecond() >= 30)
					{
						//؂グŁA؂̂ĂA
						//1-29bŔ30-59b̏ꍇAt]̂ŁA
						//bPʂ̕ςƂAꂪ30bȏȂ؂グAȂ؂̂Ăɓꂵ܂
						if (aJikoku.getSecond() + aCompareJikoku.getSecond() >= 60)
						{
							aTempJikoku.addSeconds(59);
						}
					}
					else if (!bIsChakuJikoku &&
						m_eSecondRoundChaku == ESecondRound_RoundUp &&
						m_eSecondRoundHatsu == ESecondRound_RoundDown &&
						aJikoku.getSecond() >= 30 &&
						aCompareJikoku.getSecond() > 0 && aCompareJikoku.getSecond() < 30)
					{
						//؂グŁA؂̂ĂA
						//1-29bŔ30-59b̏ꍇAt]̂ŁA
						//bPʂ̕ςƂAꂪ30bȏȂ؂グAȂ؂̂Ăɓꂵ܂
						if (aJikoku.getSecond() + aCompareJikoku.getSecond() >= 60)
						{
							aTempJikoku.addSeconds(59);
						}
					}
					else
					{
						//OL̏ɍvȂꍇ́AbIsHatsuJikokuƁAΉm_eSecondRoundɊÂA
						//30bȏ؂グA܂͐؂グ̏s܂

						if (bIsChakuJikoku &&
							m_eSecondRoundChaku == ESecondRound_RoundUp ||
							!bIsChakuJikoku &&
							m_eSecondRoundHatsu == ESecondRound_RoundUp)
						{
							aTempJikoku.addSeconds(59);
						}
						else if (bIsChakuJikoku &&
							m_eSecondRoundChaku == ESecondRound_Round ||
							!bIsChakuJikoku &&
							m_eSecondRoundHatsu == ESecondRound_Round)
						{
							aTempJikoku.addSeconds(30);
						}
					}
				}
				else
				{
					//vȂꍇ́AbIsChakuJikokuƁAΉm_eSecondRoundɊÂA
					//30bȏ؂グA܂͐؂グ̏s܂

					if (bIsChakuJikoku &&
						m_eSecondRoundChaku == ESecondRound_RoundUp ||
						!bIsChakuJikoku &&
						m_eSecondRoundHatsu == ESecondRound_RoundUp)
					{
						aTempJikoku.addSeconds(59);
					}
					else if (bIsChakuJikoku &&
						m_eSecondRoundChaku == ESecondRound_Round ||
						!bIsChakuJikoku &&
						m_eSecondRoundHatsu == ESecondRound_Round)
					{
						aTempJikoku.addSeconds(30);
					}
				}
			}

			//	 
			int iHour = aTempJikoku.getHour(); 
			if (m_bDisplay2400 && bIsChakuJikoku &&
				iHour == 0 && aTempJikoku.getMinute() == 0)
			{
				iHour = 24;
			}
			//int iHour = aJikoku.getHour();
			//if (aJikoku.getMinute() == 59 &&
			//	((!bIsChakuJikoku &&
			//	(m_eSecondRoundChaku == ESecondRound_RoundUp && aJikoku.getSecond() > 0 ||
			//		m_eSecondRoundChaku == ESecondRound_Round && aJikoku.getSecond() >= 30)) ||
			//		(bIsChakuJikoku &&
			//		(m_eSecondRoundHatsu == ESecondRound_RoundUp && aJikoku.getSecond() > 0 ||
			//			m_eSecondRoundHatsu == ESecondRound_Round && aJikoku.getSecond() >= 30))))
			//{
			//	/**
			//		59Ab؂グ0bȊOEbۂ߂30bȏ̏ꍇ́AJオ܂B
			//		A23̏ꍇ́AJオ0ɂȂ܂(2400\̏ꍇ͕)
			//	*/
			//	iHour++;
			//	if (iHour == 24 && 
			//		(!m_bDisplay2400 || bIsChakuJikoku))
			//	{
			//		iHour = 0;
			//	}
			//}
			//else if (m_bDisplay2400 && !bIsChakuJikoku &&
			//	iHour == 0 && aJikoku.getMinute() == 0)
			//{
			//	/**
			//		JオΏۂł͂ȂꍇAm_bDisplay2400trueŒ̏ꍇ00ȂA
			//		24ɕύX܂B
			//		AJオ001ɂȂꍇ͏܂
			//	*/
			//	if (m_eSecondRoundChaku == ESecondRound_RoundDown ||
			//		m_eSecondRoundChaku == ESecondRound_RoundUp && aJikoku.getSecond() == 0 ||
			//		m_eSecondRoundChaku == ESecondRound_Round && aJikoku.getSecond() < 30)
			//	{
			//		iHour = 24;
			//	}
			//}
			if (m_eHour == EHour_ZeroToNone)
			{
				//char	szLs[16] ;
				//sprintf( szLs , "%d" , aJikoku.getHour() ) ;
				//strRv += szLs ;
				strRv += strprintf(_T("%d"), iHour);
			}
			else if (m_eHour == EHour_ZeroToSpace)
			{
				//char	szLs[16] ;
				//sprintf( szLs , "%2d" , aJikoku.getHour() ) ;
				//strRv += szLs ;
				strRv += strprintf(_T("%2d"), iHour);
			}
			else
			{
				//char	szLs[16] ;
				//sprintf( szLs , "%02d" , aJikoku.getHour() ) ;
				//strRv += szLs ;
				strRv += strprintf(_T("%02d"), iHour);
			}
			//	̂̃R
			if (!m_bNoColon)
			{
				strRv += _T(":");
			}
			//	
			//int iMinute = aJikoku.getMinute();
			//if (!bIsChakuJikoku &&
			//	(m_eSecondRoundChaku == ESecondRound_RoundUp && aJikoku.getSecond() > 0 ||
			//		m_eSecondRoundChaku == ESecondRound_Round && aJikoku.getSecond() >= 30) ||
			//	bIsChakuJikoku &&
			//	(m_eSecondRoundHatsu == ESecondRound_RoundUp && aJikoku.getSecond() > 0 ||
			//		m_eSecondRoundHatsu == ESecondRound_Round && aJikoku.getSecond() >= 30))
			//{
			//	/**
			//		b؂グ0bȊOEbۂ߂30bȏ̏ꍇ́AJオ܂B
			//		60ɂȂꍇ́A0ɕύX܂B
			//	*/
			//	iMinute++;
			//	if (iMinute == 60)
			//	{
			//		iMinute = 0;
			//	}
			//}
			{
				strRv += strprintf(_T("%02d"), aTempJikoku.getMinute());
			}
		}
		else
		{
			//	
			int iHour = aJikoku.getHour(); 
			if (m_bDisplay2400 && bIsChakuJikoku &&
				iHour == 0 && aJikoku.getMinute() == 0)
			{
				/**
					m_bDisplay2400trueŒ̏ꍇ00ȂA
					24ɕύX܂Bb͍l܂B
				*/
				iHour = 24;
			}
			if (m_eHour == EHour_ZeroToNone)
			{
				//char	szLs[16] ;
				//sprintf( szLs , "%d" , aJikoku.getHour() ) ;
				//strRv += szLs ;
				strRv += strprintf(_T("%d"), iHour);
			}
			else if (m_eHour == EHour_ZeroToSpace)
			{
				//char	szLs[16] ;
				//sprintf( szLs , "%2d" , aJikoku.getHour() ) ;
				//strRv += szLs ;
				strRv += strprintf(_T("%2d"), iHour);
			}
			else
			{
				//char	szLs[16] ;
				//sprintf( szLs , "%02d" , aJikoku.getHour() ) ;
				//strRv += szLs ;
				strRv += strprintf(_T("%02d"), iHour);
			}
			//	̂̃R
			if (!m_bNoColon)
			{
				strRv += _T(":");
			}
			//	
			{
				strRv += strprintf(_T("%02d"), aJikoku.getMinute());
			}
			//	b
			if (m_eSecond == ESecond_Output ||
				(m_eSecond == ESecond_NotIfZero && aJikoku.getSecond() != 0))
			{
				//	̂̃R
				if (!m_bNoColon)
				{
					strRv += _T(":");
				}
				{
					strRv += strprintf(_T("%02d"), aJikoku.getSecond());
				}
			}
		}
	}
	return ( strRv ) ;

};




// ****************************************************************
//	CdDedJikoku
// ****************************************************************
const int iSecondsOfADay = 24 * 60 * 60 ;

// --------------------------------
//@name ֐
// --------------------------------
int CdDedJikoku::adjustTotalSeconds( int iTotalSeconds ) 
{
	iTotalSeconds %= iSecondsOfADay ;
	if ( iTotalSeconds < 0 ){
		iTotalSeconds = iSecondsOfADay + iTotalSeconds ;
	}
	return ( iTotalSeconds ) ;
}

// ********************************
//	RXgN^
// ********************************
CdDedJikoku::CdDedJikoku() : 
		m_iTotalSeconds( INT_MIN )
{
}

CdDedJikoku::CdDedJikoku( int iTotalSeconds ) 
{
	m_iTotalSeconds = adjustTotalSeconds( iTotalSeconds ) ;
}
	
CdDedJikoku::CdDedJikoku( int iHour , int iMinute , int iSecond ) 
{
	m_iTotalSeconds = adjustTotalSeconds( iHour * 60 * 60 + iMinute * 60 + iSecond ) ; 
}
CdDedJikoku::CdDedJikoku( const tstring& strTime ) 
	: m_iTotalSeconds( INT_MIN ) 
{
	decode( strTime ) ;
}

// ********************************
//	CdDedJikoku
// ********************************
	// ********************************
	//@name 
	// ********************************
CdDedJikoku& CdDedJikoku::setTotalSeconds( int value ) 
{
	m_iTotalSeconds = adjustTotalSeconds( value ) ;
	return ( *this ) ;
}
	
CdDedJikoku& CdDedJikoku::setTime( int iHour , int iMinute , int iSecond ) 
{
	m_iTotalSeconds = adjustTotalSeconds( iHour * 60 * 60 + iMinute * 60 + iSecond ) ; 
	return ( *this ) ;
}
	
CdDedJikoku& CdDedJikoku::setNull() 
{
	m_iTotalSeconds = INT_MIN ;
	return ( *this ) ;
}
	
	// ********************************
	//@name 
	// ********************************
int CdDedJikoku::compare( const CdDedJikoku& value )const 
{
	if ( m_iTotalSeconds > value.m_iTotalSeconds ){
		return ( 1 ) ;
	}	else if ( m_iTotalSeconds < value.m_iTotalSeconds ){
		return ( -1 ) ;
	}
	return ( 0 ) ;
}

int CdDedJikoku::compare( 
		const CdDedJikoku& value , 
		const CdDedJikoku& jikokuKitenJikoku )const 
{
	int iThisTotalSeconds = this->m_iTotalSeconds ;
	if ( iThisTotalSeconds < jikokuKitenJikoku.m_iTotalSeconds )
	{
		iThisTotalSeconds += TOTALSECONDS_A_DAY ;
	}

	int iValueTotalSeconds = value.m_iTotalSeconds ;
	if ( iValueTotalSeconds < jikokuKitenJikoku.m_iTotalSeconds )
	{
		iValueTotalSeconds += TOTALSECONDS_A_DAY ;
	}

	if ( iThisTotalSeconds > iValueTotalSeconds ){
		return ( 1 ) ;
	}	else if ( iThisTotalSeconds < iValueTotalSeconds ){
		return ( -1 ) ;
	}
	return ( 0 ) ;
}


CdDedJikoku& CdDedJikoku::addSeconds( int value ) 
{
	if ( !isNull() ){
		m_iTotalSeconds += value ;
		m_iTotalSeconds = adjustTotalSeconds( m_iTotalSeconds ) ;
	}
	return *this ;
}

int CdDedJikoku::subJikoku( const CdDedJikoku& value  )const 
{
	int iRv = 0 ; 
	if ( !isNull() && !value.isNull() ){
		iRv = m_iTotalSeconds - value.m_iTotalSeconds ;

		if ( iRv > 12*60*60 ){
			iRv -= 24*60*60 ;
		}	else if ( iRv < -12*60*60 ){
			iRv += 24*60*60 ;
		} 
	} 
	return ( iRv ) ;
}
	

int CdDedJikoku::decode( const tstring& value ) 
{
	int iRv = 0 ;

	tstring	strValue = value ;

	//	񂪋󕶎ȂAwNullԁxƂ܂B
	if ( value.empty() ){
		setNull() ;
		return ( 0 ) ;
	}

	//	RȂꍇ͒ǉ
	{
		tstring::size_type pos = strValue.find(_T(":") ) ;
		if ( pos == tstring::npos ){
			//	R܂B2؂ŃR}܂B
			if ( strValue.size() > 2 ){
				strValue.insert( strValue.size() - 2 , _T(":") ) ;
			}
			if ( strValue.size() > 5 ){
				strValue.insert( strValue.size() - 5 , _T(":") ) ;
			}
		} 
	}
	//strValue = "13:15:45","9:15"
	
	//	bȂꍇ͒ǉ
	if ( strValue.size() <= 5 ){
		strValue += _T(":00") ;
	}
	//strValue = "13:15:45","9:15:00"

	//	10̈ʂȂꍇ͒ǉ
	if ( strValue.size() <= 7 ){
		strValue = tstring(_T("0") ) + strValue ;
	}
	//	10̈ʂXy[X̏ꍇ́AXy[X "0" ɕύX
	if ( strValue.size() > 0 && strValue[0] == ' ' ){
		strValue[0] = '0' ;
	}

	//strValue = "13:15:45","09:15:00"

	int iHour = -1 ;
	int iMinute = -1 ;
	int iSecond = -1 ;
	if ( strValue.size() == 8 ){
		//	
		{
			tstring	strLs = strValue.substr( 0 , 2 ) ;
			if ( strLs.find_first_not_of(_T("0123456789") ) == tstring::npos ){
				iHour = _ttoi( strLs.c_str() ) ;
			}
		}
		//	
		{
			tstring	strLs = strValue.substr( 3 , 2 ) ;
			if ( strLs.find_first_not_of(_T("0123456789") ) == tstring::npos ){
				iMinute = _ttoi( strLs.c_str() ) ;
			}
		}
		//	b
		{
			tstring	strLs = strValue.substr( 6 , 2 ) ;
			if ( strLs.find_first_not_of(_T("0123456789") ) == tstring::npos ){
				iSecond = _ttoi( strLs.c_str() ) ;
			}
		}
	}	else	{
		iRv = -1 ;	//	ڐsĂ܂B
		return ( iRv ) ;
	}
	
	if ( 0 <= iHour && iHour < 24 && 
			0 <= iMinute && iMinute < 60 && 
			0 <= iSecond && iSecond < 60 ){
		setTime( iHour , iMinute , iSecond ) ;
	}	else	{
		iRv = -2 ;	//	EEb̕\LsłB
	}
	
	return ( iRv ) ;
}

} //namespace entDed
