/*
OuDiaSecond Copyright (C) 2017-2020 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDlgAllOperationTableProp.cpp : Cve[V t@C
//

#include "stdafx.h"

#include "..\DiagramEdit.h"
#include "CDlgAllOperationTableProp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewAllOperationTable {

/////////////////////////////////////////////////////////////////////////////
// CDlgAllOperationTableProp _CAO


CDlgAllOperationTableProp::CDlgAllOperationTableProp(
		const CWndDcdGridAllOperationTable::EOperationSort eOperationSort,
		const bool bCompareBottom,
		CWnd* pParent )
	: CDialog(CDlgAllOperationTableProp::IDD, pParent)
	, m_eOperationSort(eOperationSort)
	, m_iEDIT_CompareBottom(bCompareBottom)
{
	//{{AFX_DATA_INIT(CDlgAllOperationTableProp)
	//}}AFX_DATA_INIT
	m_iRADIO_OPERATIONSORT = (int)m_eOperationSort;
}


void CDlgAllOperationTableProp::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAllOperationTableProp)
	DDX_Radio(pDX, IDC_RADIO_OPERATIONSORT_0, m_iRADIO_OPERATIONSORT);
	DDX_Check(pDX, IDC_CHECK_CompareBottom, m_iEDIT_CompareBottom);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgAllOperationTableProp, CDialog)
	//{{AFX_MSG_MAP(CDlgAllOperationTableProp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgAllOperationTableProp bZ[W nh

void CDlgAllOperationTableProp::OnOK() 
{
	int iRv = 0 ;
	// --------------------------------
	//	UpdateData()̑O
	// --------------------------------


	if ( !UpdateData() )
	{
		iRv = -1 ;	//	UpdateData()Ɏs܂B(G[\ς)
	}
	
	// --------------------------------
	//	Rg[̒l荞
	// --------------------------------
	if ( iRv >= 0 )
	{
		switch (m_iRADIO_OPERATIONSORT)
		{
		case 0:
			m_eOperationSort = CWndDcdGridAllOperationTable::EOperationSort_OperationNumber;
			break;
		case 1:
			m_eOperationSort = CWndDcdGridAllOperationTable::EOperationSort_OutEki;
			break;
		case 2:
			m_eOperationSort = CWndDcdGridAllOperationTable::EOperationSort_OutJikoku;
			break;
		case 3:
			m_eOperationSort = CWndDcdGridAllOperationTable::EOperationSort_InEki;
			break;
		case 4:
			m_eOperationSort = CWndDcdGridAllOperationTable::EOperationSort_InJikoku;
			break;
		}

	}

	// --------------------------------
	if ( iRv >= 0 )
	{
		//	G[Ȃ΃_CAOI
		CDialog::OnOK();
	}
	else
	{
		CString strErrorMsg ;
		switch( iRv )
		{
		case -1:	//	UpdateData()Ɏs܂B(G[\ς)
			//	̏ꍇ́AG[bZ[W͕\܂B
			break ;
		default:
			strErrorMsg.Format( _T( "Error=%d" ) , iRv ) ;
			break ;
		}
		if ( strErrorMsg.GetLength() > 0 )
		{
			MessageBox( strErrorMsg , NULL , MB_ICONERROR ) ; 
		}
	}
}
} //namespace ViewAllOperationTable
