/*
OuDiaSecond Copyright (C) 2017-2020 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDlgOperationTableExport.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "MfcUtil\MfcUtil.h"
#include "str\CsvDocument\CdCsvDocument.h"
#include "str\CsvDocument\CconvCsvDocument.h"
#include "str\strtoint.h"
#include "str\vectorToFile.h"

#include "..\diagramedit.h"
#include "..\resource.h"
#include "CDlgOperationTableCsvExport.h"
#include "..\entDed\CdDedRessyaProperty.h"
#include <algorithm>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewAllOperationTable {
using namespace std ;

/////////////////////////////////////////////////////////////////////////////
// CDlgOperationTableCsvExport _CAO


CDlgOperationTableCsvExport::CDlgOperationTableCsvExport(
	const CentDedRosen* pCentDedRosen,
	const CentDedDia* pCentDedDia,
	tstring  strOperationNumber,
	int iStationIndex,
	bool bDisplaySecondEkiJikoku,
	bool bDisplayColonEkiJikoku,
	bool bDisplayParentSyubetsu,
	bool bDisplayNoboriLeftToRight,
	bool bCompareBottom,
	CWndDcdGridAllOperationTable::EOperationSort eOperationSort,
	CWnd* pParent )
	: CDialog(CDlgOperationTableCsvExport::IDD, pParent)
 	, m_pCentDedRosen( pCentDedRosen )
	, m_pCentDedDia(pCentDedDia)
	, m_strOperationNumber(strOperationNumber)
	, m_bDisplaySecondEkiJikoku(bDisplaySecondEkiJikoku)
	, m_bDisplayColonEkiJikoku(bDisplayColonEkiJikoku)
	, m_bDisplayParentSyubetsu(bDisplayParentSyubetsu)
	//, m_bDisplayNoboriLeftToRight(bDisplayNoboriLeftToRight)
	, m_bCompareBottom(bCompareBottom)
	, m_iRadioOperationTarget(0)
	, m_strOperationNumberInput(strOperationNumber.c_str())
	, m_iTypeOfSearch(0)
	, m_iStationIndex(iStationIndex)
	, m_iInOrOut(0)
	, m_iOperationOrder((int)eOperationSort)
	, m_iIncludeOuterTerminal(1)
{
	//{{AFX_DATA_INIT(CDlgOuJikokuhyouCsvExport)
	//}}AFX_DATA_INIT
	m_iNoboriLeftToRight = bDisplayNoboriLeftToRight ? 1 : 0;
	if (eOperationSort == CWndDcdGridAllOperationTable::EOperationSort_InEki ||
		eOperationSort == CWndDcdGridAllOperationTable::EOperationSort_InJikoku)
	{
		m_iInOrOut = 1;
	}
}

void CDlgOperationTableCsvExport::splitOperationNumber(
	const tstring strOperationNumberIn,
	vector<int>& iOperationNumber,
	vector<tstring>& strOperationNumberOut) const
{
	iOperationNumber.clear();
	strOperationNumberOut.clear();
	bool bIsDigit = false;
	bool bIsNotDigit = false;
	tstring strOperationNumberTemp = strOperationNumberIn;
	while (!strOperationNumberTemp.empty())
	{
		int idx = 0;
		if (_istdigit(strOperationNumberTemp[idx]) != 0)
		{
			if ((int)strOperationNumberTemp.size() == 1)
			{
				iOperationNumber.push_back(
					_ttoi(strOperationNumberTemp.c_str()));
				strOperationNumberOut.push_back(tstring());
				break;
			}
			//̏ꍇ
			bIsDigit = true;
		}
		else
		{
			if ((int)strOperationNumberTemp.size() == 1)
			{
				iOperationNumber.push_back(INT_MIN);
				strOperationNumberOut.push_back(strOperationNumberTemp);
				break;
			}
			//ȊȌꍇ
			bIsDigit = false;
		}
		idx++;
		for (; idx < (int)strOperationNumberTemp.size(); idx++)
		{
			if (idx == (int)strOperationNumberTemp.size() - 1)
			{
				if (bIsDigit && _istdigit(strOperationNumberTemp[idx]) != 0)
				{
					iOperationNumber.push_back(
						_ttoi(strOperationNumberTemp.c_str()));
					strOperationNumberOut.push_back(tstring());

					strOperationNumberTemp.clear();
					break;
				}
				else if (!bIsDigit && _istdigit(strOperationNumberTemp[idx]) == 0)
				{
					iOperationNumber.push_back(INT_MIN);
					strOperationNumberOut.push_back(strOperationNumberTemp);

					strOperationNumberTemp.clear();
					break;
				}

			}
			if (_istdigit(strOperationNumberTemp[idx]) != 0)
			{
				//idxʒuŁA擪̏ꍇ
				if (!bIsDigit)
				{
					iOperationNumber.push_back(INT_MIN);
					strOperationNumberOut.push_back(strOperationNumberTemp.substr(0, idx));

					strOperationNumberTemp = strOperationNumberTemp.substr(idx);
					break;
				}
			}
			else
			{
				//idxʒuŁA擪̏ꍇ
				if (bIsDigit)
				{
					iOperationNumber.push_back(
						_ttoi(strOperationNumberTemp.substr(0, idx).c_str()));
					strOperationNumberOut.push_back(tstring());

					strOperationNumberTemp = strOperationNumberTemp.substr(idx);
					break;
				}
			}
		}
	}
}

bool CDlgOperationTableCsvExport::SortOperationNumber(
	const tstring strOperationNumber1,
	const tstring strOperationNumber2)
{
	if (strOperationNumber2.empty())
	{
		return true;
	}
	if (strOperationNumber1.empty())
	{
		return false;
	}


	vector<int> iOperationNumber1;
	vector<int> iOperationNumber2;
	vector<tstring> strOperationNumber1Part;
	vector<tstring> strOperationNumber2Part;
	splitOperationNumber(strOperationNumber1, iOperationNumber1, strOperationNumber1Part);
	splitOperationNumber(strOperationNumber2, iOperationNumber2, strOperationNumber2Part);

	if (m_bCompareBottom)
	{
		int iSize1 = iOperationNumber1.size();
		int iSize2 = iOperationNumber2.size();
		int iMin = min(iSize1, iSize2);
		for (int idx = 1; idx <= iMin; idx++)
		{
			// --------------------------------
			//	- ƂȊOł͐̕
			// --------------------------------
			{
				if (iOperationNumber1[iSize1 - idx] != INT_MIN && iOperationNumber2[iSize2 - idx] == INT_MIN)
				{
					return true;
				}
				else if (iOperationNumber1[iSize1 - idx] == INT_MIN && iOperationNumber2[iSize2 - idx] != INT_MIN)
				{
					return false;
				}
			}

			if (iOperationNumber1[iSize1 - idx] == INT_MIN)
			{
				//ɐȊȌꍇA
				// --------------------------------
				//	- ̒Z
				// --------------------------------
				{
					if (strOperationNumber1Part[iSize1 - idx].length() < strOperationNumber2Part[iSize2 - idx].length())
					{
						return true;
					}
					else if (strOperationNumber1Part[iSize1 - idx].length() > strOperationNumber2Part[iSize2 - idx].length())
					{
						return false;
					}
				}
				// --------------------------------
				//	- őB
				// --------------------------------
				{
					if (strOperationNumber1Part[iSize1 - idx] < strOperationNumber2Part[iSize2 - idx])
					{
						return true;
					}
					else if (strOperationNumber1Part[iSize1 - idx] > strOperationNumber2Part[iSize2 - idx])
					{
						return false;
					}
				}
			}
			else
			{
				//ɐ̏ꍇȂ召
				// --------------------------------
				//	- ̂
				// --------------------------------
				{
					if (iOperationNumber1[iSize1 - idx] < iOperationNumber2[iSize2 - idx])
					{
						return true;
					}
					else if (iOperationNumber1[iSize1 - idx] > iOperationNumber2[iSize2 - idx])
					{
						return false;
					}
				}
			}

		}
	}
	else
	{
		int iMin = min(iOperationNumber1.size(), iOperationNumber2.size());
		for (int idx = 0; idx < iMin; idx++)
		{
			// --------------------------------
			//	- ƂȊOł͐̕
			// --------------------------------
			{
				if (iOperationNumber1[idx] != INT_MIN && iOperationNumber2[idx] == INT_MIN)
				{
					return true;
				}
				else if (iOperationNumber1[idx] == INT_MIN && iOperationNumber2[idx] != INT_MIN)
				{
					return false;
				}
			}

			if (iOperationNumber1[idx] == INT_MIN)
			{
				//ɐȊȌꍇA
				// --------------------------------
				//	- ̒Z
				// --------------------------------
				{
					if (strOperationNumber1Part[idx].length() < strOperationNumber2Part[idx].length())
					{
						return true;
					}
					else if (strOperationNumber1Part[idx].length() > strOperationNumber2Part[idx].length())
					{
						return false;
					}
				}
				// --------------------------------
				//	- őB
				// --------------------------------
				{
					if (strOperationNumber1Part[idx] < strOperationNumber2Part[idx])
					{
						return true;
					}
					else if (strOperationNumber1Part[idx] > strOperationNumber2Part[idx])
					{
						return false;
					}
				}
			}
			else
			{
				//ɐ̏ꍇȂ召
				// --------------------------------
				//	- ̂
				// --------------------------------
				{
					if (iOperationNumber1[idx] < iOperationNumber2[idx])
					{
						return true;
					}
					else if (iOperationNumber1[idx] > iOperationNumber2[idx])
					{
						return false;
					}
				}
			}

		}
	}
	// --------------------------------
	//	- vfȂ̂
	// --------------------------------
	{
		if (iOperationNumber1.size() < iOperationNumber2.size())
		{
			return true;
		}
		else if (iOperationNumber1.size() > iOperationNumber2.size())
		{
			return false;
		}
	}

	return false;
}

bool CDlgOperationTableCsvExport::SortOperation(
	const tstring strOperationNumber1,
	const int& iEkiIndex1,
	const int& iOuterIndex1,
	const CdDedJikoku& Jikoku1,
	const tstring strOperationNumber2,
	const int& iEkiIndex2,
	const int& iOuterIndex2,
	const CdDedJikoku& Jikoku2,
	const CdDedJikoku& KitenJikoku)
{
	if (strOperationNumber1.empty())
	{
		return false;
	}
	if (m_iOperationOrder == (int)CWndDcdGridAllOperationTable::EOperationSort_OperationNumber)
	{
		/**
			^pԍ
			^pԍCompareBottomɊÂŔ肵܂
			̉^pԍ͖̂ŁAʂ͈ӂɌ܂܂
		*/
		return SortOperationNumber(strOperationNumber1, strOperationNumber2);
	}
	else if (m_iOperationOrder == (int)CWndDcdGridAllOperationTable::EOperationSort_OutEki ||
		m_iOperationOrder == (int)CWndDcdGridAllOperationTable::EOperationSort_InEki)
	{
		/**
			ow
			(1)ow
			(2)
			(3)^pԍŕׂ܂
			(1)oẃAw̏ꍇiPosition=0̉wɏW񂵂܂B
				܂AHOn̏ꍇAȏoɂȂA
				HOnm̏ꍇAHOnwIndex̂ɂȂ܂
			(2)owvĂꍇAŕׂ܂B
				ȂAHOnwvĂꍇ́AHOnwŔr܂
			(3)owiHOnwjAvĂꍇ́A^pԍŕׂ܂B
		*/

		if (iEkiIndex1 < iEkiIndex2)
		{
			return true;
		}
		else if (iEkiIndex1 > iEkiIndex2)
		{
			return false;
		}

		if (iOuterIndex1 < iOuterIndex2)
		{
			return true;
		}
		else if (iOuterIndex1 > iOuterIndex2)
		{
			return false;
		}

		if (Jikoku1.compare(Jikoku2, KitenJikoku) < 0)
		{
			return true;
		}
		else if (Jikoku1.compare(Jikoku2, KitenJikoku) > 0)
		{
			return false;
		}

		return SortOperationNumber(strOperationNumber1, strOperationNumber2);
	}
	else if (m_iOperationOrder == (int)CWndDcdGridAllOperationTable::EOperationSort_OutJikoku ||
		m_iOperationOrder == (int)CWndDcdGridAllOperationTable::EOperationSort_InJikoku)
	{
		/**
			
			(1)
			(2)^pԍŕׂ܂B
			(1)́AHOn̏ꍇAHOnwpĔr܂
		*/

		if (Jikoku1.compare(Jikoku2, KitenJikoku) < 0)
		{
			return true;
		}
		else if (Jikoku1.compare(Jikoku2, KitenJikoku) > 0)
		{
			return false;
		}

		return SortOperationNumber(strOperationNumber1, strOperationNumber2);
	}
	return false;
}

bool CDlgOperationTableCsvExport::CheckSatisfyConditions(
	const tstring& strOperationNumber,
	list< OperationTableContent> ListOperationTableContent,
	//const CentDedRessya* pCentDedRessya,
	const deque<int>& iEkiIndexGroup)
{
	if (m_iRadioOperationTarget == 0)
	{
		/**
			S^po
		*/
		return true;
	}
	else if (m_iRadioOperationTarget == 1)
	{
		/**
			^pԍvo
		*/
		if (m_strOperationNumberInput.IsEmpty())
		{
			return false;
		}

		tstring strOperationNumberInput((LPCTSTR)m_strOperationNumberInput);
		if (strOperationNumber.size() < strOperationNumberInput.size())
		{
			return false;
		}
		if (m_iTypeOfSearch == 0) //v
		{
			return strOperationNumber.find(strOperationNumberInput) != tstring::npos;
		}
		else if (m_iTypeOfSearch == 1)//Sv
		{
			return strOperationNumber == strOperationNumberInput;
		}
		else if (m_iTypeOfSearch == 2)//Ov
		{
			return strOperationNumber.compare(
				0,
				strOperationNumberInput.size(),
				strOperationNumberInput) == 0;

		}
		else if (m_iTypeOfSearch == 3)//v
		{
			return strOperationNumber.compare(
				strOperationNumber.size()-strOperationNumberInput.size(),
				strOperationNumberInput.size(),
				strOperationNumberInput) == 0;

		}
	}
	else if (m_iRadioOperationTarget == 2)
	{
		/**
			oEwwo
		*/
		if (m_iInOrOut == 0)
		{
			if (ListOperationTableContent.front().iOuterShihatsuekiIndex != INT_MIN)
			{
				if (m_iIncludeOuterTerminal == 0)
				{
					return false;
				}
			}
			/**
				Ver2.02
				^p̐擪Ԃ̍ƂuovuHOnvȊO(OԐڑ)łɂ܂B
			*/
			//else if (ListOperationTableContent.front().aRessyaProperty.getJikoku().isNull())
			//{
			//	return false;
			//}

			int iSihatsuEkiIndex = m_pCentDedRosen->getCentDedEkiCont()->EkiIndexOfEkiOrder(
				ListOperationTableContent.front().aRessyaProperty.getRessyahoukou(), ListOperationTableContent.front().iSihatsuEkiOrder);
			for (int idx = 0; idx < (int)iEkiIndexGroup.size(); idx++)
			{
				if (iSihatsuEkiIndex == iEkiIndexGroup[idx])
				{
					return true;
				}
			}
		}
		else if (m_iInOrOut == 1)
		{
			if (ListOperationTableContent.back().iOuterShuchakuekiIndex != INT_MIN)
			{
				if (m_iIncludeOuterTerminal == 0)
				{
					return false;
				}
			}
			/**
				Ver2.02
				^p̐擪Ԃ̍ƂuvuHOIvȊO(Ԑڑ)łɂ܂B
			*/
			//else if (ListOperationTableContent.back().AfterOperation != NULL)
			//{
			//	return false;
			//}

			int iSyuuchakuEkiIndex = m_pCentDedRosen->getCentDedEkiCont()->EkiIndexOfEkiOrder(
				ListOperationTableContent.back().aRessyaProperty.getRessyahoukou(), ListOperationTableContent.back().iSyuuchakuEkiOrder);
			for (int idx = 0; idx < (int)iEkiIndexGroup.size(); idx++)
			{
				if (iSyuuchakuEkiIndex == iEkiIndexGroup[idx])
				{
					return true;
				}
			}
		}
	}
	return false;
}

void CDlgOperationTableCsvExport::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOuJikokuhyouCsvExport)
	//}}AFX_DATA_MAP
	DDX_Radio(pDX, IDC_OperationExport_RADIO1, m_iRadioOperationTarget);
	DDX_Text(pDX, IDC_OperationExport_EDIT_KeyWord, m_strOperationNumberInput);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_TypeOfSearch, m_iTypeOfSearch);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_Station, m_iStationIndex);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_OutOrIn, m_iInOrOut);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_Order, m_iOperationOrder);
	DDX_Check(pDX, IDC_OperationExport_CHECK_IncludeOuterTerminal, m_iIncludeOuterTerminal);
	DDX_Check(pDX, IDC_OperationExport_CHECK_NoboriLeftToRight, m_iNoboriLeftToRight);
}


BEGIN_MESSAGE_MAP(CDlgOperationTableCsvExport, CDialog)
	//{{AFX_MSG_MAP(CDlgOuJikokuhyouCsvExport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOuJikokuhyouCsvExport bZ[W nh

BOOL CDlgOperationTableCsvExport::OnInitDialog()
{
	
	// --------------------------------
	int iRv = 0 ;
	const CentDedDia* pCentDedDia = NULL ;
	if ( iRv >= 0 )
	{
		//pCentDedDia = m_pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get( m_iDiaIndex ) ;
		if ( m_pCentDedDia == NULL )
		{
			iRv = -11 ;	//	m_pCentDedDia słB
		}
	}
	if 	( iRv >= 0 )
	{
		const Mu<const CentDedEki*>* pCentDedEkiCont = m_pCentDedRosen->getCentDedEkiCont()->getMuPtr();

		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_Station);
		for (int idx = 0; idx < pCentDedEkiCont->size(); idx++ )
		{
			const CentDedEki* pCentDedEki = pCentDedEkiCont->get(idx);
			//tstring strEkimei = stringOf(idx) + ". ";
			//strEkimei = strEkimei + pCentDedEki->getEkimei();
			tstring strEkimei =  pCentDedEki->getEkimei();
			pCComboBox->AddString(strEkimei.c_str());
		}

		//pCComboBox->SetCurSel(m_iStationIndex);
	}

	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_TypeOfSearch);

		tstring strTemp = _T("ƈv");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("܂");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("Ov");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("v");
		pCComboBox->AddString(strTemp.c_str());
		//ƈv;܂;Ov;v;
	}
	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_OutOrIn);

		tstring strTemp = _T("o");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("");
		pCComboBox->AddString(strTemp.c_str());
		//o;;
	}
	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_Order);

		tstring strTemp = _T("^pԍɕׂ");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("owɕׂ");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("ɕׂ");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("wɕׂ");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("ɕׂ");
		pCComboBox->AddString(strTemp.c_str());
		//^pԍɕׂ;owɕׂ;
	}


	CDialog::OnInitDialog();

	// --------------------------------
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgOperationTableCsvExport::OnOK()
{
	int iRv = 0 ;
	UpdateData();
	CString	strError ;
	// --------------------------------
	const CentDedDia* pCentDedDia = NULL ;
	//const Mu<const CentDedRessya*>* pCentDedRessyaContGet = NULL ;
	if ( iRv >= 0 )
	{
		//pCentDedDia = m_pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get( m_iDiaIndex ) ;
		if ( m_pCentDedDia == NULL )
		{
			iRv = -11 ;	//	m_iDiaIndex słB
		}
	}
	//if 	( iRv >= 0 )
	//{
	//	pCentDedRessyaContGet = pCentDedDia->getCentDedRessyaCont( m_eRessyahoukou )->getMuPtr() ;
	//}
	//pCentDedRessyaContGet = ΏۂƂȂԃRei
	
	
	// --------------------------------
	//	͒l̎擾
	// --------------------------------
	const CdDedJikoku KitenJikoku = m_pCentDedRosen->getKitenJikoku();
	
	deque<int> iEkiIndexGroup;
	if (m_iRadioOperationTarget == 2)
	{
		m_pCentDedRosen->getCentDedEkiCont()->getEkiIndexBrunchLoop(
			m_iStationIndex,
			iEkiIndexGroup);
	}

	unordered_map<tstring, list<OperationTableContent>> contOperationTableContent =
		m_pCentDedDia->getcontOperationTableContent();

	const CentDedEkiCont* pCentDedEkiCont = m_pCentDedRosen->getCentDedEkiCont();
	const Mu<const CentDedRessya*>* pCentDedRessyaConts[2];
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		pCentDedRessyaConts[iRessyahoukou] = m_pCentDedDia->getCentDedRessyaCont((ERessyahoukou)iRessyahoukou)->getMuPtr();
	}

	vector<tstring> strOperationNumberCont;
	vector<int> iEkiIndexCont;
	vector<int> iOuterIndexCont;
	vector<CdDedJikoku> JikokuCont;


	int iMaxRessyaCount = 0;
	for (auto itr = contOperationTableContent.begin();
		itr != contOperationTableContent.end(); itr++)
	{
		if ((int)itr->second.size() > iMaxRessyaCount)
		{
			iMaxRessyaCount = itr->second.size();
		}

		if (!CheckSatisfyConditions(itr->first, itr->second,/*pCentDedRessya,*/ iEkiIndexGroup))
		{
			continue;
		}

		int iEkiIndexTemp;
		int iOuterIndexTemp;
		CdDedJikoku JikokuTemp;
		if (m_iOperationOrder == 1)
		{
			OperationTableContent aShihatsuOperationTableContent = itr->second.front();
			iEkiIndexTemp = pCentDedEkiCont->EkiIndexOfEkiOrder(
				aShihatsuOperationTableContent.aRessyaProperty.getRessyahoukou(),
				aShihatsuOperationTableContent.iSihatsuEkiOrder);
			const CentDedEki* pSihatsuEki = pCentDedEkiCont->getMuPtr()->get(iEkiIndexTemp);

			if (pSihatsuEki->getBrunchLoopPosition() != -1)
			{
				iEkiIndexTemp = pSihatsuEki->getEkiIndexLoop().front();
			}
			iOuterIndexTemp = aShihatsuOperationTableContent.iOuterShihatsuekiIndex;
			if (iOuterIndexTemp != INT_MIN)
			{
				JikokuTemp = aShihatsuOperationTableContent.OuterShihatsuJikoku;
			}
			else
			{
				int iSihatsuEkiOrder = aShihatsuOperationTableContent.iSihatsuEkiOrder;
				const CentDedRessya* pCentDedRessya =
					pCentDedRessyaConts[aShihatsuOperationTableContent.aRessyaProperty.getRessyahoukou()]
					->get(aShihatsuOperationTableContent.aRessyaProperty.getRessyaIndex());

				if (!pCentDedRessya->isRunBetweenNextEki(iSihatsuEkiOrder))
				{
					iSihatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iSihatsuEkiOrder);
				}

				JikokuTemp = pCentDedRessya->getCentDedEkiJikoku(iSihatsuEkiOrder).getHatsujikoku();
			}
		}
		else if (m_iOperationOrder == 2)
		{
			OperationTableContent aShihatsuOperationTableContent = itr->second.front();
			if (aShihatsuOperationTableContent.iOuterShihatsuekiIndex != INT_MIN)
			{
				JikokuTemp = aShihatsuOperationTableContent.OuterShihatsuJikoku;
			}
			else
			{
				int iSihatsuEkiOrder = aShihatsuOperationTableContent.iSihatsuEkiOrder;
				const CentDedRessya* pCentDedRessya =
					pCentDedRessyaConts[aShihatsuOperationTableContent.aRessyaProperty.getRessyahoukou()]
					->get(aShihatsuOperationTableContent.aRessyaProperty.getRessyaIndex());

				if (!pCentDedRessya->isRunBetweenNextEki(iSihatsuEkiOrder))
				{
					iSihatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iSihatsuEkiOrder);
				}

				JikokuTemp = pCentDedRessya->getCentDedEkiJikoku(iSihatsuEkiOrder).getHatsujikoku();
			}
		}
		else if (m_iOperationOrder == 3)
		{
			OperationTableContent aSyuchakuOperationTableContent = itr->second.back();
			iEkiIndexTemp = pCentDedEkiCont->EkiIndexOfEkiOrder(
				aSyuchakuOperationTableContent.aRessyaProperty.getRessyahoukou(),
				aSyuchakuOperationTableContent.iSyuuchakuEkiOrder);
			const CentDedEki* pSyuchakuEki = pCentDedEkiCont->getMuPtr()->get(iEkiIndexTemp);

			if (pSyuchakuEki->getBrunchLoopPosition() != -1)
			{
				iEkiIndexTemp = pSyuchakuEki->getEkiIndexLoop().front();
			}
			iOuterIndexTemp = aSyuchakuOperationTableContent.iOuterShuchakuekiIndex;
			if (iOuterIndexTemp != INT_MIN)
			{
				JikokuTemp = aSyuchakuOperationTableContent.OuterShuchakuJikoku;
			}
			else
			{
				int iSyuuchakuEkiOrder = aSyuchakuOperationTableContent.iSyuuchakuEkiOrder;
				const CentDedRessya* pCentDedRessya =
					pCentDedRessyaConts[aSyuchakuOperationTableContent.aRessyaProperty.getRessyahoukou()]
					->get(aSyuchakuOperationTableContent.aRessyaProperty.getRessyaIndex());

				if (!pCentDedRessya->isRunBetweenNextEki(iSyuuchakuEkiOrder - 1))
				{
					iSyuuchakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iSyuuchakuEkiOrder);
				}

				JikokuTemp = pCentDedRessya->getCentDedEkiJikoku(iSyuuchakuEkiOrder).getChakujikoku();
			}
		}
		else if (m_iOperationOrder == 4)
		{
			OperationTableContent aSyuchakuOperationTableContent = itr->second.back();
			if (aSyuchakuOperationTableContent.iOuterShuchakuekiIndex != INT_MIN)
			{
				JikokuTemp = aSyuchakuOperationTableContent.OuterShuchakuJikoku;
			}
			else
			{
				int iSyuuchakuEkiOrder = aSyuchakuOperationTableContent.iSyuuchakuEkiOrder;
				const CentDedRessya* pCentDedRessya =
					pCentDedRessyaConts[aSyuchakuOperationTableContent.aRessyaProperty.getRessyahoukou()]
					->get(aSyuchakuOperationTableContent.aRessyaProperty.getRessyaIndex());

				if (!pCentDedRessya->isRunBetweenNextEki(iSyuuchakuEkiOrder - 1))
				{
					iSyuuchakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iSyuuchakuEkiOrder);
				}

				JikokuTemp = pCentDedRessya->getCentDedEkiJikoku(iSyuuchakuEkiOrder).getChakujikoku();
			}
		}

		bool bInsert = false;
		for (int idx = 0; idx < (int)strOperationNumberCont.size(); idx++)
		{
			if (SortOperation(
				itr->first, iEkiIndexTemp, 
				iOuterIndexTemp, JikokuTemp ,
				strOperationNumberCont[idx],iEkiIndexCont[idx], 
				iOuterIndexCont[idx], JikokuCont[idx],
				KitenJikoku))
		{
				strOperationNumberCont.insert(strOperationNumberCont.begin() + idx, itr->first);
				iEkiIndexCont.insert(iEkiIndexCont.begin() + idx, iEkiIndexTemp);
				iOuterIndexCont.insert(iOuterIndexCont.begin() + idx, iOuterIndexTemp);
				JikokuCont.insert(JikokuCont.begin() + idx, JikokuTemp);
				bInsert = true;
				break;
			}
		}
		if (!bInsert)
		{
			strOperationNumberCont.push_back(itr->first);
			iEkiIndexCont.push_back(iEkiIndexTemp);
			iOuterIndexCont.push_back(iOuterIndexTemp);
			JikokuCont.push_back(JikokuTemp);
		}
	}

	
	// --------------------------------
	//	o̓t@C͒l̎擾
	// --------------------------------
	if ( iRv >= 0 )
	{
		CFileDialog aDlg( 
			FALSE , 
			_T( "csv" ) , 
			m_strCsvFilename , 
			OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
			getCDiagramEditApp()->getCFileDialogFilterCsv(), 
			this );
		if ( aDlg.DoModal() != IDOK )
		{
			iRv = -2 ;	//	Cancel܂B
		}
		else
		{
			m_strCsvFilename = aDlg.GetPathName() ;
		}
	}
	//m_strCsvFilename = w肳ꂽCSVt@C

	// --------------------------------
	//	CSVt@C̏o
	// --------------------------------
	CWaitCursor aCursor ;
	if ( iRv >= 0 )
	{
		bool bDisplayNoboriLeftToRight = false;
		if (m_iNoboriLeftToRight == 1)
		{
			bDisplayNoboriLeftToRight = true;
		}
		CconvOperationTableCsv	aConv( getCDiagramEditApp()->createCconvOperationTableCsv()) ;
		CdCsvDocument	aCdCsvDocument ;
		int iResult = aConv.encode(
			*m_pCentDedRosen , 
			*m_pCentDedDia , 
			strOperationNumberCont,
			m_bDisplaySecondEkiJikoku,
			m_bDisplayColonEkiJikoku,
			m_bDisplayParentSyubetsu,
			bDisplayNoboriLeftToRight,
			&aCdCsvDocument ) ;
		if ( iResult < 0 )
		{
			GetDlgItemText( IDC_TEXT_ENCODE_ERROR , strError ) ;
			//strError="CSVւ̕ϊɎs܂B"

			strError.Format( _T( "%s(%d)" ) , CString( strError ), iResult ) ; 
			iRv = iResult - 10 ;
		}
		else
		{
			tstring strCsvDocument ;
			CConvCsvDocument	aCConvCsvDocument ;
			strCsvDocument = aCConvCsvDocument.encode( &aCdCsvDocument ) ;
			int iResult = stringToFile( strCsvDocument , (LPCTSTR)m_strCsvFilename ) ;
			if ( iResult < 0 )
			{
				GetDlgItemText( IDC_TEXT_FILE_SAVE_FAILED , strError ) ;
				//strError="t@Cւ̕ۑɎs܂B"

				iRv = -21 ; // t@Cւ̕ۑɎs܂B

			}
		}
	}
	//CDialog::OnOK();
}

} //namespace ViewAllOperationTable
