/*
OuDiaSecond Copyright (C) 2017-2020 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CWndDcdGridAllOperationTable.cpp
//	$Id: CWndDcdGridAllOperationTable.cpp  $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"

#include "logmsg\LogMsg.h"
#include "NsOu\OuNew.h"
#include "NsOu\dynamic_castOu.h"
#include "str\strtoint.h"
#include "DcDraw\CDcdTargetGetDC.h"
#include "DcDraw\CConverter_WinGdi.h"
#include "MfcUtil/MfcUtil.h"
#include "Str/strToWstr.h"
#include "DcDraw\CDcdLine.h"

#include "..\resource.h"
#include "..\entDed\CentDedRosen.h"
#include "..\entDed\CentDedDia.h"
#include "..\DiagramEdit.h"
#include "..\CRfEditCmdHolder.h"
#include "..\DedRosenFileData\EditCmd\EditCmd.h"
#include "CWndDcdGridAllOperationTable.h"
#include "AllOperationTableColSpec\AllOperationTableColSpec.h"
#include "CDlgOperationTableCsvExport.h"
#include "CDlgAllOperationTableProp.h"
#include "..\ViewOperationTable\COperationTableView.h"
#include "..\ViewDiagram\cdeddiagramview.h"
#include "CconvAllOperationTableCsv.h"
#include "str\CsvDocument\CconvCsvDocument.h"
#include "str\vectorToFile.h"


// ****************************************************************
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
// ****************************************************************

namespace ViewAllOperationTable {
using namespace std ;


// --------------------------------
///@name	Yԍ
// --------------------------------
///@{
/**
YԍFwb_
*/
const int YCOLUMNNNO_HEADER = 0 ;
/**
YԍF^p0Ԗ
*/
const int YCOLUMNNNO_OPERATION_0 = 1 ;
///@}

/**
@return
	^pꗗr[̃tHg̑Ԃ܂B
*/
static CdFontProp createFontProp()
{
	CdDedDispProp aCdDedDispProp = getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp();
	return aCdDedDispProp.getJikokuhyouFont(0);
	//return ( CConverter_WinGdi().CdFontPropOf( DEFAULT_GUI_FONT ) ) ;
}


	// --------------------------------
	//@name	֐
	// --------------------------------
CdAllOperationTableXColSpecCont
CWndDcdGridAllOperationTable::createXColSpecCont()
{
	CdAllOperationTableXColSpecCont aSpecCont(
		getCDiagramEditDoc()->getCDedRosenFileData()
		->getCdDedDispProp().getDisplayRessyamei(),
		m_bDisplayAllRessya,
		m_iMaxRessyaCount);
	return aSpecCont ;
}

CdAllOperationTableYColSpecCont
CWndDcdGridAllOperationTable::createYColSpecCont()
{
	CdAllOperationTableYColSpecCont aSpecCont(
		m_strOperationNumber.size());
	return aSpecCont ;
}

CdAllOperationTableXColSpec
CWndDcdGridAllOperationTable::getXColSpecOfFocus()
{
	CdAllOperationTableXColSpec aSpec ;
	CdDcdPosXy aPos = getCFocus()->getFocusCellColumnNumber() ;
	if ( aPos != getCFocus()->ColumnNumberPosXy_NULL() )
	{
		CdAllOperationTableXColSpecCont aSpecCont(
			getCDiagramEditDoc()->getCDedRosenFileData()
			->getCdDedDispProp().getDisplayRessyamei(),
			m_bDisplayAllRessya,
			m_iMaxRessyaCount);
		aSpec = aSpecCont.ColumnNumberToSpec( aPos.getX() ) ;
	}
	return aSpec ;
}

CdAllOperationTableYColSpec
CWndDcdGridAllOperationTable::getYColSpecOfFocus()
{
	CdAllOperationTableYColSpec aSpec ;
	CdDcdPosXy aPos = getCFocus()->getFocusCellColumnNumber() ;
	if ( aPos != getCFocus()->ColumnNumberPosXy_NULL() )
	{
		CdAllOperationTableYColSpecCont aSpecCont(
			m_strOperationNumber.size());
		aSpec = aSpecCont.ColumnNumberToSpec( aPos.getY() ) ;
	}
	return aSpec ;
}
	
	// --------------------------------
	//@name OnUpdate ̉֐
	// --------------------------------

const CdDedJikoku::CConv
CWndDcdGridAllOperationTable::getCdDedJikokuConv()const
{
	//if (m_bDisplaySecondEkiJikoku)
	//{
	//	if (m_bDisplayColonEkiJikoku)
	//	{
	//		static CdDedJikoku::CConv aConv(
	//			false,		//	RL
	//						//  00  09 ̏ꍇA10̈ʂ "0" Xy[Xɂ܂B
	//			CdDedJikoku::CConv::EHour_ZeroToSpace,
	//			CdDedJikoku::CConv::ESecond_Output 	// b\܂
	//		);
	//		return aConv;
	//	}
	//	else
	//	{
	//		static CdDedJikoku::CConv aConv(
	//			true,		//	R
	//						//  00  09 ̏ꍇA10̈ʂ "0" Xy[Xɂ܂B
	//			CdDedJikoku::CConv::EHour_ZeroToSpace,
	//			CdDedJikoku::CConv::ESecond_Output 	// b\܂
	//		);
	//		return aConv;
	//	}
	//}
	//else
	//{
	//	if (m_bDisplayColonEkiJikoku)
	//	{
	//		static CdDedJikoku::CConv aConv(
	//			false,		//	RL
	//						//  00  09 ̏ꍇA10̈ʂ "0" Xy[Xɂ܂B
	//			CdDedJikoku::CConv::EHour_ZeroToSpace,
	//			CdDedJikoku::CConv::ESecond_NoSecond 	// bɏo͂܂B
	//		);
	//		return aConv;
	//	}
	//	else
	//	{
	//		static CdDedJikoku::CConv aConv(
	//			true,		//	R
	//						//  00  09 ̏ꍇA10̈ʂ "0" Xy[Xɂ܂B
	//			CdDedJikoku::CConv::EHour_ZeroToSpace,
	//			CdDedJikoku::CConv::ESecond_NoSecond 	// bɏo͂܂B
	//		);
	//		return aConv;
	//	}
	//}

	CdDedJikoku::CConv::ESecond eSecond = CdDedJikoku::CConv::ESecond_NoSecond;
	if (m_bDisplaySecondEkiJikoku)
	{
		eSecond = CdDedJikoku::CConv::ESecond_Output;
	}

	CdDedJikoku::CConv aConv(
		!m_bDisplayColonEkiJikoku,
		CdDedJikoku::CConv::EHour_ZeroToSpace,
		eSecond,
		(CdDedJikoku::CConv::ESecondRound)m_iSecondRoundChaku,
		(CdDedJikoku::CConv::ESecondRound)m_iSecondRoundHatsu,
		m_bDisplay2400
	);
	return aConv;
}

void CWndDcdGridAllOperationTable::OnUpdate_setOperationTableContent_To_Column(
	int iYColumnNumber ,
	const tstring strOperationNumber,
	const list<OperationTableContent>& ListOperationTableContent)
{
	const Mu<const CentDedRessya*>* pCentDedRessyaConts[2];
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		pCentDedRessyaConts[iRessyahoukou] = getCentDedRessyaCont((ERessyahoukou)iRessyahoukou)->getMuPtr();
	}


	CdFontProp fontpropDefault = createFontProp() ;
	CdAllOperationTableXColSpecCont aXColSpecCont = createXColSpecCont();

	// --------------------------------
	//	sYTCYݒ
	// --------------------------------
	{
		CDcdTargetGetDC	aCDcdTarget( NULL ) ;

		CdDcdSizeXy	sizeRessyamei ;
		CDcdTextbox	aCDcdTextbox(_T("sss") ,
			fontpropDefault , 
			_T("") , 1 , 2 , 2 ) ;
		aCDcdTextbox.getItemSize( &aCDcdTarget , &sizeRessyamei) ;

		getCXDcdGrid()->getYColumn( iYColumnNumber )->setColumnSize(sizeRessyamei.getY() ) ;
	}


	// --------------------------------
	//	ݒ
	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* pCdDedEkiConts[2];
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		pCdDedEkiConts[iRessyahoukou] =
			getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getCentDedEkiCont()->getMuPtr((ERessyahoukou)iRessyahoukou);
	}

	const CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuCont =
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getCentDedRessyasyubetsuCont();

	const OperationTableContent aOperationTableContentOut = ListOperationTableContent.front();
	const OperationTableContent aOperationTableContentIn = ListOperationTableContent.back();

	const CentDedRessya* pCentDedRessyaOut =
		pCentDedRessyaConts[aOperationTableContentOut.aRessyaProperty.getRessyahoukou()]
		->get(aOperationTableContentOut.aRessyaProperty.getRessyaIndex());
	const CentDedRessya* pCentDedRessyaIn =
		pCentDedRessyaConts[aOperationTableContentIn.aRessyaProperty.getRessyahoukou()]
		->get(aOperationTableContentIn.aRessyaProperty.getRessyaIndex());

	const CentDedRessyasyubetsu* pCentDedRessyasyubetsuOut = pCentDedRessyasyubetsuCont
		->getMuPtr()->get(pCentDedRessyaOut->getRessyasyubetsuIndex());
	if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsuOut->getParentSyubetsuIndex() >= 0)
	{
		pCentDedRessyasyubetsuOut = pCentDedRessyasyubetsuCont
			->getMuPtr()->get(pCentDedRessyasyubetsuOut->getParentSyubetsuIndex());
	}
	const CentDedRessyasyubetsu* pCentDedRessyasyubetsuIn = pCentDedRessyasyubetsuCont
		->getMuPtr()->get(pCentDedRessyaIn->getRessyasyubetsuIndex());
	if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsuIn->getParentSyubetsuIndex() >= 0)
	{
		pCentDedRessyasyubetsuIn = pCentDedRessyasyubetsuCont
			->getMuPtr()->get(pCentDedRessyasyubetsuIn->getParentSyubetsuIndex());
	}

	tstring strRessyahoukouKudari;
	tstring strRessyahoukouNobori;
	CString strRessyahoukouTemp;
	if (getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getKudariDiaAlias().empty())
	{
		strRessyahoukouTemp.LoadString(IDS_WORD_Kudari);
		strRessyahoukouKudari = (LPCTSTR)strRessyahoukouTemp;
	}
	else
	{
		strRessyahoukouKudari = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getKudariDiaAlias().c_str();
	}
	if (getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getNoboriDiaAlias().empty())
	{
		strRessyahoukouTemp.LoadString(IDS_WORD_Nobori);
		strRessyahoukouNobori = (LPCTSTR)strRessyahoukouTemp;
	}
	else
	{
		strRessyahoukouNobori = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getNoboriDiaAlias().c_str();
	}

	{
		//	ԍ
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_ColumnNumber));
		Ou<CDcdTextbox> pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
		pCDcdTextbox->
			setText(to_tstring(iYColumnNumber - YCOLUMNNNO_OPERATION_0 + 1));

		//	tHg
		CdDrawTextProp	aCdDrawTextProp =
			pCDcdTextbox->getCdDrawTextProp();
		aCdDrawTextProp.setCdFontProp(fontpropDefault);
		aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

		//	Z𖳌
		InvalidateCell(iXColumnNumber, iYColumnNumber);
	}
	{
		//	^pԍ
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_OperationNumber));
		Ou<CDcdTextbox> pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
		pCDcdTextbox->
			setText(strOperationNumber);

		//	tHg
		CdDrawTextProp	aCdDrawTextProp =
			pCDcdTextbox->getCdDrawTextProp();
		aCdDrawTextProp.setCdFontProp(fontpropDefault);
		aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

		//	Z𖳌
		InvalidateCell(iXColumnNumber, iYColumnNumber);
	}
	{
		//	ow&ow
		int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_OutEkimei));
		int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_OutHatsujikoku));
		Ou<CDcdTextbox> pCDcdTextbox1 =
			getCXDcdGrid()->getCell(iXColumnNumber1, iYColumnNumber)->getIfDcDraw();
		Ou<CDcdTextbox> pCDcdTextbox2 =
			getCXDcdGrid()->getCell(iXColumnNumber2, iYColumnNumber)->getIfDcDraw();

		tstring strEkimei;
		CdDedJikoku aCdDedJikoku;
		if (ListOperationTableContent.front().iOuterShihatsuekiIndex != INT_MIN)
		{
			int iOuterTerminalIndex = aOperationTableContentOut.iOuterShihatsuekiIndex;
			strEkimei = pCdDedEkiConts[aOperationTableContentOut.aRessyaProperty.getRessyahoukou()]
				->get(aOperationTableContentOut.iSihatsuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
			aCdDedJikoku = aOperationTableContentOut.OuterShihatsuJikoku;
		}
		else
		{
			int iSihatsuEkiOrder = aOperationTableContentOut.iSihatsuEkiOrder;
			if (!pCentDedRessyaOut->isRunBetweenNextEki(iSihatsuEkiOrder))
			{
				iSihatsuEkiOrder = pCentDedRessyaOut->getRunBetweenEkiForward(iSihatsuEkiOrder);
			}

			strEkimei = pCdDedEkiConts[aOperationTableContentOut.aRessyaProperty.getRessyahoukou()]
				->get(iSihatsuEkiOrder).getEkimei();
			aCdDedJikoku = pCentDedRessyaOut->getCentDedEkiJikoku(iSihatsuEkiOrder).getHatsujikoku();
		}
		pCDcdTextbox1->setText(strEkimei);
		pCDcdTextbox2->
			setText(getCdDedJikokuConv().encode(aCdDedJikoku, false));

		//	tHg
		CdDrawTextProp	aCdDrawTextProp1 =
			pCDcdTextbox1->getCdDrawTextProp();
		aCdDrawTextProp1.setCdFontProp(fontpropDefault);
		aCdDrawTextProp1.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox1->setCdDrawTextProp(aCdDrawTextProp1);

		CdDrawTextProp	aCdDrawTextProp2 =
			pCDcdTextbox2->getCdDrawTextProp();
		aCdDrawTextProp2.setCdFontProp(fontpropDefault);
		aCdDrawTextProp2.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox2->setCdDrawTextProp(aCdDrawTextProp2);

		//	Z𖳌
		InvalidateCell(iXColumnNumber1, iYColumnNumber);
		InvalidateCell(iXColumnNumber2, iYColumnNumber);
	}
	{
		//	
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_Arrow));
		Ou<CDcdTextbox> pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

		tstring strArrow = _T("");
		pCDcdTextbox->setText(strArrow);

		//	tHg
		CdDrawTextProp	aCdDrawTextProp =
			pCDcdTextbox->getCdDrawTextProp();
		aCdDrawTextProp.setCdFontProp(fontpropDefault);
		aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

		//	Z𖳌
		InvalidateCell(iXColumnNumber, iYColumnNumber);
	}
	{
		//	ԎnIw&ԉw
		int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_InEkimei));
		int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_InChakujikoku));
		Ou<CDcdTextbox> pCDcdTextbox1 =
			getCXDcdGrid()->getCell(iXColumnNumber1, iYColumnNumber)->getIfDcDraw();
		Ou<CDcdTextbox> pCDcdTextbox2 =
			getCXDcdGrid()->getCell(iXColumnNumber2, iYColumnNumber)->getIfDcDraw();

		tstring strEkimei;
		CdDedJikoku aCdDedJikoku;
		if (aOperationTableContentIn.iOuterShuchakuekiIndex != INT_MIN)
		{
			int iOuterTerminalIndex = aOperationTableContentIn.iOuterShuchakuekiIndex;
			strEkimei = pCdDedEkiConts[aOperationTableContentIn.aRessyaProperty.getRessyahoukou()]
				->get(aOperationTableContentIn.iSyuuchakuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
			aCdDedJikoku = aOperationTableContentIn.OuterShuchakuJikoku;
		}
		else
		{
			int iSyuuchakuEkiOrder = aOperationTableContentIn.iSyuuchakuEkiOrder;
			if (!pCentDedRessyaIn->isRunBetweenNextEki(iSyuuchakuEkiOrder - 1))
			{
				iSyuuchakuEkiOrder = pCentDedRessyaIn->getRunBetweenEkiBackward(iSyuuchakuEkiOrder);
			}

			strEkimei = pCdDedEkiConts[aOperationTableContentIn.aRessyaProperty.getRessyahoukou()]
				->get(iSyuuchakuEkiOrder).getEkimei();
			aCdDedJikoku = pCentDedRessyaIn->getCentDedEkiJikoku(iSyuuchakuEkiOrder).getChakujikoku();
		}
		pCDcdTextbox1->setText(strEkimei);
		pCDcdTextbox2->
			setText(getCdDedJikokuConv().encode(aCdDedJikoku, true));

		//	tHg
		CdDrawTextProp	aCdDrawTextProp1 =
			pCDcdTextbox1->getCdDrawTextProp();
		aCdDrawTextProp1.setCdFontProp(fontpropDefault);
		aCdDrawTextProp1.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox1->setCdDrawTextProp(aCdDrawTextProp1);

		CdDrawTextProp	aCdDrawTextProp2 =
			pCDcdTextbox2->getCdDrawTextProp();
		aCdDrawTextProp2.setCdFontProp(fontpropDefault);
		aCdDrawTextProp2.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox2->setCdDrawTextProp(aCdDrawTextProp2);

		//	Z𖳌
		InvalidateCell(iXColumnNumber1, iYColumnNumber);
		InvalidateCell(iXColumnNumber2, iYColumnNumber);
	}

	if (m_bDisplayAllRessya)
	{
		int iRessyaIndex = 0;
		for (auto itr = ListOperationTableContent.begin(); itr != ListOperationTableContent.end(); itr++, iRessyaIndex++)
		{
			const CentDedRessya* pCentDedRessya =
				pCentDedRessyaConts[itr->aRessyaProperty.getRessyahoukou()]
				->get(itr->aRessyaProperty.getRessyaIndex());

			const CentDedRessyasyubetsu* pCentDedRessyasyubetsu = pCentDedRessyasyubetsuCont
				->getMuPtr()->get(pCentDedRessya->getRessyasyubetsuIndex());
			if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
			{
				pCentDedRessyasyubetsu = pCentDedRessyasyubetsuCont
					->getMuPtr()->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
			}

			{
				//	ԕ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
				tstring strRessyahoukou;
				if (pCentDedRessya->getRessyahoukou() == Ressyahoukou_Kudari)
				{
					strRessyahoukou = strRessyahoukouKudari;
				}
				else
				{
					strRessyahoukou = strRessyahoukouNobori;
				}
				pCDcdTextbox->
					setText(strRessyahoukou);

				//	tHg
				CdDrawTextProp	aCdDrawTextProp =
					pCDcdTextbox->getCdDrawTextProp();
				aCdDrawTextProp.setCdFontProp(fontpropDefault);
				aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}
			{
				//	Ԕԍ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyabangou, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
				pCDcdTextbox->
					setText(pCentDedRessya->getRessyabangou());

				//	tHg
				CdDrawTextProp	aCdDrawTextProp =
					pCDcdTextbox->getCdDrawTextProp();
				aCdDrawTextProp.setCdFontProp(fontpropDefault);
				aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}
			{
				//	Ԏ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

				//ʂ̃eLXg
				pCDcdTextbox->setText(pCentDedRessyasyubetsu->getSyubetsumei());

				//ʂ̃tHg
				CdDrawTextProp	aCdDrawTextProp =
					pCDcdTextbox->getCdDrawTextProp();
				aCdDrawTextProp.setCdFontProp(fontpropDefault);
				{
					aCdDrawTextProp.setTextColor(pCentDedRessyasyubetsu->getJikokuhyouMojiColor());

					int idxFont = pCentDedRessyasyubetsu->getJikokuhyouFontIndex();
					aCdDrawTextProp.setCdFontProp(
						getCDiagramEditDoc()->getCDedRosenFileData()
						->getCdDedDispProp().getJikokuhyouFont(idxFont));
				}
				aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}
			if (getCDiagramEditDoc()->getCDedRosenFileData()
				->getCdDedDispProp().getDisplayRessyamei())
			{
				//	Ԗ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyamei, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

				//Ԗ̃eLXg
				tstring strRessyamei = pCentDedRessya->getRessyamei();
				if (!pCentDedRessya->getGousuu().empty())
				{
					strRessyamei += _T(" ");
					strRessyamei += pCentDedRessya->getGousuu();
					strRessyamei += _T("");
				}
				pCDcdTextbox->setText(strRessyamei);

				//Ԗ̃tHg
				CdDrawTextProp	aCdDrawTextProp =
					pCDcdTextbox->getCdDrawTextProp();
				aCdDrawTextProp.setCdFontProp(fontpropDefault);
				{
					aCdDrawTextProp.setTextColor(pCentDedRessyasyubetsu->getJikokuhyouMojiColor());

					int idxFont = pCentDedRessyasyubetsu->getJikokuhyouFontIndex();
					aCdDrawTextProp.setCdFontProp(
						getCDiagramEditDoc()->getCDedRosenFileData()
						->getCdDedDispProp().getJikokuhyouFont(idxFont));
				}
				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}

			if (iRessyaIndex < m_iMaxRessyaCount - 1)
			{
				//	
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_RessyaArrow, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

				if (iRessyaIndex < (int)ListOperationTableContent.size() - 1)
				{
					tstring strArrow = _T("");
					pCDcdTextbox->setText(strArrow);
				}
				else
				{
					pCDcdTextbox->setText(_T(""));
				}

				//	tHg
				CdDrawTextProp	aCdDrawTextProp =
					pCDcdTextbox->getCdDrawTextProp();
				aCdDrawTextProp.setCdFontProp(fontpropDefault);
				aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}
		}
		/**
			Ԗ{MaxRessyaCountꍇ́A󔒃Xy[X𖄂߂܂B
		*/
		for (;iRessyaIndex < m_iMaxRessyaCount; iRessyaIndex++)
		{
			{
				//	ԕ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
				pCDcdTextbox->setText(_T(""));
				
				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}
			{
				//	Ԕԍ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyabangou, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
				pCDcdTextbox->setText(_T(""));

				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}
			{
				//	Ԏ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
				pCDcdTextbox->setText(_T(""));

				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}
			if (getCDiagramEditDoc()->getCDedRosenFileData()
				->getCdDedDispProp().getDisplayRessyamei())
			{
				//	Ԗ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyamei, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
				pCDcdTextbox->setText(_T(""));
				
				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}

			if (iRessyaIndex < m_iMaxRessyaCount - 1)
			{
				//	
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_RessyaArrow, iRessyaIndex));
				Ou<CDcdTextbox> pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
				pCDcdTextbox->setText(_T(""));

				//	Z𖳌
				InvalidateCell(iXColumnNumber, iYColumnNumber);
			}
		}
	}
	else
	{
		{
			//	oԕ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, 0));
			Ou<CDcdTextbox> pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
			tstring strRessyahoukou;
			if (pCentDedRessyaOut->getRessyahoukou() == Ressyahoukou_Kudari)
			{
				strRessyahoukou = strRessyahoukouKudari;
			}
			else
			{
				strRessyahoukou = strRessyahoukouNobori;
			}
			pCDcdTextbox->
				setText(strRessyahoukou);

			//	tHg
			CdDrawTextProp	aCdDrawTextProp =
				pCDcdTextbox->getCdDrawTextProp();
			aCdDrawTextProp.setCdFontProp(fontpropDefault);
			aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

			//	Z𖳌
			InvalidateCell(iXColumnNumber, iYColumnNumber);
		}
		{
			//	oԔԍ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyabangou, 0));
			Ou<CDcdTextbox> pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
			pCDcdTextbox->
				setText(pCentDedRessyaOut->getRessyabangou());

			//	tHg
			CdDrawTextProp	aCdDrawTextProp =
				pCDcdTextbox->getCdDrawTextProp();
			aCdDrawTextProp.setCdFontProp(fontpropDefault);
			aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

			//	Z𖳌
			InvalidateCell(iXColumnNumber, iYColumnNumber);
		}
		{
			//	oԎ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, 0));
			Ou<CDcdTextbox> pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

			//ʂ̃eLXg
			pCDcdTextbox->setText(pCentDedRessyasyubetsuOut->getSyubetsumei());

			//ʂ̃tHg
			CdDrawTextProp	aCdDrawTextProp =
				pCDcdTextbox->getCdDrawTextProp();
			aCdDrawTextProp.setCdFontProp(fontpropDefault);
			{
				aCdDrawTextProp.setTextColor(pCentDedRessyasyubetsuOut->getJikokuhyouMojiColor());

				int idxFont = pCentDedRessyasyubetsuOut->getJikokuhyouFontIndex();
				aCdDrawTextProp.setCdFontProp(
					getCDiagramEditDoc()->getCDedRosenFileData()
					->getCdDedDispProp().getJikokuhyouFont(idxFont));
			}
			aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

			//	Z𖳌
			InvalidateCell(iXColumnNumber, iYColumnNumber);
		}
		if (getCDiagramEditDoc()->getCDedRosenFileData()
			->getCdDedDispProp().getDisplayRessyamei())
		{
			//	oԖ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyamei, 0));
			Ou<CDcdTextbox> pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

			//Ԗ̃eLXg
			tstring strRessyamei = pCentDedRessyaOut->getRessyamei();
			if (!pCentDedRessyaOut->getGousuu().empty())
			{
				strRessyamei += _T(" ");
				strRessyamei += pCentDedRessyaOut->getGousuu();
				strRessyamei += _T("");
			}
			pCDcdTextbox->setText(strRessyamei);

			//Ԗ̃tHg
			CdDrawTextProp	aCdDrawTextProp =
				pCDcdTextbox->getCdDrawTextProp();
			aCdDrawTextProp.setCdFontProp(fontpropDefault);
			{
				aCdDrawTextProp.setTextColor(pCentDedRessyasyubetsuOut->getJikokuhyouMojiColor());

				int idxFont = pCentDedRessyasyubetsuOut->getJikokuhyouFontIndex();
				aCdDrawTextProp.setCdFontProp(
					getCDiagramEditDoc()->getCDedRosenFileData()
					->getCdDedDispProp().getJikokuhyouFont(idxFont));
			}
			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

			//	Z𖳌
			InvalidateCell(iXColumnNumber, iYColumnNumber);
		}

		{
			//	
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_RessyaArrow, 0));
			Ou<CDcdTextbox> pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

			tstring strArrow = _T("");
			pCDcdTextbox->setText(strArrow);

			//	tHg
			CdDrawTextProp	aCdDrawTextProp =
				pCDcdTextbox->getCdDrawTextProp();
			aCdDrawTextProp.setCdFontProp(fontpropDefault);
			aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

			//	Z𖳌
			InvalidateCell(iXColumnNumber, iYColumnNumber);
		}

		{
			//	ԕ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, 1));
			Ou<CDcdTextbox> pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
			tstring strRessyahoukou;
			if (pCentDedRessyaIn->getRessyahoukou() == Ressyahoukou_Kudari)
			{
				strRessyahoukou = strRessyahoukouKudari;
			}
			else
			{
				strRessyahoukou = strRessyahoukouNobori;
			}
			pCDcdTextbox->
				setText(strRessyahoukou);

			//	tHg
			CdDrawTextProp	aCdDrawTextProp =
				pCDcdTextbox->getCdDrawTextProp();
			aCdDrawTextProp.setCdFontProp(fontpropDefault);
			aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

			//	Z𖳌
			InvalidateCell(iXColumnNumber, iYColumnNumber);
		}
		{
			//	Ԕԍ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyabangou, 1));
			Ou<CDcdTextbox> pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
			pCDcdTextbox->
				setText(pCentDedRessyaIn->getRessyabangou());

			//	tHg
			CdDrawTextProp	aCdDrawTextProp =
				pCDcdTextbox->getCdDrawTextProp();
			aCdDrawTextProp.setCdFontProp(fontpropDefault);
			aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

			//	Z𖳌
			InvalidateCell(iXColumnNumber, iYColumnNumber);
		}
		{
			//	Ԏ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, 1));
			Ou<CDcdTextbox> pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

			//ʂ̃eLXg
			pCDcdTextbox->setText(pCentDedRessyasyubetsuIn->getSyubetsumei());

			//ʂ̃tHg
			CdDrawTextProp	aCdDrawTextProp =
				pCDcdTextbox->getCdDrawTextProp();
			aCdDrawTextProp.setCdFontProp(fontpropDefault);
			{
				aCdDrawTextProp.setTextColor(pCentDedRessyasyubetsuIn->getJikokuhyouMojiColor());

				int idxFont = pCentDedRessyasyubetsuIn->getJikokuhyouFontIndex();
				aCdDrawTextProp.setCdFontProp(
					getCDiagramEditDoc()->getCDedRosenFileData()
					->getCdDedDispProp().getJikokuhyouFont(idxFont));
			}
			aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

			//	Z𖳌
			InvalidateCell(iXColumnNumber, iYColumnNumber);
		}
		if (getCDiagramEditDoc()->getCDedRosenFileData()
			->getCdDedDispProp().getDisplayRessyamei())
		{
			//	Ԗ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyamei, 1));
			Ou<CDcdTextbox> pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

			//Ԗ̃eLXg
			tstring strRessyamei = pCentDedRessyaIn->getRessyamei();
			if (!pCentDedRessyaIn->getGousuu().empty())
			{
				strRessyamei += _T(" ");
				strRessyamei += pCentDedRessyaIn->getGousuu();
				strRessyamei += _T("");
			}
			pCDcdTextbox->setText(strRessyamei);

			//Ԗ̃tHg
			CdDrawTextProp	aCdDrawTextProp =
				pCDcdTextbox->getCdDrawTextProp();
			aCdDrawTextProp.setCdFontProp(fontpropDefault);
			{
				aCdDrawTextProp.setTextColor(pCentDedRessyasyubetsuOut->getJikokuhyouMojiColor());

				int idxFont = pCentDedRessyasyubetsuIn->getJikokuhyouFontIndex();
				aCdDrawTextProp.setCdFontProp(
					getCDiagramEditDoc()->getCDedRosenFileData()
					->getCdDedDispProp().getJikokuhyouFont(idxFont));
			}
			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

			//	Z𖳌
			InvalidateCell(iXColumnNumber, iYColumnNumber);
		}
	}

}

void CWndDcdGridAllOperationTable::splitOperationNumber(
	const tstring strOperationNumberIn,
	vector<int>& iOperationNumber,
	vector<tstring>& strOperationNumberOut) const
{
	iOperationNumber.clear();
	strOperationNumberOut.clear();
	bool bIsDigit = false;
	bool bIsNotDigit = false;
	tstring strOperationNumberTemp = strOperationNumberIn;
	while (!strOperationNumberTemp.empty())
	{
		int idx = 0;
		if (_istdigit(strOperationNumberTemp[idx]) != 0)
		{
			if ((int)strOperationNumberTemp.size() == 1)
			{
				iOperationNumber.push_back(
					_ttoi(strOperationNumberTemp.c_str()));
				strOperationNumberOut.push_back(tstring());
				break;
			}
			//̏ꍇ
			bIsDigit = true;
		}
		else
		{
			if ((int)strOperationNumberTemp.size() == 1)
			{
				iOperationNumber.push_back(INT_MIN);
				strOperationNumberOut.push_back(strOperationNumberTemp);
				break;
			}
			//ȊȌꍇ
			bIsDigit = false;
		}
		idx++;
		for (; idx < (int)strOperationNumberTemp.size(); idx++)
		{
			if (idx == (int)strOperationNumberTemp.size() - 1)
			{
				if (bIsDigit && _istdigit(strOperationNumberTemp[idx]) != 0)
				{
					iOperationNumber.push_back(
						_ttoi(strOperationNumberTemp.c_str()));
					strOperationNumberOut.push_back(tstring());

					strOperationNumberTemp.clear();
					break;
				}
				else if (!bIsDigit && _istdigit(strOperationNumberTemp[idx]) == 0)
				{
					iOperationNumber.push_back(INT_MIN);
					strOperationNumberOut.push_back(strOperationNumberTemp);

					strOperationNumberTemp.clear();
					break;
				}

			}
			if (_istdigit(strOperationNumberTemp[idx]) != 0)
			{
				//idxʒuŁA擪̏ꍇ
				if (!bIsDigit)
				{
					iOperationNumber.push_back(INT_MIN);
					strOperationNumberOut.push_back(strOperationNumberTemp.substr(0, idx));

					strOperationNumberTemp = strOperationNumberTemp.substr(idx);
					break;
				}
			}
			else
			{
				//idxʒuŁA擪̏ꍇ
				if (bIsDigit)
				{
					iOperationNumber.push_back(
						_ttoi(strOperationNumberTemp.substr(0, idx).c_str()));
					strOperationNumberOut.push_back(tstring());

					strOperationNumberTemp = strOperationNumberTemp.substr(idx);
					break;
				}
			}
		}
	}
}

bool CWndDcdGridAllOperationTable::SortOperationNumber(
	const tstring strOperationNumber1, 
	const tstring strOperationNumber2)
{
	if (strOperationNumber2.empty())
	{
		return true;
	}
	if (strOperationNumber1.empty())
	{
		return false;
	}


	vector<int> iOperationNumber1;
	vector<int> iOperationNumber2;
	vector<tstring> strOperationNumber1Part;
	vector<tstring> strOperationNumber2Part;
	splitOperationNumber(strOperationNumber1, iOperationNumber1, strOperationNumber1Part);
	splitOperationNumber(strOperationNumber2, iOperationNumber2, strOperationNumber2Part);

	if (m_bCompareBottom)
	{
		int iSize1 = iOperationNumber1.size();
		int iSize2 = iOperationNumber2.size();
		int iMin = min(iSize1, iSize2);
		for (int idx = 1; idx <= iMin; idx++)
		{
			// --------------------------------
			//	- ƂȊOł͐̕
			// --------------------------------
			{
				if (iOperationNumber1[iSize1 - idx] != INT_MIN && iOperationNumber2[iSize2 - idx] == INT_MIN)
				{
					return true;
				}
				else if (iOperationNumber1[iSize1 - idx] == INT_MIN && iOperationNumber2[iSize2 - idx] != INT_MIN)
				{
					return false;
				}
			}

			if (iOperationNumber1[iSize1 - idx] == INT_MIN)
			{
				//ɐȊȌꍇA
				// --------------------------------
				//	- ̒Z
				// --------------------------------
				{
					if (strOperationNumber1Part[iSize1 - idx].length() < strOperationNumber2Part[iSize2 - idx].length())
					{
						return true;
					}
					else if (strOperationNumber1Part[iSize1 - idx].length() > strOperationNumber2Part[iSize2 - idx].length())
					{
						return false;
					}
				}
				// --------------------------------
				//	- őB
				// --------------------------------
				{
					if (strOperationNumber1Part[iSize1 - idx] < strOperationNumber2Part[iSize2 - idx])
					{
						return true;
					}
					else if (strOperationNumber1Part[iSize1 - idx] > strOperationNumber2Part[iSize2 - idx])
					{
						return false;
					}
				}
			}
			else
			{
				//ɐ̏ꍇȂ召
				// --------------------------------
				//	- ̂
				// --------------------------------
				{
					if (iOperationNumber1[iSize1 - idx] < iOperationNumber2[iSize2 - idx])
					{
						return true;
					}
					else if (iOperationNumber1[iSize1 - idx] > iOperationNumber2[iSize2 - idx])
					{
						return false;
					}
				}
			}

		}
	}
	else
	{
		int iMin = min(iOperationNumber1.size(), iOperationNumber2.size());
		for (int idx = 0; idx < iMin; idx++)
		{
			// --------------------------------
			//	- ƂȊOł͐̕
			// --------------------------------
			{
				if (iOperationNumber1[idx] != INT_MIN && iOperationNumber2[idx] == INT_MIN)
				{
					return true;
				}
				else if (iOperationNumber1[idx] == INT_MIN && iOperationNumber2[idx] != INT_MIN)
				{
					return false;
				}
			}

			if (iOperationNumber1[idx] == INT_MIN)
			{
				//ɐȊȌꍇA
				// --------------------------------
				//	- ̒Z
				// --------------------------------
				{
					if (strOperationNumber1Part[idx].length() < strOperationNumber2Part[idx].length())
					{
						return true;
					}
					else if (strOperationNumber1Part[idx].length() > strOperationNumber2Part[idx].length())
					{
						return false;
					}
				}
				// --------------------------------
				//	- őB
				// --------------------------------
				{
					if (strOperationNumber1Part[idx] < strOperationNumber2Part[idx])
					{
						return true;
					}
					else if (strOperationNumber1Part[idx] > strOperationNumber2Part[idx])
					{
						return false;
					}
				}
			}
			else
			{
				//ɐ̏ꍇȂ召
				// --------------------------------
				//	- ̂
				// --------------------------------
				{
					if (iOperationNumber1[idx] < iOperationNumber2[idx])
					{
						return true;
					}
					else if (iOperationNumber1[idx] > iOperationNumber2[idx])
					{
						return false;
					}
				}
			}

		}
	}
	// --------------------------------
	//	- vfȂ̂
	// --------------------------------
	{
		if (iOperationNumber1.size() < iOperationNumber2.size())
		{
			return true;
		}
		else if (iOperationNumber1.size() > iOperationNumber2.size())
		{
			return false;
		}
	}

	return false;
}

bool CWndDcdGridAllOperationTable::SortOperation(
	const tstring strOperationNumber1,
	const int& iEkiIndex1,
	const int& iOuterIndex1,
	const CdDedJikoku& Jikoku1,
	const tstring strOperationNumber2,
	const int& iEkiIndex2,
	const int& iOuterIndex2,
	const CdDedJikoku& Jikoku2,
	const CdDedJikoku& KitenJikoku)
{
	if (strOperationNumber1.empty())
	{
		return false;
	}
	if (m_eOperationSort == EOperationSort_OperationNumber)
	{
		/**
			^pԍ
			^pԍCompareBottomɊÂŔ肵܂
			̉^pԍ͖̂ŁAʂ͈ӂɌ܂܂
		*/
		return SortOperationNumber(strOperationNumber1, strOperationNumber2);
	}
	else if (m_eOperationSort == EOperationSort_OutEki ||
		m_eOperationSort == EOperationSort_InEki)
	{
		/**
			ow
			(1)ow
			(2)
			(3)^pԍŕׂ܂
			(1)oẃAw̏ꍇiPosition=0̉wɏW񂵂܂B
				܂AHOn̏ꍇAȏoɂȂA
				HOnm̏ꍇAHOnwIndex̂ɂȂ܂
			(2)owvĂꍇAŕׂ܂B
				ȂAHOnwvĂꍇ́AHOnwŔr܂
			(3)owiHOnwjAvĂꍇ́A^pԍŕׂ܂B
		*/

		if (iEkiIndex1 < iEkiIndex2)
		{
			return true;
		}
		else if (iEkiIndex1 > iEkiIndex2)
		{
			return false;
		}

		if (iOuterIndex1 < iOuterIndex2)
		{
			return true;
		}
		else if (iOuterIndex1 > iOuterIndex2)
		{
			return false;
		}

		if (Jikoku1.compare(Jikoku2, KitenJikoku) < 0)
		{
			return true;
		}
		else if (Jikoku1.compare(Jikoku2, KitenJikoku) > 0)
		{
			return false;
		}

		return SortOperationNumber(strOperationNumber1, strOperationNumber2);
	}
	else if (m_eOperationSort == EOperationSort_OutJikoku ||
		m_eOperationSort == EOperationSort_InJikoku)
	{
		/**
			
			(1)
			(2)^pԍŕׂ܂B
			(1)́AHOn̏ꍇAHOnwpĔr܂
		*/
		
		if (Jikoku1.compare(Jikoku2, KitenJikoku) < 0)
		{
			return true;
		}
		else if (Jikoku1.compare(Jikoku2, KitenJikoku) > 0)
		{
			return false;
		}

		return SortOperationNumber(strOperationNumber1, strOperationNumber2);
	}
	return false;
}


void  CWndDcdGridAllOperationTable::OnUpdate_All()
{
	CWaitCursor	aCWaitCursor ;	
	
	{
		//	R}hIuWFNgsɂZړŃZIɂȂȂ悤ɁA
		//	ZIAZI@\ꎞIɒ~܂B
		clearSelect();
		CPropStack aPropStack(this);
		aPropStack
			.CBoxSelect_setIsEnable(false)
			.CRandomSelect_setIsEnable(false);

		// --------------------------------		
		//	SvfXV
		// --------------------------------

		unordered_map<tstring, list<OperationTableContent>> contOperationTableContent =
			getCentDedDia()->getcontOperationTableContent();

		const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()->
			getCDedRosenFileData()->getCentDedRosen()->getCentDedEkiCont();
		const Mu<const CentDedRessya*>* pCentDedRessyaConts[2];
		for (int iRessyahoukou = Ressyahoukou_Kudari;
			iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
		{
			pCentDedRessyaConts[iRessyahoukou] = getCentDedRessyaCont((ERessyahoukou)iRessyahoukou)->getMuPtr();
		}
		const CdDedJikoku KitenJikoku = getCDiagramEditDoc()->getCDedRosenFileData()
			->getCentDedRosen()->getKitenJikoku();

		m_strOperationNumber.clear();
		vector<int> iEkiIndexCont;
		vector<int> iOuterIndexCont;
		vector<CdDedJikoku> JikokuCont;


		int iMaxRessyaCount = 0;
		for (auto itr = contOperationTableContent.begin();
			itr != contOperationTableContent.end(); itr++)
		{
			if ((int)itr->second.size() > iMaxRessyaCount)
			{
				iMaxRessyaCount = itr->second.size();
			}

			int iEkiIndexTemp;
			int iOuterIndexTemp;
			CdDedJikoku JikokuTemp;
			if (m_eOperationSort == EOperationSort_OutEki)
			{
				OperationTableContent aShihatsuOperationTableContent = itr->second.front();
				iEkiIndexTemp = pCentDedEkiCont->EkiIndexOfEkiOrder(
					aShihatsuOperationTableContent.aRessyaProperty.getRessyahoukou(),
					aShihatsuOperationTableContent.iSihatsuEkiOrder);
				const CentDedEki* pSihatsuEki = pCentDedEkiCont->getMuPtr()->get(iEkiIndexTemp);

				if (pSihatsuEki->getBrunchLoopPosition() != -1)
				{
					iEkiIndexTemp = pSihatsuEki->getEkiIndexLoop().front();
				}
				iOuterIndexTemp = aShihatsuOperationTableContent.iOuterShihatsuekiIndex;
				if (iOuterIndexTemp != INT_MIN)
				{
					JikokuTemp = aShihatsuOperationTableContent.OuterShihatsuJikoku;
				}
				else
				{
					int iSihatsuEkiOrder = aShihatsuOperationTableContent.iSihatsuEkiOrder;
					const CentDedRessya* pCentDedRessya =
						pCentDedRessyaConts[aShihatsuOperationTableContent.aRessyaProperty.getRessyahoukou()]
						->get(aShihatsuOperationTableContent.aRessyaProperty.getRessyaIndex());

					if (!pCentDedRessya->isRunBetweenNextEki(iSihatsuEkiOrder))
					{
						iSihatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iSihatsuEkiOrder);
					}

					JikokuTemp = pCentDedRessya->getCentDedEkiJikoku(iSihatsuEkiOrder).getHatsujikoku();
				}
			}
			else if (m_eOperationSort == EOperationSort_OutJikoku)
			{
				OperationTableContent aShihatsuOperationTableContent = itr->second.front();
				if (aShihatsuOperationTableContent.iOuterShihatsuekiIndex != INT_MIN)
				{
					JikokuTemp = aShihatsuOperationTableContent.OuterShihatsuJikoku;
				}
				else
				{
					int iSihatsuEkiOrder = aShihatsuOperationTableContent.iSihatsuEkiOrder;
					const CentDedRessya* pCentDedRessya =
						pCentDedRessyaConts[aShihatsuOperationTableContent.aRessyaProperty.getRessyahoukou()]
						->get(aShihatsuOperationTableContent.aRessyaProperty.getRessyaIndex());

					if (!pCentDedRessya->isRunBetweenNextEki(iSihatsuEkiOrder))
					{
						iSihatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iSihatsuEkiOrder);
					}

					JikokuTemp = pCentDedRessya->getCentDedEkiJikoku(iSihatsuEkiOrder).getHatsujikoku();
				}
			}
			else if (m_eOperationSort == EOperationSort_InEki)
			{
				OperationTableContent aSyuchakuOperationTableContent = itr->second.back();
				iEkiIndexTemp = pCentDedEkiCont->EkiIndexOfEkiOrder(
					aSyuchakuOperationTableContent.aRessyaProperty.getRessyahoukou(),
					aSyuchakuOperationTableContent.iSyuuchakuEkiOrder);
				const CentDedEki* pSyuchakuEki = pCentDedEkiCont->getMuPtr()->get(iEkiIndexTemp);

				if (pSyuchakuEki->getBrunchLoopPosition() != -1)
				{
					iEkiIndexTemp = pSyuchakuEki->getEkiIndexLoop().front();
				}
				iOuterIndexTemp = aSyuchakuOperationTableContent.iOuterShuchakuekiIndex;
				if (iOuterIndexTemp != INT_MIN)
				{
					JikokuTemp = aSyuchakuOperationTableContent.OuterShuchakuJikoku;
				}
				else
				{
					int iSyuuchakuEkiOrder = aSyuchakuOperationTableContent.iSyuuchakuEkiOrder;
					const CentDedRessya* pCentDedRessya =
						pCentDedRessyaConts[aSyuchakuOperationTableContent.aRessyaProperty.getRessyahoukou()]
						->get(aSyuchakuOperationTableContent.aRessyaProperty.getRessyaIndex());

					if (!pCentDedRessya->isRunBetweenNextEki(iSyuuchakuEkiOrder - 1))
					{
						iSyuuchakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iSyuuchakuEkiOrder);
					}

					JikokuTemp = pCentDedRessya->getCentDedEkiJikoku(iSyuuchakuEkiOrder).getChakujikoku();
				}
			}
			else if (m_eOperationSort == EOperationSort_InJikoku)
			{
				OperationTableContent aSyuchakuOperationTableContent = itr->second.back();
				if (aSyuchakuOperationTableContent.iOuterShuchakuekiIndex != INT_MIN)
				{
					JikokuTemp = aSyuchakuOperationTableContent.OuterShuchakuJikoku;
				}
				else
				{
					int iSyuuchakuEkiOrder = aSyuchakuOperationTableContent.iSyuuchakuEkiOrder;
					const CentDedRessya* pCentDedRessya =
						pCentDedRessyaConts[aSyuchakuOperationTableContent.aRessyaProperty.getRessyahoukou()]
						->get(aSyuchakuOperationTableContent.aRessyaProperty.getRessyaIndex());

					if (!pCentDedRessya->isRunBetweenNextEki(iSyuuchakuEkiOrder - 1))
					{
						iSyuuchakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iSyuuchakuEkiOrder);
					}

					JikokuTemp = pCentDedRessya->getCentDedEkiJikoku(iSyuuchakuEkiOrder).getChakujikoku();
				}
			}

			bool bInsert = false;
			for (int idx = 0; idx < (int)m_strOperationNumber.size(); idx++)
			{
				if (SortOperation(itr->first,iEkiIndexTemp, 
					iOuterIndexTemp, JikokuTemp,
					m_strOperationNumber[idx],iEkiIndexCont[idx], 
					iOuterIndexCont[idx], JikokuCont[idx],
					KitenJikoku))
				{
					m_strOperationNumber.insert(m_strOperationNumber.begin() + idx, itr->first);
					iEkiIndexCont.insert(iEkiIndexCont.begin() + idx, iEkiIndexTemp);
					iOuterIndexCont.insert(iOuterIndexCont.begin() + idx, iOuterIndexTemp);
					JikokuCont.insert(JikokuCont.begin() + idx, JikokuTemp);
					bInsert = true;
					break;
				}
			}
			if (!bInsert)
			{
				m_strOperationNumber.push_back(itr->first);
				iEkiIndexCont.push_back(iEkiIndexTemp);
				iOuterIndexCont.push_back(iOuterIndexTemp);
				JikokuCont.push_back(JikokuTemp);
			}
		}
		m_iMaxRessyaCount = iMaxRessyaCount;

		//	X񐔂𑝌
		CdAllOperationTableXColSpecCont aXColSpecCont = createXColSpecCont();
		int iXCount = getCXDcdGrid()->getXColumnCount();
		if (iXCount != aXColSpecCont.size())
		{
			OnCreate_Header();
		}

		getCXDcdGrid()->setYColumnCount(
			contOperationTableContent.size() + YCOLUMNNNO_OPERATION_0);

			//	eZɁAf[^ݒ
		for (int idxOperation = 0; idxOperation < (int)m_strOperationNumber.size(); idxOperation++)
		{
			OnUpdate_setOperationTableContent_To_Column(
				idxOperation + YCOLUMNNNO_OPERATION_0,
				m_strOperationNumber[idxOperation],
				contOperationTableContent[m_strOperationNumber[idxOperation]]);
		}
	}
	m_bUpdate_All_Requested = false ;
}

void CWndDcdGridAllOperationTable::OnCreate_Header()
{
	// --------------------------------
	//	^p\r[ɎgptHg
	// --------------------------------
	CdFontProp fontpropDefault = createFontProp();

	CdAllOperationTableXColSpecCont aXColSpecCont = createXColSpecCont();
	// --------------------------------
	//	̐w
	// --------------------------------

	getCXDcdGrid()->setXColumnCount(aXColSpecCont.size());
	getCXDcdGrid()->setXFixColumnCount(aXColSpecCont.ColumnNumberFromSpec(
		CdAllOperationTableXColSpec::ColumnType_InChakujikoku) + 1);

	bool bDisplayRessyamei = getCDiagramEditDoc()->getCDedRosenFileData()
		->getCdDedDispProp().getDisplayRessyamei();

	// --------------------------------
	//	̃TCYݒ
	// --------------------------------
	{
		CDcdTargetGetDC	aCDcdTarget(NULL);
		// --------------------------------
		//	X
		// --------------------------------
		tstring strCellRessyaBangouWidth(
			getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp().getJikokuhyouRessyaWidth(), '0');
		if (strCellRessyaBangouWidth.length() < 8)
		{
			strCellRessyaBangouWidth = tstring(8, '0');
		}
		tstring strCellEkijikokuWidth(
			getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp().getJikokuhyouRessyaWidth(), '0');
		if (strCellEkijikokuWidth.length() < 6)
		{
			strCellEkijikokuWidth = tstring(6, '0');
		}
		tstring strCellEkimeiLength(
			getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp().getEkimeiLength() * 2, '0');
		const CentDedRessyasyubetsuCont* pRessyasyubetsuCont = getCDiagramEditDoc()->getCDedRosenFileData()
			->getCentDedRosen()->getCentDedRessyasyubetsuCont();
		tstring strCellRessyasyubetsuWidth = _T("sss");
		for (int idxSyubetsu = 0; idxSyubetsu < pRessyasyubetsuCont->size(); idxSyubetsu++)
		{
			if (strCellRessyasyubetsuWidth.length() < pRessyasyubetsuCont->get(idxSyubetsu).getSyubetsumei().length())
			{
				strCellRessyasyubetsuWidth = pRessyasyubetsuCont->get(idxSyubetsu).getSyubetsumei();
			}
		}
		//CString strCRessyahoukou;
		//strCRessyahoukou.LoadString(IDS_WORD_Kudari);
		//tstring strRessyahoukou = (LPCTSTR)strCRessyahoukou;
		tstring strRessyahoukou = _T("o");
		if (getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getKudariDiaAlias().length()
			> strRessyahoukou.length())
		{
			strRessyahoukou = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getKudariDiaAlias();
		}
		if (getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getNoboriDiaAlias().length()
			> strRessyahoukou.length())
		{
			strRessyahoukou = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getNoboriDiaAlias();
		}
		{
			//	ԍ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_ColumnNumber));
			CdDcdSizeXy	sizeOperationTable;
			CDcdTextbox	aCDcdTextbox(
				_T("000") ,
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	^pԍ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_OperationNumber));
			CdDcdSizeXy	sizeOperationTable;
			CDcdTextbox	aCDcdTextbox(
				strCellRessyaBangouWidth,
				//"0" ,
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	onIw
			int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_OutEkimei));
			int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_InEkimei));
			CdDcdSizeXy	sizeOperationTable;

			CDcdTextbox	aCDcdTextbox(
				strCellEkimeiLength,
				//"sss",
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getXColumn(iXColumnNumber1)->setColumnSize(sizeOperationTable.getX());
			getCXDcdGrid()->getXColumn(iXColumnNumber2)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	ow
			int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_OutHatsujikoku));
			int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_InChakujikoku));
			CdDcdSizeXy	sizeOperationTable;

			CDcdTextbox	aCDcdTextbox(
				strCellEkijikokuWidth,
				//"sss",
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getXColumn(iXColumnNumber1)->setColumnSize(sizeOperationTable.getX());
			getCXDcdGrid()->getXColumn(iXColumnNumber2)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Arrow));
			CdDcdSizeXy	sizeOperationTable;

			CDcdTextbox	aCDcdTextbox(
				_T("s"),
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}

		if (m_bDisplayAllRessya)
		{
			for (int idx = 0; idx < m_iMaxRessyaCount; idx++)
			{
				{
					//	ԕ
					int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
						CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, idx));
					CdDcdSizeXy	sizeOperationTable;
					CDcdTextbox	aCDcdTextbox(
						strRessyahoukou,
						fontpropDefault,
						_T(""), 1, 2, 2);
					aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
					getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
				}
				{
					//	Ԕԍ
					int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
						CdAllOperationTableXColSpec::ColumnType_Ressyabangou, idx));
					CdDcdSizeXy	sizeOperationTable;
					CDcdTextbox	aCDcdTextbox(
						strCellRessyaBangouWidth,
						//"0" ,
						fontpropDefault,
						_T(""), 1, 2, 2);
					aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
					getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
				}
				{
					//	o
					int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
						CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, idx));
					CdDcdSizeXy	sizeOperationTable;
					CDcdTextbox	aCDcdTextbox(
						strCellRessyasyubetsuWidth,
						fontpropDefault,
						_T(""), 1, 2, 2);
					aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
					getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
				}
				if (getCDiagramEditDoc()->getCDedRosenFileData()
					->getCdDedDispProp().getDisplayRessyamei())
				{
					//	oԖ
					int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
						CdAllOperationTableXColSpec::ColumnType_Ressyamei, idx));
					CdDcdSizeXy	sizeOperationTable;

					CDcdTextbox	aCDcdTextbox(
						_T("ssssss"),
						fontpropDefault,
						_T(""), 1, 2, 2);
					aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

					getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
				}
				if (idx < m_iMaxRessyaCount - 1)
				{
					//	
					int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
						CdAllOperationTableXColSpec::ColumnType_RessyaArrow, idx));
					CdDcdSizeXy	sizeOperationTable;

					CDcdTextbox	aCDcdTextbox(
						_T("s"),
						fontpropDefault,
						_T(""), 1, 2, 2);
					aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

					getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
				}
			}
		}
		else
		{
			{
				//	oԕ
				int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, 0));
				int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, 1));
				CdDcdSizeXy	sizeOperationTable;
				CDcdTextbox	aCDcdTextbox(
					strRessyahoukou,
					fontpropDefault,
					_T(""), 1, 2, 2);
				aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
				getCXDcdGrid()->getXColumn(iXColumnNumber1)->setColumnSize(sizeOperationTable.getX());
				getCXDcdGrid()->getXColumn(iXColumnNumber2)->setColumnSize(sizeOperationTable.getX());
			}
			{
				//	oԔԍ
				int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyabangou, 0));
				int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyabangou, 1));
				CdDcdSizeXy	sizeOperationTable;
				CDcdTextbox	aCDcdTextbox(
					strCellRessyaBangouWidth,
					//"0" ,
					fontpropDefault,
					_T(""), 1, 2, 2);
				aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
				getCXDcdGrid()->getXColumn(iXColumnNumber1)->setColumnSize(sizeOperationTable.getX());
				getCXDcdGrid()->getXColumn(iXColumnNumber2)->setColumnSize(sizeOperationTable.getX());
			}
			{
				//	o
				int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, 0));
				int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, 1));
				CdDcdSizeXy	sizeOperationTable;
				CDcdTextbox	aCDcdTextbox(
					strCellRessyasyubetsuWidth,
					fontpropDefault,
					_T(""), 1, 2, 2);
				aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
				getCXDcdGrid()->getXColumn(iXColumnNumber1)->setColumnSize(sizeOperationTable.getX());
				getCXDcdGrid()->getXColumn(iXColumnNumber2)->setColumnSize(sizeOperationTable.getX());
			}
			if (getCDiagramEditDoc()->getCDedRosenFileData()
				->getCdDedDispProp().getDisplayRessyamei())
			{
				//	oԖ
				int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyamei, 0));
				int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyamei, 1));
				CdDcdSizeXy	sizeOperationTable;

				CDcdTextbox	aCDcdTextbox(
					_T("ssssss"),
					fontpropDefault,
					_T(""), 1, 2, 2);
				aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

				getCXDcdGrid()->getXColumn(iXColumnNumber1)->setColumnSize(sizeOperationTable.getX());
				getCXDcdGrid()->getXColumn(iXColumnNumber2)->setColumnSize(sizeOperationTable.getX());
			}
			{
				//	
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_RessyaArrow, 0));
				CdDcdSizeXy	sizeOperationTable;

				CDcdTextbox	aCDcdTextbox(
					_T("s"),
					fontpropDefault,
					_T(""), 1, 2, 2);
				aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

				getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
			}
		}
		// --------------------------------
		//	Y
		// --------------------------------
		{
			CdDcdSizeXy	sizeOperationTable;
			CDcdTextbox	aCDcdTextbox(
				_T("ssssss"),
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getYColumn(YCOLUMNNNO_HEADER)->setColumnSize(sizeOperationTable.getY());
		}
	}
	// --------------------------------
	//	ŏɑƃeLXgݒ
	// --------------------------------
	{
		// ԍ
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_ColumnNumber));

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText(_T(""));
	}
	{
		// ^pԍ
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_OperationNumber));
		CString	aString;
		aString = _T("^pԍ");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
	{
		// ow
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_OutEkimei));
		CString	aString;
		aString = _T("ow");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
		Ou<CDcdLine>
			(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
			->setCdPenProp(getCdPenPropDotLine());
	}
	{
		// 
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_OutHatsujikoku));
		CString	aString;
		aString = _T("");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
	{
		// 
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_Arrow));

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText(_T(""));
	}
	{
		// w
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_InEkimei));
		CString	aString;
		aString = _T("w");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
		Ou<CDcdLine>
			(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
			->setCdPenProp(getCdPenPropDotLine());
	}
	{
		// 
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
			CdAllOperationTableXColSpec::ColumnType_InChakujikoku));
		CString	aString;
		aString = _T("");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);

		Ou<CDcdLine>
			(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
			->setCdPenProp(getCdPenPropBoldLine());
	}

	if (m_bDisplayAllRessya)
	{
		for (int idx = 0; idx < m_iMaxRessyaCount; idx++)
		{
			{
				// ԕ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, idx));

				Ou<CDcdTextbox>	pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

				CConverter_WinGdi aCConverter_WinGdi;

				CdDrawTextProp	aCdDrawTextProp(
					fontpropDefault,
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
				aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
				CdBrushProp	aCdBrushProp(
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
				pCDcdTextbox->setCdBrushProp(aCdBrushProp);
				pCDcdTextbox->setText(to_tstring(idx + 1));

				Ou<CDcdLine>
					(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
					->setCdPenProp(getCdPenPropDotLine());
			}
			{
				// Ԕԍ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyabangou, idx));

				Ou<CDcdTextbox>	pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

				CConverter_WinGdi aCConverter_WinGdi;

				CdDrawTextProp	aCdDrawTextProp(
					fontpropDefault,
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
				CdBrushProp	aCdBrushProp(
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
				pCDcdTextbox->setCdBrushProp(aCdBrushProp);
				pCDcdTextbox->setText(_T("Ԕԍ"));

				Ou<CDcdLine>
					(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
					->setCdPenProp(getCdPenPropDotLine());
			}
			{
				// ʖ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, idx));

				Ou<CDcdTextbox>	pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

				CConverter_WinGdi aCConverter_WinGdi;

				CdDrawTextProp	aCdDrawTextProp(
					fontpropDefault,
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
				CdBrushProp	aCdBrushProp(
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
				pCDcdTextbox->setCdBrushProp(aCdBrushProp);
				pCDcdTextbox->setText(_T(""));
				if (bDisplayRessyamei)
				{
					Ou<CDcdLine>
						(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
						->setCdPenProp(getCdPenPropDotLine());
				}
				else
				{
					Ou<CDcdLine>
						(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
						->setCdPenProp(getCdPenPropNarrowLine());
				}
			}
			if (bDisplayRessyamei)
			{
				// Ԗ
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_Ressyamei, idx));

				Ou<CDcdTextbox>	pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

				CConverter_WinGdi aCConverter_WinGdi;

				CdDrawTextProp	aCdDrawTextProp(
					fontpropDefault,
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
				CdBrushProp	aCdBrushProp(
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
				pCDcdTextbox->setCdBrushProp(aCdBrushProp);
				pCDcdTextbox->setText(_T("Ԗ"));

				Ou<CDcdLine>
					(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
					->setCdPenProp(getCdPenPropNarrowLine());
			}
			if (idx < m_iMaxRessyaCount - 1)
			{
				// 
				int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
					CdAllOperationTableXColSpec::ColumnType_RessyaArrow, idx));

				Ou<CDcdTextbox>	pCDcdTextbox =
					getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

				CConverter_WinGdi aCConverter_WinGdi;

				CdDrawTextProp	aCdDrawTextProp(
					fontpropDefault,
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
				CdBrushProp	aCdBrushProp(
					aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

				pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
				pCDcdTextbox->setCdBrushProp(aCdBrushProp);
				pCDcdTextbox->setText(_T(""));

				Ou<CDcdLine>
					(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
					->setCdPenProp(getCdPenPropNarrowLine());
			}
		}
	}
	else
	{
		{
			// ԕ
			int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, 0));
			int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyahoukou, 1));

			Ou<CDcdTextbox>	pCDcdTextbox1 =
				getCXDcdGrid()->getCell(iXColumnNumber1, YCOLUMNNNO_HEADER)->getIfDcDraw();
			Ou<CDcdTextbox>	pCDcdTextbox2 =
				getCXDcdGrid()->getCell(iXColumnNumber2, YCOLUMNNNO_HEADER)->getIfDcDraw();

			CConverter_WinGdi aCConverter_WinGdi;

			CdDrawTextProp	aCdDrawTextProp(
				fontpropDefault,
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
			CdBrushProp	aCdBrushProp(
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

			pCDcdTextbox1->setCdDrawTextProp(aCdDrawTextProp);
			pCDcdTextbox1->setCdBrushProp(aCdBrushProp);
			pCDcdTextbox1->setText(_T("o"));
			pCDcdTextbox2->setCdDrawTextProp(aCdDrawTextProp);
			pCDcdTextbox2->setCdBrushProp(aCdBrushProp);
			pCDcdTextbox2->setText(_T(""));
			Ou<CDcdLine>
				(getCXDcdGrid()->getXBorder(iXColumnNumber1)->getIfDcDraw())
				->setCdPenProp(getCdPenPropDotLine());
			Ou<CDcdLine>
				(getCXDcdGrid()->getXBorder(iXColumnNumber2)->getIfDcDraw())
				->setCdPenProp(getCdPenPropDotLine());
		}
		{
			// Ԕԍ
			int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyabangou, 0));
			int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyabangou, 1));
			CString	aString;
			aString = _T("Ԕԍ");

			Ou<CDcdTextbox>	pCDcdTextbox1 =
				getCXDcdGrid()->getCell(iXColumnNumber1, YCOLUMNNNO_HEADER)->getIfDcDraw();
			Ou<CDcdTextbox>	pCDcdTextbox2 =
				getCXDcdGrid()->getCell(iXColumnNumber2, YCOLUMNNNO_HEADER)->getIfDcDraw();

			CConverter_WinGdi aCConverter_WinGdi;

			CdDrawTextProp	aCdDrawTextProp(
				fontpropDefault,
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
			CdBrushProp	aCdBrushProp(
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

			pCDcdTextbox1->setCdDrawTextProp(aCdDrawTextProp);
			pCDcdTextbox1->setCdBrushProp(aCdBrushProp);
			pCDcdTextbox1->setText((LPCTSTR)aString);
			pCDcdTextbox2->setCdDrawTextProp(aCdDrawTextProp);
			pCDcdTextbox2->setCdBrushProp(aCdBrushProp);
			pCDcdTextbox2->setText((LPCTSTR)aString);
			Ou<CDcdLine>
				(getCXDcdGrid()->getXBorder(iXColumnNumber1)->getIfDcDraw())
				->setCdPenProp(getCdPenPropDotLine());
			Ou<CDcdLine>
				(getCXDcdGrid()->getXBorder(iXColumnNumber2)->getIfDcDraw())
				->setCdPenProp(getCdPenPropDotLine());
		}
		{
			// ʖ
			int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, 0));
			int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu, 1));
			CString	aString;
			aString = _T("");

			Ou<CDcdTextbox>	pCDcdTextbox1 =
				getCXDcdGrid()->getCell(iXColumnNumber1, YCOLUMNNNO_HEADER)->getIfDcDraw();
			Ou<CDcdTextbox>	pCDcdTextbox2 =
				getCXDcdGrid()->getCell(iXColumnNumber2, YCOLUMNNNO_HEADER)->getIfDcDraw();

			CConverter_WinGdi aCConverter_WinGdi;

			CdDrawTextProp	aCdDrawTextProp(
				fontpropDefault,
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
			CdBrushProp	aCdBrushProp(
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

			pCDcdTextbox1->setCdDrawTextProp(aCdDrawTextProp);
			pCDcdTextbox1->setCdBrushProp(aCdBrushProp);
			pCDcdTextbox1->setText((LPCTSTR)aString);
			pCDcdTextbox2->setCdDrawTextProp(aCdDrawTextProp);
			pCDcdTextbox2->setCdBrushProp(aCdBrushProp);
			pCDcdTextbox2->setText((LPCTSTR)aString);
			if (bDisplayRessyamei)
			{
				Ou<CDcdLine>
					(getCXDcdGrid()->getXBorder(iXColumnNumber1)->getIfDcDraw())
					->setCdPenProp(getCdPenPropDotLine());
				Ou<CDcdLine>
					(getCXDcdGrid()->getXBorder(iXColumnNumber2)->getIfDcDraw())
					->setCdPenProp(getCdPenPropDotLine());
			}
			else
			{
				Ou<CDcdLine>
					(getCXDcdGrid()->getXBorder(iXColumnNumber1)->getIfDcDraw())
					->setCdPenProp(getCdPenPropNarrowLine());
				Ou<CDcdLine>
					(getCXDcdGrid()->getXBorder(iXColumnNumber2)->getIfDcDraw())
					->setCdPenProp(getCdPenPropNarrowLine());
			}
		}
		if (bDisplayRessyamei)
		{
			// Ԗ
			int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyamei, 0));
			int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_Ressyamei, 1));
			CString	aString;
			aString = _T("Ԗ");

			Ou<CDcdTextbox>	pCDcdTextbox1 =
				getCXDcdGrid()->getCell(iXColumnNumber1, YCOLUMNNNO_HEADER)->getIfDcDraw();
			Ou<CDcdTextbox>	pCDcdTextbox2 =
				getCXDcdGrid()->getCell(iXColumnNumber2, YCOLUMNNNO_HEADER)->getIfDcDraw();

			CConverter_WinGdi aCConverter_WinGdi;

			CdDrawTextProp	aCdDrawTextProp(
				fontpropDefault,
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
			CdBrushProp	aCdBrushProp(
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

			pCDcdTextbox1->setCdDrawTextProp(aCdDrawTextProp);
			pCDcdTextbox1->setCdBrushProp(aCdBrushProp);
			pCDcdTextbox1->setText((LPCTSTR)aString);
			pCDcdTextbox2->setCdDrawTextProp(aCdDrawTextProp);
			pCDcdTextbox2->setCdBrushProp(aCdBrushProp);
			pCDcdTextbox2->setText((LPCTSTR)aString);
			Ou<CDcdLine>
				(getCXDcdGrid()->getXBorder(iXColumnNumber1)->getIfDcDraw())
				->setCdPenProp(getCdPenPropNarrowLine());
			Ou<CDcdLine>
				(getCXDcdGrid()->getXBorder(iXColumnNumber2)->getIfDcDraw())
				->setCdPenProp(getCdPenPropNarrowLine());
		}
		{
			// 
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdAllOperationTableXColSpec(
				CdAllOperationTableXColSpec::ColumnType_RessyaArrow, 0));

			Ou<CDcdTextbox>	pCDcdTextbox =
				getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

			CConverter_WinGdi aCConverter_WinGdi;

			CdDrawTextProp	aCdDrawTextProp(
				fontpropDefault,
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
			CdBrushProp	aCdBrushProp(
				aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

			pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
			pCDcdTextbox->setCdBrushProp(aCdBrushProp);
			pCDcdTextbox->setText(_T(""));
			Ou<CDcdLine>
				(getCXDcdGrid()->getXBorder(iXColumnNumber)->getIfDcDraw())
				->setCdPenProp(getCdPenPropNarrowLine());
		}
	}
}

	// --------------------------------
	//@name j[R}h̉֐
	// --------------------------------

int CWndDcdGridAllOperationTable::OnAllOperationtableMovetojikokuhyou_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -1;	//^pXV}~Ԃł
		}
	}
	CdAllOperationTableYColSpec aCdAllOperationTableYColSpec = getYColSpecOfFocus();
	if (iRv >= 0)
	{
		if (getCSelect()->getSelectedCellCount() == 0)
		{
			if (aCdAllOperationTableYColSpec.getColumnType() !=
				CdAllOperationTableYColSpec::ColumnType_Operation)
			{
				iRv = -3;	//tH[JXԈʒuȊOȂs
			}
		}
		else
		{
			iRv = -4; //I͕s
		}

	}
	if (!bQueryEnable && iRv >= 0)
	{
		int idxOperation = aCdAllOperationTableYColSpec.getOperationIndex();
		const list <OperationTableContent> OperationTableContents =
			getCentDedDia()->getcontOperationTableContent().at(m_strOperationNumber[idxOperation]);

		OperationTableContent aOperationTableContent = OperationTableContents.front();

		CdAllOperationTableXColSpec aCdAllOperationTableXColSpec = getXColSpecOfFocus();
		/**
			ړ̗
			EwEw
				Sԕ\OFFRessyaIndex1()ԕ`Ԗ̏ꍇ́AԂJ
			ESԕ\ONRessyaIndex1ȏԐԕ`̏ꍇ́ARessyaIndexԖڂ̗ԂJ
		*/
		if (aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_InEkimei ||
			aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_InChakujikoku ||
			(!getDisplayAllRessya() && aCdAllOperationTableXColSpec.getRessyaIndex() == 1 &&
			(aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyahoukou ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyabangou ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyamei)))
		{
			aOperationTableContent = OperationTableContents.back();
		}
		else if (getDisplayAllRessya() &&
			aCdAllOperationTableXColSpec.getRessyaIndex() >= 1 && 
			aCdAllOperationTableXColSpec.getRessyaIndex() < (int)OperationTableContents.size() &&
			(aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyahoukou ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyabangou ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyamei ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_RessyaArrow))
		{
			auto itr = OperationTableContents.begin();
			for (int idx = 0; idx < idxOperation; idx++)
			{
				itr++;
			}
			aOperationTableContent = *itr;
		}

		ERessyahoukou eRessyahoukou = aOperationTableContent.aRessyaProperty.getRessyahoukou();
		int iRessyaidx = aOperationTableContent.aRessyaProperty.getRessyaIndex();
		// --------------------------------
		//	\r[J
		// --------------------------------
		CJikokuhyouView* pCJikokuhyouView = NULL;
		if (iRv >= 0)
		{
			CJikokuhyouDoc* pCJikokuhyouDoc = NULL;
			if (iRv >= 0)
			{
				pCJikokuhyouDoc =
					getCDiagramEditApp()->openCJikokuhyouDoc(
						getCentDedDia(),
						eRessyahoukou,
						false,
						&pCJikokuhyouView);
				if (pCJikokuhyouView == NULL)
				{
					iRv = -5;	//	\r[̃I[vɎs܂
				}
			}
			//pCJikokuhyouDoc = \hLg
			//pCJikokuhyouView = \r[
		}

		if (iRv >= 0)
		{
			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
			pCJikokuhyouView->setFocusToRessyaIndex(iRessyaidx, aCentDedRessya.getSihatsuEki());
			iRv = 1;	//	\r[ֈړ܂
		}

	}
	return iRv;
}

int CWndDcdGridAllOperationTable::OnAllOperationtableMovetoOperationTable_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -1;	//^pXV}~Ԃł
		}
	}
	CdAllOperationTableYColSpec aCdAllOperationTableYColSpec = getYColSpecOfFocus();
	if (iRv >= 0)
	{
		if (getCSelect()->getSelectedCellCount() == 0)
		{
			if (aCdAllOperationTableYColSpec.getColumnType() !=
				CdAllOperationTableYColSpec::ColumnType_Operation)
			{
				iRv = -3;	//tH[JXԈʒuȊOȂs
			}
		}
		else
		{
			iRv = -4; //I͕s
		}

	}
	if (!bQueryEnable && iRv >= 0)
	{
		int idxOperation = aCdAllOperationTableYColSpec.getOperationIndex();
		
		if (!m_strOperationNumber[idxOperation].empty())
		{
			COperationTableView* pCOperationTableView = NULL;
			if (iRv >= 0)
			{
				COperationTableDoc* pCOperationTableDoc = NULL;
				if (iRv >= 0)
				{
					pCOperationTableDoc =
						getCDiagramEditApp()->openCOperationTableDoc(
							getCentDedDia(),
							m_strOperationNumber[idxOperation]);
					//if (pCOperationTableView == NULL)
					//{
					//	iRv = -4;	//	^p\r[̃I[vɎs܂
					//}
				}
				//pCOperationTableDoc = ^p\hLg
				//pCOperationTableView = ^p\r[
			}
		}
	}
	return iRv;
}

int CWndDcdGridAllOperationTable::OnAllOperationtableMovetodiagram_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -5;	//^pXV}~Ԃł
		}
	}
	CdAllOperationTableYColSpec aCdAllOperationTableYColSpec = getYColSpecOfFocus();
	if (iRv >= 0)
	{
		if (getCSelect()->getSelectedCellCount() == 0)
		{
			if (aCdAllOperationTableYColSpec.getColumnType() !=
				CdAllOperationTableYColSpec::ColumnType_Operation)
			{
				iRv = -2;	//tH[JXԈʒuȊOȂs
			}
		}
		else
		{
			iRv = -1; //I͕s
		}

	}
	if (!bQueryEnable && iRv >= 0)
	{
		int idxOperation = aCdAllOperationTableYColSpec.getOperationIndex();
		const list <OperationTableContent> OperationTableContents =
			getCentDedDia()->getcontOperationTableContent().at(m_strOperationNumber[idxOperation]);

		OperationTableContent aOperationTableContent = OperationTableContents.front();

		CdAllOperationTableXColSpec aCdAllOperationTableXColSpec = getXColSpecOfFocus();
		/**
			ړ̗
			EwEw
				Sԕ\OFFRessyaIndex1()ԕ`Ԗ̏ꍇ́AԂJ
			ESԕ\ONRessyaIndex1ȏԐԕ`̏ꍇ́ARessyaIndexԖڂ̗ԂJ
			EȊȌꍇ͏oԂJ
		*/
		if (aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_InEkimei ||
			aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_InChakujikoku ||
			(!getDisplayAllRessya() && aCdAllOperationTableXColSpec.getRessyaIndex() == 1 &&
			(aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyahoukou ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyabangou ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyamei)))
		{
			aOperationTableContent = OperationTableContents.back();
		}
		else if (getDisplayAllRessya() &&
			aCdAllOperationTableXColSpec.getRessyaIndex() >= 1 &&
			aCdAllOperationTableXColSpec.getRessyaIndex() < (int)OperationTableContents.size() &&
			(aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyahoukou ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyabangou ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyasyubetsu ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_Ressyamei ||
				aCdAllOperationTableXColSpec.getColumnType() == CdAllOperationTableXColSpec::ColumnType_RessyaArrow))
		{
			auto itr = OperationTableContents.begin();
			for (int idx = 0; idx < idxOperation; idx++)
			{
				itr++;
			}
			aOperationTableContent = *itr;
		}

		ERessyahoukou eRessyahoukou = aOperationTableContent.aRessyaProperty.getRessyahoukou();
		int iRessyaidx = aOperationTableContent.aRessyaProperty.getRessyaIndex();
		// --------------------------------
		//	_COr[J
		// --------------------------------
		CDedDiagramView* pCDedDiagramView = NULL;
		if (iRv >= 0) {

			const CDedDiagramDoc* pCDedDiagramDoc = NULL;
			if (iRv >= 0) {
				pCDedDiagramDoc =
					getCDiagramEditApp()->openCDedDiagramDoc(
						getCentDedDia());
				if (pCDedDiagramDoc == NULL) {
					iRv = -3;	//	_COr[̃I[vɎs܂
				}
			}
			//pCDedDiagramDoc = _COhLg
			//	r[ANeBuɂȂĂ܂B

			if (iRv >= 0) {
				POSITION aPOSITION = pCDedDiagramDoc->GetFirstViewPosition();
				if (aPOSITION != NULL) {
					pCDedDiagramView = (CDedDiagramView*)pCDedDiagramDoc->GetNextView(aPOSITION);
				}
				if (pCDedDiagramView == NULL) {
					iRv = -4;	//	_COr[̃I[vɎs܂
				}
			}
		}
		//pCDedDiagramView = _COr[
		if (iRv >= 0) {
			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
			pCDedDiagramView->setZone_Dgr(aCentDedRessya.getCentDedEkiJikoku(aCentDedRessya.getSihatsuEki()).getHatsujikoku(true),
				aCentDedRessya.EkiIndexOfEkiOrder(aCentDedRessya.getValidSihatsuEki()),
				aCentDedRessya.getRessyahoukou() == Ressyahoukou_Nobori);
		}
	}
	return iRv;
}

int CWndDcdGridAllOperationTable::OnFileExportOperationTableCsv_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -1;	//^pXV}~Ԃł
		}
	}

	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		CdAllOperationTableXColSpec aCdAllOperationTableXColSpec = getXColSpecOfFocus();
		CdAllOperationTableYColSpec aCdAllOperationTableYColSpec = getYColSpecOfFocus();
		tstring strDefaultOperationNumber;
		int iDefalutEkiIndex = 0;
		if (aCdAllOperationTableYColSpec.getColumnType() == CdAllOperationTableYColSpec::ColumnType_Operation &&
			aCdAllOperationTableYColSpec.getOperationIndex() < (int)m_strOperationNumber.size())
		{
			strDefaultOperationNumber = m_strOperationNumber[aCdAllOperationTableYColSpec.getOperationIndex()];
			const list <OperationTableContent> OperationTableContents =
				getCentDedDia()->getcontOperationTableContent().at(strDefaultOperationNumber);

			if (m_eOperationSort == EOperationSort_InEki ||
				m_eOperationSort == EOperationSort_InJikoku)
			{
				OperationTableContent aOperationTableContent = OperationTableContents.back();

				iDefalutEkiIndex = getCentDedRessyaCont(aOperationTableContent.aRessyaProperty.getRessyahoukou())
					->EkiIndexOfEkiOrder(aOperationTableContent.iSyuuchakuEkiOrder);
			}
			else
			{
				OperationTableContent aOperationTableContent = OperationTableContents.front();

				iDefalutEkiIndex = getCentDedRessyaCont(aOperationTableContent.aRessyaProperty.getRessyahoukou())
					->EkiIndexOfEkiOrder(aOperationTableContent.iSihatsuEkiOrder);
			}
		}
		const CDedRosenFileData* pCDedRosenFileData =
			getCDiagramEditDoc()->getCDedRosenFileData();
		
		CDlgOperationTableCsvExport	aDlg(
			pCDedRosenFileData->getCentDedRosen(),
			getCentDedDia(),
			strDefaultOperationNumber,
			iDefalutEkiIndex,
			getDisplaySecondEkiJikoku(),
			getDisplayColonEkiJikoku(),
			getDisplayParentSyubetsu(),
			getDisplayNoboriLeftToRight(),
			getCompareBottom(),
			m_eOperationSort,
			this);
		aDlg.DoModal();

		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

int CWndDcdGridAllOperationTable::OnFileExportAllOperationTableCsv_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -1;	//^pXV}~Ԃł
		}
	}

	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************

		CString	strError;
		if (iRv >= 0)
		{
			CFileDialog aDlg(
				FALSE,
				_T("csv"),
				m_strCsvFilename,
				OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
				getCDiagramEditApp()->getCFileDialogFilterCsv(),
				this);
			if (aDlg.DoModal() != IDOK)
			{
				iRv = -2;	//	Cancel܂B
			}
			else
			{
				m_strCsvFilename = aDlg.GetPathName();
			}
		}
		//m_strCsvFilename = w肳ꂽCSVt@C



		// --------------------------------
		//	CSVt@C̏o
		// --------------------------------
		CWaitCursor aCursor;
		if (iRv >= 0)
		{
			const CDedRosenFileData* pCDedRosenFileData =
				getCDiagramEditDoc()->getCDedRosenFileData();

			CconvAllOperationTableCsv	aConv;
			CdCsvDocument	aCdCsvDocument;
			int iResult = aConv.encode(
				*pCDedRosenFileData->getCentDedRosen(),
				*getCentDedDia(),
				m_strOperationNumber,
				getDisplaySecondEkiJikoku(),
				getDisplayColonEkiJikoku(),
				getDisplayParentSyubetsu(),
				getDisplayAllRessya(),
				m_iMaxRessyaCount,
				&aCdCsvDocument);
			if (iResult < 0)
			{
				GetDlgItemText(IDC_TEXT_ENCODE_ERROR, strError);
				//strError="CSVւ̕ϊɎs܂B"

				strError.Format(_T("%s(%d)"), CString(strError), iResult);
				iRv = iResult - 10;
			}
			else
			{
				tstring strCsvDocument;
				CConvCsvDocument	aCConvCsvDocument;
				strCsvDocument = aCConvCsvDocument.encode(&aCdCsvDocument);
				int iResult = stringToFile(strCsvDocument, (LPCTSTR)m_strCsvFilename);
				if (iResult < 0)
				{
					GetDlgItemText(IDC_TEXT_FILE_SAVE_FAILED, strError);
					//strError="t@Cւ̕ۑɎs܂B"

					iRv = -21; // t@Cւ̕ۑɎs܂B

				}
			}
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

// ****************************************************************
//	CWndDcdGridEkiTrack2
// ****************************************************************


// ********************************
//	RXgN^
// ********************************
CWndDcdGridAllOperationTable::CWndDcdGridAllOperationTable()
	: m_bUpdate_All_Requested( false )
	, m_bInitialUpdateComplete(false)
	, m_bDisplayAllRessya(false)
	, m_iMaxRessyaCount(0)
	, m_eOperationSort(EOperationSort::EOperationSort_OperationNumber)
	, m_bCompareBottom(false)
	, m_bDisplaySecondEkiJikoku(false)
	, m_bDisplayColonEkiJikoku(false)
	, m_bDisplayParentSyubetsu(false)
	, m_bDisplayNoboriLeftToRight(false)
	, m_strCsvFilename(_T(""))
	, m_iSecondRoundChaku(0)
	, m_iSecondRoundHatsu(0)
	, m_bDisplay2400(false)
{
	//getCSelect()->setSelectMode( CSelect::SelectMode_YColumn ) ;
	getCSelect()->setSelectMode(CSelect::SelectMode_NONE);
}
CWndDcdGridAllOperationTable::~CWndDcdGridAllOperationTable()
{
}

// ********************************
//@name	CDcdGrid
// ********************************

// ********************************
//@name	CWndDcdGrid
// ********************************

	// ********************************
	//@name CWndDcdGridRessyasyubetsu-
	// ********************************

CAllOperationTableDoc * CWndDcdGridAllOperationTable::GetDocument()
{
	CView* pCView = (CView*)GetParent();
	return (CAllOperationTableDoc*)pCView->GetDocument();
}

const CentDedDia*	CWndDcdGridAllOperationTable::getCentDedDia()
{
	const CentDedRosen*	pCentDedRosen =
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
	int iDiaIndex = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName(
		GetDocument()->getDiaName());
	if (iDiaIndex < 0) {
		return (NULL);
	}
	const CentDedDia* pCentDedDia = pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get(iDiaIndex);
	return (pCentDedDia);
};

const CentDedRessyaCont*	CWndDcdGridAllOperationTable::getCentDedRessyaCont(
	ERessyahoukou eRessyahoukou)
{
	const CentDedDia* pCentDedDia = getCentDedDia();
	if (pCentDedDia == NULL) {
		return (NULL);
	}
	return (pCentDedDia->getCentDedRessyaCont(eRessyahoukou));
};


int CWndDcdGridAllOperationTable::OnAllOperationTableProp_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (iRv >= 0)
	{
	}
	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		CDlgAllOperationTableProp aDlg(
			m_eOperationSort,
			m_bCompareBottom,
			this);
		if (aDlg.DoModal() == IDOK)
		{
			setOperationSort(aDlg.getOperationSort());
			setCompareBottom(aDlg.getCompareBottom());

			//	EkijikokuSort ̐ݒA
			//	.ini t@Cɕۑ
			getCDiagramEditApp()->writeCWndDcdGridAllOperationTableViewProp(this);

			iRv = 1;	//	_CAO{bNXł̓͂Kp܂B
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

int CWndDcdGridAllOperationTable::OnViewDisplayAllRessya_Process(
	BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (getDisplayAllRessya())
	{
		iRv = 1;	//(bQueryEnable==TRUȄꍇ)[bPʂ̎\]LłB
	}
	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		setDisplayAllRessya(!getDisplayAllRessya());
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

int CWndDcdGridAllOperationTable::OnViewDisplaySecondEkijikoku_Process(
	BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (getDisplaySecondEkiJikoku())
	{
		iRv = 1;	//(bQueryEnable==TRUȄꍇ)[bPʂ̎\]LłB
	}
	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		setDisplaySecondEkiJikoku(!getDisplaySecondEkiJikoku());
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

int CWndDcdGridAllOperationTable::OnViewDisplayColonEkijikoku_Process(
	BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (getDisplayColonEkiJikoku())
	{
		iRv = 1;	//(bQueryEnable==TRUȄꍇ)[bPʂ̎\]LłB
	}
	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		setDisplayColonEkiJikoku(!getDisplayColonEkiJikoku());
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

int CWndDcdGridAllOperationTable::OnViewDisplayParentSyubetsu_Process(
	BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (getDisplayParentSyubetsu())
	{
		iRv = 1;	//(bQueryEnable==TRUȄꍇ)[bPʂ̎\]LłB
	}
	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		setDisplayParentSyubetsu(!getDisplayParentSyubetsu());
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

CWndDcdGridAllOperationTable::EOperationSort CWndDcdGridAllOperationTable::getOperationSort()const
{
	return m_eOperationSort;
}
int CWndDcdGridAllOperationTable::setOperationSort(EOperationSort value)
{
	int iRv = 0;
	if (m_eOperationSort != value)
	{
		m_eOperationSort = value;

		//	bPʂ̕\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂

		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridAllOperationTableViewProp(this);
	}
	return (iRv);
}

bool CWndDcdGridAllOperationTable::getCompareBottom()const
{
	return m_bCompareBottom;
}
int CWndDcdGridAllOperationTable::setCompareBottom(bool value)
{
	int iRv = 0;
	if (m_bCompareBottom != value)
	{
		m_bCompareBottom = value;

		//	bPʂ̕\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂

		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridAllOperationTableViewProp(this);
	}
	return (iRv);
}

bool CWndDcdGridAllOperationTable::getDisplayAllRessya()const
{
	return m_bDisplayAllRessya;
}
int CWndDcdGridAllOperationTable::setDisplayAllRessya(bool value)
{
	int iRv = 0;
	if (m_bDisplayAllRessya != value)
	{
		m_bDisplayAllRessya = value;

		//	bPʂ̕\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂

		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridAllOperationTableViewProp(this);
	}
	return (iRv);
}

bool CWndDcdGridAllOperationTable::getDisplaySecondEkiJikoku()const
{
	return m_bDisplaySecondEkiJikoku;
}
int CWndDcdGridAllOperationTable::setDisplaySecondEkiJikoku(bool value)
{
	int iRv = 0;
	if (m_bDisplaySecondEkiJikoku != value)
	{
		m_bDisplaySecondEkiJikoku = value;

		//	bPʂ̕\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂

		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridAllOperationTableViewProp(this);
	}
	return (iRv);
}

bool CWndDcdGridAllOperationTable::getDisplayColonEkiJikoku()const
{
	return m_bDisplayColonEkiJikoku;
}
int CWndDcdGridAllOperationTable::setDisplayColonEkiJikoku(bool value)
{
	int iRv = 0;
	if (m_bDisplayColonEkiJikoku != value)
	{
		m_bDisplayColonEkiJikoku = value;

		//	bPʂ̕\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂

		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridAllOperationTableViewProp(this);
	}
	return (iRv);
}

bool CWndDcdGridAllOperationTable::getDisplayParentSyubetsu()const
{
	return m_bDisplayParentSyubetsu;
}
int CWndDcdGridAllOperationTable::setDisplayParentSyubetsu(bool value)
{
	int iRv = 0;
	if (m_bDisplayParentSyubetsu != value)
	{
		m_bDisplayParentSyubetsu = value;

		//	eʋ@\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂
		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridAllOperationTableViewProp(this);
	}
	return (iRv);
}


bool CWndDcdGridAllOperationTable::getDisplayNoboriLeftToRight()const
{
	return m_bDisplayNoboriLeftToRight;
}
int CWndDcdGridAllOperationTable::setDisplayNoboriLeftToRight(bool value)
{
	int iRv = 0;

	m_bDisplayNoboriLeftToRight = value;

	return (iRv);
}


// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CWndDcdGridAllOperationTable,CWndDcdGridAllOperationTable::super)
	//{{AFX_MSG_MAP(CWndDcdGridAllOperationTable)
	ON_WM_CREATE()
	ON_WM_KEYUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_KEYDOWN()
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_AllOperationTableProp, &CWndDcdGridAllOperationTable::OnAllOperationtableProp)
	ON_UPDATE_COMMAND_UI(ID_AllOperationTableProp, &CWndDcdGridAllOperationTable::OnUpdateAllOperationtableProp)
	ON_COMMAND(ID_AllOperationTable_MoveToOperationTable, &CWndDcdGridAllOperationTable::OnAllOperationtableMovetoOperationTable)
	ON_UPDATE_COMMAND_UI(ID_AllOperationTable_MoveToOperationTable, &CWndDcdGridAllOperationTable::OnUpdateAllOperationtableMovetoOperationTable)
	ON_COMMAND(ID_OperationTable_MoveToJikokuhyou, &CWndDcdGridAllOperationTable::OnAllOperationtableMovetojikokuhyou)
	ON_UPDATE_COMMAND_UI(ID_OperationTable_MoveToJikokuhyou, &CWndDcdGridAllOperationTable::OnUpdateAllOperationtableMovetojikokuhyou)
	ON_COMMAND(ID_OperationTable_MoveToDiagram, &CWndDcdGridAllOperationTable::OnAllOperationtableMovetodiagram)
	ON_UPDATE_COMMAND_UI(ID_OperationTable_MoveToDiagram, &CWndDcdGridAllOperationTable::OnUpdateAllOperationtableMovetodiagram)
	ON_COMMAND(ID_VIEW_DisplayAllRessya, &CWndDcdGridAllOperationTable::OnViewDisplayAllRessya)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplayAllRessya, &CWndDcdGridAllOperationTable::OnUpdateViewDisplayAllRessya)
	ON_COMMAND(ID_VIEW_DisplaySecondEkiJikoku, &CWndDcdGridAllOperationTable::OnViewDisplaySecondEkijikoku)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplaySecondEkiJikoku, &CWndDcdGridAllOperationTable::OnUpdateViewDisplaySecondEkijikoku)
	ON_COMMAND(ID_VIEW_DisplayColonEkiJikoku, &CWndDcdGridAllOperationTable::OnViewDisplayColonEkijikoku)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplayColonEkiJikoku, &CWndDcdGridAllOperationTable::OnUpdateViewDisplayColonEkijikoku)
	ON_COMMAND(ID_VIEW_DisplayParentSyubetsu, &CWndDcdGridAllOperationTable::OnViewDisplayParentSyubetsu)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplayParentSyubetsu, &CWndDcdGridAllOperationTable::OnUpdateViewDisplayParentSyubetsu)
	ON_COMMAND(ID_FILE_EXPORT_OPERATIONTABLECSV, &CWndDcdGridAllOperationTable::OnFileExportOperationtablecsv)
	ON_COMMAND(ID_FILE_EXPORT_ALLOPERATIONTABLECSV, &CWndDcdGridAllOperationTable::OnFileExportAllOperationtablecsv)
END_MESSAGE_MAP()

int CWndDcdGridAllOperationTable::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (super::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	//// --------------------------------
	////	Ԏʃr[ɎgptHg
	//// --------------------------------
	//CdFontProp fontpropDefault = createFontProp() ;
	//CdOperationTableXColSSpecCont = createXColSpecCont();
	//// --------------------------------
	////	̐w
	//// --------------------------------

	//getCXDcdGrid()->setXColumnCount(aXColSpecCont.size()) ;
	getCXDcdGrid()->setYColumnCount(YCOLUMNNNO_OPERATION_0);
	getCXDcdGrid()->setYFixColumnCount(YCOLUMNNNO_OPERATION_0);
	OnCreate_Header();


	// --------------------------------
	//	tH[JXZ̏ʒuݒ
	// --------------------------------
	getCFocus()->setFocusCell( getCXDcdGrid()->getCell( 0 , YCOLUMNNNO_OPERATION_0) ) ;
	// --------------------------------
	//	\XV
	// --------------------------------
	InvalidateGrid() ;

	
	return 0;
}




void CWndDcdGridAllOperationTable::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	if (lHint == LHINT_SUBVIEW_TO_ROOTDOC)
	{
		return;
	}
	// --------------------------------

	// --------------------------------
	//	OnUpdate()
	//	.init@CvpeBǂݍ
	// --------------------------------
	if (!m_bInitialUpdateComplete)
	{
		getCDiagramEditApp()->readCWndDcdGridAllOperationTableViewProp(this);
		CdDedDispProp aCdDedDispProp =
			getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp();
		m_iSecondRoundChaku = aCdDedDispProp.getSecondRoundChaku();
		m_iSecondRoundHatsu = aCdDedDispProp.getSecondRoundHatsu();
		m_bDisplay2400 = aCdDedDispProp.getDisplay2400();
		// --------------------------------
		m_bInitialUpdateComplete = true;
	}

	//pHint= 
	//	pHint CRfEditCmdHolder IuWFNgȂA
	//	ΉҏWR}h CRfEditCmd ێĂ܂B
	//	̏ꍇAthis  CRfEditCmd ̓eɍœK
	//	XVs܂B
	//	NULLȂASXVvĂ܂B
	if (m_bUpdate_All_Requested)
	{
		//	SXVۗĂꍇ́A
		//	̌̓R}hɂœKꂽP̂̂ȂXVvɑ΂ĂASXVs܂B
		pHint = NULL;
	}


	Ou<CRfEditCmd> pCmd;
	if (pHint != NULL && pHint->IsKindOf(RUNTIME_CLASS(CRfEditCmdHolder)))
	{

		CRfEditCmdHolder* pHolder =
			(CRfEditCmdHolder*)pHint;
		pCmd = pHolder->getCmd();
	}

	//
	//	
	//	
	if ( pCmd != NULL )
	{
		if ( dynamic_castOu<CRfEditCmd_Comment>( pCmd ) || 
			dynamic_castOu<CRfEditCmd_Dia>(pCmd) ||
			dynamic_castOu<CRfEditCmd_DiaProp>(pCmd) ||
			dynamic_castOu<CRfEditCmd_RessyasyubetsuSwap>( pCmd ))
		{
			//	̃r[́A
			//		Rg̕ύX
			//		_C̕ύX
			//		_C̑̕ύX
			//		wԐ̕ύX
			//		wԐ̓
			//		Ԏʂ̓
			//	̏ꍇ́AXVs܂B
		}
		else if (dynamic_castOu<CRfEditCmd_Ressya>(pCmd))
		{
			const CentDedRosen*	pCentDedRosen =
				getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
			int iDiaIndex = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName(
				GetDocument()->getDiaName());
			Ou<CRfEditCmd_Ressya>	pCommand =
				dynamic_castOu<CRfEditCmd_Ressya>(pCmd);
			if (pCommand->getDiaIndex() == iDiaIndex && !pCommand->getWaitOperationConnect())
			{
				pHint = NULL;
			}
		}
		else if (dynamic_castOu<CRfEditCmd_Operation>(pCmd))
		{
			const CentDedRosen*	pCentDedRosen =
				getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
			int iDiaIndex = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName(
				GetDocument()->getDiaName());
			Ou<CRfEditCmd_Operation>	pCommand =
				dynamic_castOu<CRfEditCmd_Operation>(pCmd);
			if (pCommand->getDiaIndex() == iDiaIndex)
			{
				pHint = NULL;
			}
		}
		else
		{
			//CRfEditCmd_DedRosenFileDataProp
			//	  Ht@C̃vpeB̕ύX́A
			//	tHg̕ω𔺂߁ASXVKvłB
			//CRfEditCmd_Eki
			//CRfEditCmd_RessyaSyubetsu
			//CRfEditCmd_Rosen
			//CRfEditCmd_RosenFileData
			//	Ԏʂ܂IuWFNgłBꂪXVꂽꍇ́A
			//	SXVKvłB
			pHint = NULL ;
		}
	}
	if ( pHint == NULL )
	{
		// --------------------------------		
		//	SvfXV
		// --------------------------------
		CView *pView = getCDiagramEditApp()->getCMainFrame()->
			getMDIChildActiveView() ;

		CdDedDispProp aCdDedDispProp =
			getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp();
		m_iSecondRoundChaku = aCdDedDispProp.getSecondRoundChaku();
		m_iSecondRoundHatsu = aCdDedDispProp.getSecondRoundHatsu();
		m_bDisplay2400 = aCdDedDispProp.getDisplay2400();

		CAllOperationTableDoc* pCAllOperationTableDoc = (CAllOperationTableDoc*)GetDocument();

		if ( GetParent() == pView )
		{
			OnUpdate_All() ;
		}
		else
		{
			LogMsg(_T("CWndDcdGridAllOperationTable::OnUpdate()")
				_T("m_bUpdate_All_Requested=true") ) ;
			m_bUpdate_All_Requested = true ;
		}
	}
	
	int iYColumnBegin = createYColSpecCont().ColumnNumberFromSpec( 
		CdAllOperationTableYColSpec(CdAllOperationTableYColSpec::ColumnType_Operation, 0 ) ) ;

	getCSelect()->setColumnNumberSelectLimit(
		CdDcdZoneXy( 
			CdDcdZone( 0 , INT_MAX ) ,
			CdDcdZone( iYColumnBegin , getCentDedDia()->getcontOperationTableContent().size())
		) );

}

void CWndDcdGridAllOperationTable::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView)
{
	LogMsg(_T("CWndDcdGridAllOperationTable::OnActivateView(%d,,)") , bActivate ) ;
	
	if ( bActivate && m_bUpdate_All_Requested )
	{
		OnUpdate_All() ;
	}
}

void CWndDcdGridAllOperationTable::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CMenu	aMenu ;
	aMenu.LoadMenu( IDR_MENU_ALLOPERATIONTABLE_CONTEXT ) ;
	CMenu* pContextMenu = aMenu.GetSubMenu( 0 ) ;

	//	ReLXgj[}EXȊOŌĂяoꂽꍇ́A
	//	ReLXgj[̕\ʒúAtH[JXZ̒̈ʒuƂ܂B
	if ( point.x ==-1 || point.y == -1 )
	{
		//	ReLXgj[}EXȊOŌĂяo܂
		CdDcdPosXy posxyFocusCellColumnNumber = getCFocus()->getFocusCellColumnNumber() ;
		if ( posxyFocusCellColumnNumber !=  
				CFocus::ColumnNumberPosXy_NULL() )
		{
			CdDcdZoneXy	zonexyFocusCell = getCellZone( 
				posxyFocusCellColumnNumber.getX() , 
				posxyFocusCellColumnNumber.getY() ) ;
			point.x = zonexyFocusCell.getX().getPos() + zonexyFocusCell.getX().getSize() / 2 ;
			point.y = zonexyFocusCell.getY().getPos() + zonexyFocusCell.getY().getSize() / 2 ;
			ClientToScreen( &point ) ;
		}
	}
	//point = ReLXgj[̕\ʒuB
	//	-1̏ꍇ́AReLXgj[͕\ł܂B

	if ( point.x >= 0 &&  point.y >= 0 )
	{
		pContextMenu->TrackPopupMenu( 
			TPM_LEFTALIGN | TPM_RIGHTBUTTON ,
			point.x , point.y , 
			AfxGetMainWnd() ) ;	//	this w肷ƁAAppDocView 
								//R}h`F[삵܂B
	}
	else
	{
		super::OnContextMenu(pWnd, point);
	}
}

void CWndDcdGridAllOperationTable::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	OnAllOperationtableMovetoOperationTable_Process(FALSE);
}

void CWndDcdGridAllOperationTable::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	int iRv = 0;

	//if (iRv >= 0 && CKeyinputSenderToModalDlg::AnyLetterOrDigitKeyIsDown())
	//{

	//	if (iRv >= 0)
	//	{
	//		if (getCentDedDia()->getWaitOperationUpdate())
	//		{
	//			iRv = -1;	//^pXV}~Ԃł
	//		}
	//	}
	//	CdAllOperationTableYColSpec aCdAllOperationTableYColSpec = getYColSpecOfFocus();
	//	if (iRv >= 0)
	//	{
	//		if (getCSelect()->getSelectedCellCount() == 0)
	//		{
	//			if (aCdAllOperationTableYColSpec.getColumnType() !=
	//				CdAllOperationTableYColSpec::ColumnType_Operation)
	//			{
	//				iRv = -2;	//tH[JXԈʒuȊOȂs
	//			}
	//		}
	//		else
	//		{
	//			iRv = -1; //I͕s
	//		}
	//	}

	//	//if (iRv >= 0)
	//	//{
	//	//	auto itr = m_ListOperationTableContent->begin();
	//	//	for (int idx = 0; idx < aCdOperationTableYColSpec.getOperationTableContentIndex(); idx++)
	//	//	{
	//	//		itr++;
	//	//	}
	//	//	ERessyahoukou eRessyahoukou = itr->aRessyaProperty.getRessyahoukou();
	//	//	int iRessyaidx = itr->aRessyaProperty.getRessyaIndex();
	//	//	// --------------------------------
	//	//	//	\r[J
	//	//	// --------------------------------
	//	//	CJikokuhyouView* pCJikokuhyouView = NULL;
	//	//	if (iRv >= 0)
	//	//	{
	//	//		CJikokuhyouDoc* pCJikokuhyouDoc = NULL;
	//	//		if (iRv >= 0)
	//	//		{
	//	//			pCJikokuhyouDoc =
	//	//				getCDiagramEditApp()->openCJikokuhyouDoc(
	//	//					getCentDedDia(),
	//	//					eRessyahoukou,
	//	//					false,
	//	//					&pCJikokuhyouView);
	//	//			if (pCJikokuhyouView == NULL)
	//	//			{
	//	//				iRv = -3;	//	\r[̃I[vɎs܂
	//	//			}
	//	//		}
	//	//		//pCJikokuhyouDoc = \hLg
	//	//		//pCJikokuhyouView = \r[
	//	//	}

	//	//	if (iRv >= 0)
	//	//	{

	//	//		CdOperationTableXColSpec aCdOperationTableXColSpec = getXColSpecOfFocus();
	//	//		if (aCdOperationTableXColSpec.getColumnType() ==
	//	//			CdOperationTableXColSpec::ColumnType_Ressyabangou)
	//	//		{
	//	//			pCJikokuhyouView->openCDlgRessyaPropKeyDown(iRessyaidx, 1, nChar, nRepCnt, nFlags);
	//	//		}
	//	//		else if (aCdOperationTableXColSpec.getColumnType() ==
	//	//			CdOperationTableXColSpec::ColumnType_Ressyasyubetsu)
	//	//		{
	//	//			pCJikokuhyouView->openCDlgRessyaPropKeyDown(iRessyaidx, 2, nChar, nRepCnt, nFlags);
	//	//		}
	//	//		else if (aCdOperationTableXColSpec.getColumnType() ==
	//	//			CdOperationTableXColSpec::ColumnType_Ressyamei)
	//	//		{
	//	//			pCJikokuhyouView->openCDlgRessyaPropKeyDown(iRessyaidx, 3, nChar, nRepCnt, nFlags);
	//	//		}
	//	//		else if (aCdOperationTableXColSpec.getColumnType() ==
	//	//			CdOperationTableXColSpec::ColumnType_OriginSideEkimei ||
	//	//			aCdOperationTableXColSpec.getColumnType() ==
	//	//			CdOperationTableXColSpec::ColumnType_OriginSideEkijikoku)
	//	//		{
	//	//			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
	//	//			if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari ||
	//	//				getDisplayNoboriLeftToRight())
	//	//			{
	//	//				pCJikokuhyouView->openCDlgEkijikokuPropKeyDown(iRessyaidx, aCentDedRessya.getValidSihatsuEki(), true, nChar, nRepCnt, nFlags);
	//	//			}
	//	//			else
	//	//			{
	//	//				pCJikokuhyouView->openCDlgEkijikokuPropKeyDown(iRessyaidx, aCentDedRessya.getValidSyuuchakuEki(), false, nChar, nRepCnt, nFlags);
	//	//			}
	//	//		}
	//	//		else if (aCdOperationTableXColSpec.getColumnType() ==
	//	//			CdOperationTableXColSpec::ColumnType_TerminalSideEkimei ||
	//	//			aCdOperationTableXColSpec.getColumnType() ==
	//	//			CdOperationTableXColSpec::ColumnType_TerminalSideEkijikoku)
	//	//		{
	//	//			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
	//	//			if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari ||
	//	//				getDisplayNoboriLeftToRight())
	//	//			{
	//	//				pCJikokuhyouView->openCDlgEkijikokuPropKeyDown(iRessyaidx, aCentDedRessya.getValidSyuuchakuEki(), false, nChar, nRepCnt, nFlags);
	//	//			}
	//	//			else
	//	//			{
	//	//				pCJikokuhyouView->openCDlgEkijikokuPropKeyDown(iRessyaidx, aCentDedRessya.getValidSihatsuEki(), true, nChar, nRepCnt, nFlags);
	//	//			}
	//	//		}
	//	//		else
	//	//		{
	//	//			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
	//	//			pCJikokuhyouView->setFocusToRessyaIndex(iRessyaidx, aCentDedRessya.getValidSihatsuEki());
	//	//		}
	//	//		iRv = 1;	//	\r[ֈړ܂
	//	//	}
	//	//}

	//}
	//else
	//{
		//if (!m_CKeyinputSenderToModalDlg.OnKeyDown(nChar, nRepCnt, nFlags))
		//{
		super::OnKeyDown(nChar, nRepCnt, nFlags);
		//}
	//}
}


void CWndDcdGridAllOperationTable::OnAllOperationtableProp()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	OnAllOperationTableProp_Process(FALSE);
}


void CWndDcdGridAllOperationTable::OnUpdateAllOperationtableProp(CCmdUI* pCmdUI)
{
	// TODO:ɃR}hXV UI nh[ R[hǉ܂B
	pCmdUI->Enable(OnAllOperationTableProp_Process(TRUE) >= 0);
}


void CWndDcdGridAllOperationTable::OnAllOperationtableMovetoOperationTable()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	OnAllOperationtableMovetoOperationTable_Process(FALSE);
}


void CWndDcdGridAllOperationTable::OnUpdateAllOperationtableMovetoOperationTable(CCmdUI *pCmdUI)
{
	// TODO:ɃR}hXV UI nh[ R[hǉ܂B
	pCmdUI->Enable(OnAllOperationtableMovetoOperationTable_Process(TRUE) >= 0);
}

void CWndDcdGridAllOperationTable::OnAllOperationtableMovetojikokuhyou()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	OnAllOperationtableMovetojikokuhyou_Process(FALSE);
}


void CWndDcdGridAllOperationTable::OnUpdateAllOperationtableMovetojikokuhyou(CCmdUI *pCmdUI)
{
	// TODO:ɃR}hXV UI nh[ R[hǉ܂B
	pCmdUI->Enable(OnAllOperationtableMovetojikokuhyou_Process(TRUE) >= 0);
}


void CWndDcdGridAllOperationTable::OnAllOperationtableMovetodiagram()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	OnAllOperationtableMovetodiagram_Process(FALSE);
}


void CWndDcdGridAllOperationTable::OnUpdateAllOperationtableMovetodiagram(CCmdUI *pCmdUI)
{
	// TODO:ɃR}hXV UI nh[ R[hǉ܂B
	pCmdUI->Enable(OnAllOperationtableMovetodiagram_Process(TRUE) >= 0);
}

void CWndDcdGridAllOperationTable::OnViewDisplayAllRessya()
{
	OnViewDisplayAllRessya_Process(FALSE);
}

void CWndDcdGridAllOperationTable::OnUpdateViewDisplayAllRessya(CCmdUI* pCmdUI)
{
	int iResult = OnViewDisplayAllRessya_Process(TRUE);
	pCmdUI->Enable(iResult >= 0);
	pCmdUI->SetCheck(iResult >= 1);
}

void CWndDcdGridAllOperationTable::OnViewDisplaySecondEkijikoku()
{
	OnViewDisplaySecondEkijikoku_Process(FALSE);
}

void CWndDcdGridAllOperationTable::OnUpdateViewDisplaySecondEkijikoku(CCmdUI *pCmdUI)
{
	int iResult = OnViewDisplaySecondEkijikoku_Process(TRUE);
	pCmdUI->Enable(iResult >= 0);
	pCmdUI->SetCheck(iResult >= 1);
}

void CWndDcdGridAllOperationTable::OnViewDisplayColonEkijikoku()
{
	OnViewDisplayColonEkijikoku_Process(FALSE);
}

void CWndDcdGridAllOperationTable::OnUpdateViewDisplayColonEkijikoku(CCmdUI *pCmdUI)
{
	int iResult = OnViewDisplayColonEkijikoku_Process(TRUE);
	pCmdUI->Enable(iResult >= 0);
	pCmdUI->SetCheck(iResult >= 1);
}

void CWndDcdGridAllOperationTable::OnViewDisplayParentSyubetsu()
{
	OnViewDisplayParentSyubetsu_Process(FALSE);
}

void CWndDcdGridAllOperationTable::OnUpdateViewDisplayParentSyubetsu(CCmdUI *pCmdUI)
{
	int iResult = OnViewDisplayParentSyubetsu_Process(TRUE);
	pCmdUI->Enable(iResult >= 0);
	pCmdUI->SetCheck(iResult >= 1);
}

void CWndDcdGridAllOperationTable::OnFileExportOperationtablecsv()
{
	OnFileExportOperationTableCsv_Process(FALSE);
}

void CWndDcdGridAllOperationTable::OnFileExportAllOperationtablecsv()
{
	OnFileExportAllOperationTableCsv_Process(FALSE);
}

} //namespace ViewAllOperationTable